2013-03-08  Gabor Rapcsanyi  <rgabor@webkit.org>

        Cache flush problem on ARMv7 JSC
        https://bugs.webkit.org/show_bug.cgi?id=111441

        Reviewed by Zoltan Herczeg.

        Not proper cache flush causing random crashes on ARMv7 Linux with V8 tests.
        The problem is similar to https://bugs.webkit.org/show_bug.cgi?id=77712.
        Change the cache fulsh mechanism similar to ARM traditinal and revert the
        temporary fix.

        * assembler/ARMv7Assembler.h:
        (JSC::ARMv7Assembler::cacheFlush):

2013-03-20  Zoltan Herczeg  <zherczeg@webkit.org>

        ARMv7 replaceWithJump ASSERT failure after r135330.
        https://bugs.webkit.org/show_bug.cgi?id=103146

        Reviewed by Filip Pizlo.

        On Linux, the 24 bit distance range of jumps sometimes does not
        enough to cover all targets addresses. This patch supports jumps
        outside of this range using a mov/movt/bx 10 byte long sequence.

        * assembler/ARMv7Assembler.h:
        (ARMv7Assembler):
        (JSC::ARMv7Assembler::revertJumpTo_movT3movtcmpT2):
        (JSC::ARMv7Assembler::nopw):
        (JSC::ARMv7Assembler::label):
        (JSC::ARMv7Assembler::replaceWithJump):
        (JSC::ARMv7Assembler::maxJumpReplacementSize):
        * assembler/MacroAssemblerARMv7.h:
        (JSC::MacroAssemblerARMv7::revertJumpReplacementToBranchPtrWithPatch):

2013-04-04  Andras Becsi  <andras.becsi@digia.com>

        Fix the build with GCC 4.8
        https://bugs.webkit.org/show_bug.cgi?id=113147

        Reviewed by Allan Sandfeld Jensen.

        Initialize JSObject* exception to suppress warnings that make
        the build fail because of -Werror=maybe-uninitialized.

        * runtime/Executable.cpp:
        (JSC::FunctionExecutable::compileForCallInternal):
        (JSC::FunctionExecutable::compileForConstructInternal):

2013-02-19  Filip Pizlo  <fpizlo@apple.com>

        DFG::SpeculativeJIT::compileInt32ToDouble() has an unnecessary case for constant operands
        https://bugs.webkit.org/show_bug.cgi?id=110309

        Reviewed by Sam Weinig.
        
        It used to be necessary, back when we didn't have constant folding. Now we have
        constant folding. So we don't need it.

        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::compileInt32ToDouble):

2013-02-20  Filip Pizlo  <fpizlo@apple.com>

        DFG inlines Resolves that it doesn't know how to handle correctly
        https://bugs.webkit.org/show_bug.cgi?id=110405

        Reviewed by Geoffrey Garen.
        
        Don't try to be clever: if there's a failing resolve, we can't inline it, period.

        * dfg/DFGCapabilities.h:
        (JSC::DFG::canInlineResolveOperations):
        (JSC::DFG::canInlineOpcode):

2013-02-20  Roger Fong  <roger_fong@apple.com>

        Get VS2010 Solution B&I ready.
        <rdar://problem/1322988>

        Rubberstamped by Timothy Horton.        
        
        Add Production configuration. 
        Add a JavaScriptCore submit solution with a DebugSuffix configuration. 
        Modify JavaScriptCore.make as necessary.
        
        * JavaScriptCore.vcxproj/JavaScriptCore.make: Added.
        * JavaScriptCore.vcxproj/JavaScriptCore.sln: Removed.
        * JavaScriptCore.vcxproj/JavaScriptCore.submit.sln: Copied from Source/JavaScriptCore/JavaScriptCore.vcxproj/JavaScriptCore.sln.
        * JavaScriptCore.vcxproj/JavaScriptCore.vcxproj:
        * JavaScriptCore.vcxproj/JavaScriptCoreCommon.props:
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGenerator.vcxproj:
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGeneratorCommon.props:
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGeneratorPostBuild.cmd:
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGeneratorPreBuild.cmd:
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGeneratorProduction.props: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGeneratorRelease.props:
        * JavaScriptCore.vcxproj/JavaScriptCoreGenerated.vcxproj:
        * JavaScriptCore.vcxproj/JavaScriptCoreGenerated.vcxproj.filters:
        * JavaScriptCore.vcxproj/JavaScriptCoreGeneratedProduction.props: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreGeneratedRelease.props:
        * JavaScriptCore.vcxproj/JavaScriptCoreProduction.props: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreRelease.props:
        * JavaScriptCore.vcxproj/LLInt/LLIntAssembly/LLIntAssembly.vcxproj:
        * JavaScriptCore.vcxproj/LLInt/LLIntDesiredOffsets/LLIntDesiredOffsets.vcxproj:
        * JavaScriptCore.vcxproj/LLInt/LLIntOffsetsExtractor/LLIntOffsetsExtractor.vcxproj:
        * JavaScriptCore.vcxproj/LLInt/LLIntOffsetsExtractor/LLIntOffsetsExtractorCommon.props:
        * JavaScriptCore.vcxproj/LLInt/LLIntOffsetsExtractor/LLIntOffsetsExtractorDebug.props:
        * JavaScriptCore.vcxproj/LLInt/LLIntOffsetsExtractor/LLIntOffsetsExtractorProduction.props: Added.
        * JavaScriptCore.vcxproj/LLInt/LLIntOffsetsExtractor/LLIntOffsetsExtractorRelease.props:
        * JavaScriptCore.vcxproj/jsc/jsc.vcxproj:
        * JavaScriptCore.vcxproj/jsc/jscCommon.props:
        * JavaScriptCore.vcxproj/jsc/jscProduction.props: Added.
        * JavaScriptCore.vcxproj/jsc/jscRelease.props:
        * JavaScriptCore.vcxproj/testRegExp/testRegExp.vcxproj:
        * JavaScriptCore.vcxproj/testRegExp/testRegExpCommon.props:
        * JavaScriptCore.vcxproj/testRegExp/testRegExpProduction.props: Added.
        * JavaScriptCore.vcxproj/testRegExp/testRegExpRelease.props:
        * JavaScriptCore.vcxproj/testapi/testapi.vcxproj:
        * JavaScriptCore.vcxproj/testapi/testapiCommon.props:
        * JavaScriptCore.vcxproj/testapi/testapiProduction.props: Added.
        * JavaScriptCore.vcxproj/testapi/testapiRelease.props:

2013-02-19  Jer Noble  <jer.noble@apple.com>

        EME: Enable both ENCRYPTED_MEDIA and ENCRYPTED_MEDIA_V2 until clients transition to the new API.
        https://bugs.webkit.org/show_bug.cgi?id=110284

        Reviewed by Eric Carlson.

        Re-enable the ENCRYPTED_MEDIA flag.

        * Configurations/FeatureDefines.xcconfig:

2013-02-20  Dirk Schulze  <krit@webkit.org>

        Enable CANVAS_PATH flag
        https://bugs.webkit.org/show_bug.cgi?id=108508

        Reviewed by Simon Fraser.

        Enable CANVAS_PATH flag on trunk.

        Existing tests cover the feature.

        * Configurations/FeatureDefines.xcconfig:

2013-02-19  Mark Rowe  <mrowe@apple.com>

        Unreviewed, uninteresting change to test a theory about bad dependency handling.

        * API/JSStringRefCF.cpp:
        (JSStringCreateWithCFString): Remove an unnecessary else clause.

2013-02-19  Oliver Hunt  <oliver@apple.com>

        Silence some analyzer warnings
        https://bugs.webkit.org/show_bug.cgi?id=110281

        Reviewed by Mark Hahnenberg.

        The static analyzer believes that callerCodeBlock can be null,
        based on other code performing null tests.  This should not
        ever be the case, but we'll add RELEASE_ASSERTs to make it
        obvious if we're ever wrong.

        * interpreter/Interpreter.cpp:
        (JSC::getCallerInfo):

2013-02-19  Oliver Hunt  <oliver@apple.com>

        Don't force everything to be blinded in debug builds
        https://bugs.webkit.org/show_bug.cgi?id=110279

        Reviewed by Mark Hahnenberg.

        Switch to an explicit flag for indicating that we want
        every constant to be blinded.

        * assembler/MacroAssembler.h:
        (JSC::MacroAssembler::shouldBlind):

2013-02-19  Filip Pizlo  <fpizlo@apple.com>

        Fix indentation of Opcode.h

        Rubber stamped by Mark Hahnenberg.

        * bytecode/Opcode.h:

2013-02-19  Filip Pizlo  <fpizlo@apple.com>

        Moved PolymorphicAccessStructureList into its own file.

        Rubber stamped by Mark Hahnenberg.

        * GNUmakefile.list.am:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * bytecode/Instruction.h:
        (JSC):
        * bytecode/PolymorphicAccessStructureList.h: Added.
        (JSC):
        (PolymorphicAccessStructureList):
        (PolymorphicStubInfo):
        (JSC::PolymorphicAccessStructureList::PolymorphicStubInfo::PolymorphicStubInfo):
        (JSC::PolymorphicAccessStructureList::PolymorphicStubInfo::set):
        (JSC::PolymorphicAccessStructureList::PolymorphicAccessStructureList):
        (JSC::PolymorphicAccessStructureList::visitWeak):
        * bytecode/StructureStubInfo.h:

2013-02-19  Filip Pizlo  <fpizlo@apple.com>

        Fix indentation of Instruction.h

        Rubber stamped by Mark Hahnenberg.

        * bytecode/Instruction.h:

2013-02-18  Geoffrey Garen  <ggaren@apple.com>

        Unreviewed, rolling in r143348.
        http://trac.webkit.org/changeset/143348
        https://bugs.webkit.org/show_bug.cgi?id=110242

        The bug was that isEmptyValue() was returning true for the deleted value.
        Fixed this and simplified things further by delegating to m_sourceCode
        for both isNull() and isHashTableDeletedValue(), so they can't be out of
        sync.

        * runtime/CodeCache.cpp:
        (JSC::CodeCache::getFunctionExecutableFromGlobalCode):
        * runtime/CodeCache.h:
        (JSC::SourceCodeKey::SourceCodeKey):
        (JSC::SourceCodeKey::isHashTableDeletedValue):
        (JSC::SourceCodeKey::hash):
        (JSC::SourceCodeKey::length):
        (JSC::SourceCodeKey::isNull):
        (JSC::SourceCodeKey::operator==):
        (SourceCodeKey):

2013-02-15  Martin Robinson  <mrobinson@igalia.com>

        [GTK] Improve gyp build JavaScriptCore code generation
        https://bugs.webkit.org/show_bug.cgi?id=109969

        Reviewed by Dirk Pranke.

        Switch away from using DerivedSources.make when building JavaScriptCore generated
        sources. This bring a couple advantages, such as building the sources in parallel,
        but requires us to list the generated sources more than once.

        * JavaScriptCore.gyp/JavaScriptCoreGTK.gyp: Add rules for generating JavaScriptCore sources.
        * JavaScriptCore.gyp/generate-derived-sources.sh: Added.
        * JavaScriptCore.gyp/redirect-stdout.sh: Added.

2013-02-19  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r143348.
        http://trac.webkit.org/changeset/143348
        https://bugs.webkit.org/show_bug.cgi?id=110242

        "Caused a deleted value sentinel crash on the layout tests"
        (Requested by ggaren on #webkit).

        * runtime/CodeCache.cpp:
        (JSC::CodeCache::getFunctionExecutableFromGlobalCode):
        * runtime/CodeCache.h:
        (JSC::SourceCodeKey::SourceCodeKey):
        (JSC::SourceCodeKey::isHashTableDeletedValue):
        (JSC::SourceCodeKey::hash):
        (JSC::SourceCodeKey::length):
        (JSC::SourceCodeKey::isNull):
        (JSC::SourceCodeKey::operator==):
        (SourceCodeKey):

2013-02-19  Mark Hahnenberg  <mhahnenberg@apple.com>

        HeapBlock::destroy should issue warning if result is unused
        https://bugs.webkit.org/show_bug.cgi?id=110233

        Reviewed by Oliver Hunt.

        To enforce the fact that we need to return blocks to the BlockAllocator after calling destroy, 
        we should add WARN_UNUSED_RETURN to HeapBlock::destroy and any other destroy functions in its subclasses.

        * heap/HeapBlock.h:

2013-02-19  Mark Hahnenberg  <mhahnenberg@apple.com>

        WeakSet::removeAllocator leaks WeakBlocks
        https://bugs.webkit.org/show_bug.cgi?id=110228

        Reviewed by Geoffrey Garen.

        We need to return the WeakBlock to the BlockAllocator after the call to WeakBlock::destroy.

        * heap/WeakSet.cpp:
        (JSC::WeakSet::removeAllocator):

2013-02-18  Geoffrey Garen  <ggaren@apple.com>

        Save space on keys in the CodeCache
        https://bugs.webkit.org/show_bug.cgi?id=110179

        Reviewed by Oliver Hunt.

        Share the SourceProvider's string instead of making our own copy. This
        chops off 16MB - 32MB from the CodeCache's memory footprint when full.
        (It's 16MB when the strings are LChar, and 32MB when they're UChar.)

        * runtime/CodeCache.cpp:
        (JSC::CodeCache::getFunctionExecutableFromGlobalCode):
        * runtime/CodeCache.h: Removed a defunct enum value.

        (JSC::SourceCodeKey::SourceCodeKey):
        (JSC::SourceCodeKey::isHashTableDeletedValue):
        (SourceCodeKey):
        (JSC::SourceCodeKey::hash):
        (JSC::SourceCodeKey::length):
        (JSC::SourceCodeKey::isNull):
        (JSC::SourceCodeKey::string):
        (JSC::SourceCodeKey::operator==): Store a SourceCode instead of a String
        so we can share our string with our SourceProvider. Cache our hash so
        we don't have to re-decode our string just to re-hash the table.

2013-02-19  Zoltan Herczeg  <zherczeg@webkit.org>

        revertBranchPtrWithPatch is incorrect on ARM traditional
        https://bugs.webkit.org/show_bug.cgi?id=110201

        Reviewed by Oliver Hunt.

        Revert two instructions back to their original value.

        * assembler/ARMAssembler.h:
        (JSC::ARMAssembler::revertBranchPtrWithPatch):
        (ARMAssembler):
        * assembler/MacroAssemblerARM.h:
        (JSC::MacroAssemblerARM::branchPtrWithPatch):
        (JSC::MacroAssemblerARM::revertJumpReplacementToBranchPtrWithPatch):

2013-02-19  Filip Pizlo  <fpizlo@apple.com>

        REGRESSION(r143241): It made 27 layout tests crash on 32 bit platforms
        https://bugs.webkit.org/show_bug.cgi?id=110184

        Reviewed by Zoltan Herczeg.
        
        32-bit backend was making all sorts of crazy assumptions, which happened to mostly
        not break things prior to http://trac.webkit.org/changeset/143241. This brings the
        32-bit backend's type speculation fully into compliance with what the 64-bit
        backend does.

        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::checkGeneratedTypeForToInt32):
        (JSC::DFG::SpeculativeJIT::compileValueToInt32):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::fillSpeculateIntInternal):
        (JSC::DFG::SpeculativeJIT::fillSpeculateDouble):
        (JSC::DFG::SpeculativeJIT::fillSpeculateCell):
        (JSC::DFG::SpeculativeJIT::fillSpeculateBoolean):

2013-02-18  Ilya Tikhonovsky  <loislo@chromium.org>

        Unreviewed build fix for Apple Windows. Second stage.
        Add missed export statement.

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCoreExports.def:

2013-02-18  Roger Fong  <roger_fong@apple.com>

        Unreviewed Windows build fix.

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCoreExports.def:
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExports.def.in:

2013-02-18  Darin Adler  <darin@apple.com>

        Remove unneeded explicit function template arguments.
        https://bugs.webkit.org/show_bug.cgi?id=110043

        Reviewed by Ryosuke Niwa.

        * runtime/Identifier.cpp:
        (JSC::IdentifierASCIIStringTranslator::hash): Let the compiler deduce the type
        when calling computeHashAndMaskTop8Bits.
        (JSC::IdentifierLCharFromUCharTranslator::hash): Ditto.
        * runtime/Identifier.h:
        (JSC::IdentifierCharBufferTranslator::hash): Ditto.
2013-02-18  Geoffrey Garen  <ggaren@apple.com>

        Shrank the SourceProvider cache
        https://bugs.webkit.org/show_bug.cgi?id=110158

        Reviewed by Oliver Hunt.

        CodeCache is now our primary source cache, so a long-lived SourceProvider
        cache is a waste. I measured this as a 10MB Membuster win; with more
        precise instrumentation, Andreas estimated it as up to 30MB.

        I didn't eliminate the SourceProvider cache because it's still useful
        in speeding up uncached parsing of scripts with large nested functions
        (i.e., all scripts).

        * heap/Heap.cpp:
        (JSC::Heap::collect): Discard all source provider caches after GC. This
        is a convenient place to do so because it's reasonably soon after initial
        parsing without being immediate.

        * parser/Parser.cpp:
        (JSC::::Parser): Updated for interface change: The heap now owns the
        source provider cache, since most SourceProviders are not expected to
        have one by default, and the heap is responsible for throwing them away.

        (JSC::::parseInner): No need to update statistics on cache size, since
        we're going to throw it away no matter what.

        (JSC::::parseFunctionInfo): Reduced the minimum function size to 16. This
        is a 27% win on a new parsing micro-benchmark I've added. Now that the
        cache is temporary, we don't have to worry so much about its memory
        footprint.

        * parser/Parser.h:
        (Parser): Updated for interface changes.

        * parser/SourceProvider.cpp:
        (JSC::SourceProvider::SourceProvider):
        (JSC::SourceProvider::~SourceProvider):
        * parser/SourceProvider.h:
        (JSC):
        (SourceProvider): SourceProvider doesn't own its cache anymore because
        the cache is temporary.

        * parser/SourceProviderCache.cpp:
        (JSC::SourceProviderCache::clear):
        (JSC::SourceProviderCache::add):
        * parser/SourceProviderCache.h:
        (JSC::SourceProviderCache::SourceProviderCache):
        (SourceProviderCache):
        * parser/SourceProviderCacheItem.h:
        (SourceProviderCacheItem): No need to update statistics on cache size,
        since we're going to throw it away no matter what.

        * runtime/JSGlobalData.cpp:
        (JSC::JSGlobalData::addSourceProviderCache):
        (JSC):
        (JSC::JSGlobalData::clearSourceProviderCaches):
        * runtime/JSGlobalData.h:
        (JSC):
        (JSGlobalData): Moved the cache here so it's easier to throw away.

2013-02-18  Filip Pizlo  <fpizlo@apple.com>

        DFG backend Branch handling has duplicate code and dead code
        https://bugs.webkit.org/show_bug.cgi?id=110162

        Reviewed by Mark Hahnenberg.
        
        Streamline the code, and make the 64 backend's optimizations make more sense
        (i.e. not be dead code).

        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::emitBranch):
        (JSC::DFG::SpeculativeJIT::compile):

2013-02-18  Brent Fulgham  <bfulgham@webkit.org>

        [Windows] Unreviewed VS2010 build correction after r143273.

        * JavaScriptCore.vcxproj/JavaScriptCore.vcxproj: Add missing source
        file SourceProvider.cpp.
        * JavaScriptCore.vcxproj/JavaScriptCore.vcxproj.filters: Ditto.
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExports.def.in: Add missing exports.

2013-02-18  Filip Pizlo  <fpizlo@apple.com>

        Structure::flattenDictionaryStructure should compute max offset in a manner that soundly handles the case where the property list becomes empty
        https://bugs.webkit.org/show_bug.cgi?id=110155
        <rdar://problem/13233773>

        Reviewed by Mark Rowe.
        
        This was a rookie mistake.  It was doing:
        
        for (blah) {
            m_offset = foo // foo's monotonically increase in the loop
        }
        
        as a way of computing max offset for all of the properties.  Except what if the loop doesn't
        execute because there are no properties?  Well, then, you're going to have a bogus m_offset.
        
        The solution is to initialize m_offset at the top of the loop.

        * runtime/Structure.cpp:
        (JSC::Structure::flattenDictionaryStructure):

2013-02-18  Balazs Kilvady  <kilvadyb@homejinni.com>

        MIPS DFG implementation.
        https://bugs.webkit.org/show_bug.cgi?id=101328

        Reviewed by Oliver Hunt.

        DFG implementation for MIPS.

        * assembler/MIPSAssembler.h:
        (JSC::MIPSAssembler::MIPSAssembler):
        (JSC::MIPSAssembler::sllv):
        (JSC::MIPSAssembler::movd):
        (MIPSAssembler):
        (JSC::MIPSAssembler::negd):
        (JSC::MIPSAssembler::labelForWatchpoint):
        (JSC::MIPSAssembler::label):
        (JSC::MIPSAssembler::vmov):
        (JSC::MIPSAssembler::linkDirectJump):
        (JSC::MIPSAssembler::maxJumpReplacementSize):
        (JSC::MIPSAssembler::revertJumpToMove):
        (JSC::MIPSAssembler::replaceWithJump):
        * assembler/MacroAssembler.h:
        (MacroAssembler):
        (JSC::MacroAssembler::poke):
        * assembler/MacroAssemblerMIPS.h:
        (JSC::MacroAssemblerMIPS::add32):
        (MacroAssemblerMIPS):
        (JSC::MacroAssemblerMIPS::and32):
        (JSC::MacroAssemblerMIPS::lshift32):
        (JSC::MacroAssemblerMIPS::mul32):
        (JSC::MacroAssemblerMIPS::or32):
        (JSC::MacroAssemblerMIPS::rshift32):
        (JSC::MacroAssemblerMIPS::urshift32):
        (JSC::MacroAssemblerMIPS::sub32):
        (JSC::MacroAssemblerMIPS::xor32):
        (JSC::MacroAssemblerMIPS::store32):
        (JSC::MacroAssemblerMIPS::jump):
        (JSC::MacroAssemblerMIPS::branchAdd32):
        (JSC::MacroAssemblerMIPS::branchMul32):
        (JSC::MacroAssemblerMIPS::branchSub32):
        (JSC::MacroAssemblerMIPS::branchNeg32):
        (JSC::MacroAssemblerMIPS::call):
        (JSC::MacroAssemblerMIPS::loadDouble):
        (JSC::MacroAssemblerMIPS::moveDouble):
        (JSC::MacroAssemblerMIPS::swapDouble):
        (JSC::MacroAssemblerMIPS::subDouble):
        (JSC::MacroAssemblerMIPS::mulDouble):
        (JSC::MacroAssemblerMIPS::divDouble):
        (JSC::MacroAssemblerMIPS::negateDouble):
        (JSC::MacroAssemblerMIPS::branchEqual):
        (JSC::MacroAssemblerMIPS::branchNotEqual):
        (JSC::MacroAssemblerMIPS::branchTruncateDoubleToInt32):
        (JSC::MacroAssemblerMIPS::branchTruncateDoubleToUint32):
        (JSC::MacroAssemblerMIPS::truncateDoubleToInt32):
        (JSC::MacroAssemblerMIPS::truncateDoubleToUint32):
        (JSC::MacroAssemblerMIPS::branchDoubleNonZero):
        (JSC::MacroAssemblerMIPS::branchDoubleZeroOrNaN):
        (JSC::MacroAssemblerMIPS::invert):
        (JSC::MacroAssemblerMIPS::replaceWithJump):
        (JSC::MacroAssemblerMIPS::maxJumpReplacementSize):
        * dfg/DFGAssemblyHelpers.h:
        (AssemblyHelpers):
        (JSC::DFG::AssemblyHelpers::preserveReturnAddressAfterCall):
        (JSC::DFG::AssemblyHelpers::restoreReturnAddressBeforeReturn):
        (JSC::DFG::AssemblyHelpers::debugCall):
        * dfg/DFGCCallHelpers.h:
        (CCallHelpers):
        (JSC::DFG::CCallHelpers::setupArguments):
        (JSC::DFG::CCallHelpers::setupArgumentsWithExecState):
        * dfg/DFGFPRInfo.h:
        (DFG):
        (FPRInfo):
        (JSC::DFG::FPRInfo::toRegister):
        (JSC::DFG::FPRInfo::toIndex):
        (JSC::DFG::FPRInfo::debugName):
        * dfg/DFGGPRInfo.h:
        (DFG):
        (GPRInfo):
        (JSC::DFG::GPRInfo::toRegister):
        (JSC::DFG::GPRInfo::toIndex):
        (JSC::DFG::GPRInfo::debugName):
        * dfg/DFGSpeculativeJIT.h:
        (SpeculativeJIT):
        * jit/JSInterfaceJIT.h:
        (JSInterfaceJIT):
        * runtime/JSGlobalData.h:
        (JSC::ScratchBuffer::allocationSize):
        (ScratchBuffer):

2013-02-18  Filip Pizlo  <fpizlo@apple.com>

        DFG::SpeculativeJIT::isKnownXYZ methods should use CFA rather than other things
        https://bugs.webkit.org/show_bug.cgi?id=110092

        Reviewed by Geoffrey Garen.
        
        These methods were previously using GenerationInfo and other things to try to
        gain information that the CFA could give away for free, if you asked kindly
        enough.
        
        Also fixed CallLinkStatus's dump() method since it was making an invalid
        assertion: we most certainly can have a status where the structure is non-null
        and the executable is null, like if we're dealing with an InternalFunction.
        
        Also removed calls to isKnownNotXYZ from fillSpeculateABC methods in 32_64. I
        don't know why that was there. But it was causing asserts if the value was
        empty - i.e. we had already exited unconditionally but we didn't know it. I
        could have fixed this by introducing another form of isKnownNotXYZ which was
        tolerant of empty values, but I didn't feel like fixing code that I knew to be
        unnecessary. (More deeply, isKnownNotCell, for example, really asks: "do you
        know that this value can never be a cell?" while some of the previous uses
        wanted to ask: "do you know that this is a value that is not a cell?". The
        former is "true" if the value is a contradiction [i.e. BOTTOM], while the
        latter is "false" for contradictions, since contradictions are not values.)

        * bytecode/CallLinkStatus.cpp:
        (JSC::CallLinkStatus::dump):
        * bytecode/CallLinkStatus.h:
        (JSC::CallLinkStatus::CallLinkStatus):
        * dfg/DFGSpeculativeJIT.cpp:
        (DFG):
        * dfg/DFGSpeculativeJIT.h:
        (JSC::DFG::SpeculativeJIT::isKnownInteger):
        (JSC::DFG::SpeculativeJIT::isKnownCell):
        (JSC::DFG::SpeculativeJIT::isKnownNotInteger):
        (JSC::DFG::SpeculativeJIT::isKnownNotNumber):
        (JSC::DFG::SpeculativeJIT::isKnownNotCell):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::fillSpeculateIntInternal):
        (JSC::DFG::SpeculativeJIT::fillSpeculateDouble):
        (JSC::DFG::SpeculativeJIT::fillSpeculateCell):
        * dfg/DFGStructureAbstractValue.h:
        (JSC::DFG::StructureAbstractValue::dump):

2013-02-17  Filip Pizlo  <fpizlo@apple.com>

        Get rid of DFG::DoubleOperand and simplify ValueToInt32
        https://bugs.webkit.org/show_bug.cgi?id=110072

        Reviewed by Geoffrey Garen.
        
        ValueToInt32 had a side-effecting path, which was not OSR-friendly: an OSR after
        the side-effect would lead to the side-effect re-executing. I got rid of that path
        and replaced it with an optimization for the case where the input is speculated
        number-or-other. This makes idioms like null|0 and true|0 work as expected, and
        get optimized appropriately.
        
        Also got rid of DoubleOperand. Replaced all remaining uses of it with
        SpeculateDoubleOperand. Because the latter asserts that the Edge is a DoubleUse
        edge and the remaining uses of DoubleOperand are all for untyped uses, I worked
        around the assertion by setting the UseKind to DoubleUse by force. This is sound,
        since all existing assertions for DoubleUse are actually asserting that we're not
        converting a value to double unexpectedly. But all of these calls to
        SpeculateDoubleOperand are when the operand is already known to be represented as
        double, so there is no conversion.
        
        This is neutral on benchmarks, except stanford-crypto-ccm, which speeds up a
        little. Mostly, this is intended to delete a bunch of code. DoubleOperand was
        equivalent to the replace-edge-with-DoubleUse trick that I'm using now, except it
        involved a _lot_ more code.

        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::execute):
        * dfg/DFGCSEPhase.cpp:
        (JSC::DFG::CSEPhase::performNodeCSE):
        * dfg/DFGFixupPhase.cpp:
        (JSC::DFG::FixupPhase::fixupNode):
        * dfg/DFGNodeType.h:
        (DFG):
        * dfg/DFGSpeculativeJIT.cpp:
        (DFG):
        (JSC::DFG::SpeculativeJIT::compileValueToInt32):
        * dfg/DFGSpeculativeJIT.h:
        (SpeculativeJIT):
        (DFG):
        (FPRTemporary):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (DFG):
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGSpeculativeJIT64.cpp:
        (DFG):

2013-02-18  Ádám Kallai  <kadam@inf.u-szeged.hu>

        [Qt] Mountain Lion buildfix after r143147.

        Reviewed by Csaba Osztrogonác.

        * runtime/DateConstructor.cpp:

2013-02-18  Zan Dobersek  <zdobersek@igalia.com>

        Stop placing std::isfinite and std::signbit inside the global scope
        https://bugs.webkit.org/show_bug.cgi?id=109817

        Reviewed by Darin Adler.

        Prefix calls to the isfinite and signbit methods with std:: as the two
        methods are no longer being imported into the global scope.

        * assembler/MacroAssembler.h:
        (JSC::MacroAssembler::shouldBlindDouble):
        * offlineasm/cloop.rb:
        * runtime/BigInteger.h:
        (JSC::BigInteger::BigInteger):
        * runtime/DateConstructor.cpp:
        (JSC::constructDate):
        * runtime/DatePrototype.cpp:
        (JSC::fillStructuresUsingTimeArgs):
        (JSC::fillStructuresUsingDateArgs):
        (JSC::dateProtoFuncToISOString):
        (JSC::dateProtoFuncSetYear):
        * runtime/JSCJSValueInlines.h:
        (JSC::JSValue::JSValue):
        * runtime/JSGlobalObjectFunctions.cpp:
        (JSC::globalFuncIsFinite):
        * runtime/JSONObject.cpp:
        (JSC::Stringifier::appendStringifiedValue):
        * runtime/MathObject.cpp:
        (JSC::mathProtoFuncMax): Also include an opportunistic style fix.
        (JSC::mathProtoFuncMin): Ditto.
        * runtime/NumberPrototype.cpp:
        (JSC::toStringWithRadix):
        (JSC::numberProtoFuncToExponential):
        (JSC::numberProtoFuncToFixed):
        (JSC::numberProtoFuncToPrecision):
        (JSC::numberProtoFuncToString):
        * runtime/Uint16WithFraction.h:
        (JSC::Uint16WithFraction::Uint16WithFraction):

2013-02-18  Ádám Kallai  <kadam@inf.u-szeged.hu>

        [Qt] Mountain Lion buildfix after r143147.

        Reviewed by Csaba Osztrogonác.

        * runtime/DateInstance.cpp:

2013-02-18  Ilya Tikhonovsky  <loislo@chromium.org>

        Unreviewed speculative build fix for Apple Win bots.

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCoreExports.def:

2013-02-18  Filip Pizlo  <fpizlo@apple.com>

        Fix indentation of StructureStubInfo.h

        Rubber stamped by Mark Hahnenberg.

        * bytecode/StructureStubInfo.h:

2013-02-18  Filip Pizlo  <fpizlo@apple.com>

        Fix indentation of JSGlobalObject.h and JSGlobalObjectFunctions.h

        Rubber stamped by Mark Hahnenberg.

        * runtime/JSGlobalObject.h:
        * runtime/JSGlobalObjectFunctions.h:

2013-02-18  Filip Pizlo  <fpizlo@apple.com>

        Fix indention of Operations.h

        Rubber stamped by Mark Hahnenberg.

        * runtime/Operations.h:

2013-02-18  Filip Pizlo  <fpizlo@apple.com>

        Remove DFG::SpeculativeJIT::isKnownNumeric(), since it's not called from anywhere.

        Rubber stamped by Andy Estes.

        * dfg/DFGSpeculativeJIT.cpp:
        (DFG):
        * dfg/DFGSpeculativeJIT.h:
        (SpeculativeJIT):

2013-02-18  Filip Pizlo  <fpizlo@apple.com>

        Remove DFG::SpeculativeJIT::isStrictInt32(), since it's not called from anywhere.

        Rubber stampted by Andy Estes.

        * dfg/DFGSpeculativeJIT.cpp:
        (DFG):
        * dfg/DFGSpeculativeJIT.h:
        (SpeculativeJIT):

2013-02-18  Filip Pizlo  <fpizlo@apple.com>

        Remove dead code for ValueToNumber from the DFG.

        Rubber stamped by Andy Estes.
        
        We killed ValueToNumber at some point, but forgot to kill all of the backend support
        for it.

        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::handleMinMax):
        * dfg/DFGOperations.cpp:
        * dfg/DFGOperations.h:
        * dfg/DFGSpeculativeJIT.h:
        (SpeculativeJIT):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        * dfg/DFGSpeculativeJIT64.cpp:

2013-02-17  Csaba Osztrogonác  <ossy@webkit.org>

        Unreviewed buildfix for JSVALUE32_64 builds after r143147.

        * jit/JIT.h:

2013-02-17  Filip Pizlo  <fpizlo@apple.com>

        Move all Structure out-of-line inline methods to StructureInlines.h
        https://bugs.webkit.org/show_bug.cgi?id=110024

        Rubber stamped by Mark Hahnenberg and Sam Weinig.
        
        This was supposed to be easy.
        
        But, initially, there was a Structure inline method in CodeBlock.h, and moving that
        into StructureInlines.h meant that Operations.h included CodeBlock.h. This would
        cause WebCore build failures, because CodeBlock.h transitively included the JSC
        parser (via many, many paths), and the JSC parser defines tokens using enumeration
        elements that CSSGrammar.cpp (generated by bison) would #define. For example,
        bison would give CSSGrammar.cpp a #define FUNCTION 123, and would do so before
        including anything interesting. The JSC parser would have an enum that included
        FUNCTION as an element. Hence the JSC parser included into CSSGrammar.cpp would have
        a token element called FUNCTION declared in an enumeration, but FUNCTION was
        #define'd to 123, leading to a parser error.
        
        Wow.
        
        So I removed all transitive include paths from CodeBlock.h to the JSC Parser. I
        believe I was able to do so without out-of-lining anything interesting or performance
        critical. This is probably a purely good thing to have done: it will be nice to be
        able to make changes to the parser without having to compile the universe.
        
        Of course, doing this caused a bunch of other things to not compile, since a bunch of
        headers relied on things being implicitly included for them when they transitively
        included the parser. I fixed a lot of that.
        
        Finally, I ended up removing the method that depended on CodeBlock.h from
        StructureInlines.h, and putting it in Structure.cpp. That might seem like all of this
        was a waste of time, except that I suspect it was a worthwhile forcing function for
        cleaning up a bunch of cruft.
        
        * API/JSCallbackFunction.cpp:
        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * Target.pri:
        * bytecode/CodeBlock.h:
        (JSC):
        * bytecode/EvalCodeCache.h:
        * bytecode/SamplingTool.h:
        * bytecode/UnlinkedCodeBlock.cpp:
        (JSC::UnlinkedFunctionExecutable::parameterCount):
        (JSC):
        * bytecode/UnlinkedCodeBlock.h:
        (UnlinkedFunctionExecutable):
        * bytecompiler/BytecodeGenerator.h:
        * bytecompiler/Label.h:
        (JSC):
        * dfg/DFGByteCodeParser.cpp:
        * dfg/DFGByteCodeParser.h:
        * dfg/DFGFPRInfo.h:
        * dfg/DFGRegisterBank.h:
        * heap/HandleStack.cpp:
        * jit/JITWriteBarrier.h:
        * parser/Nodes.h:
        (JSC):
        * parser/Parser.h:
        * parser/ParserError.h: Added.
        (JSC):
        (JSC::ParserError::ParserError):
        (ParserError):
        (JSC::ParserError::toErrorObject):
        * parser/ParserModes.h:
        * parser/SourceProvider.cpp: Added.
        (JSC):
        (JSC::SourceProvider::SourceProvider):
        (JSC::SourceProvider::~SourceProvider):
        * parser/SourceProvider.h:
        (JSC):
        (SourceProvider):
        * runtime/ArrayPrototype.cpp:
        * runtime/DatePrototype.cpp:
        * runtime/Executable.h:
        * runtime/JSGlobalObject.cpp:
        * runtime/JSGlobalObject.h:
        (JSC):
        * runtime/Operations.h:
        * runtime/Structure.cpp:
        (JSC::Structure::prototypeForLookup):
        (JSC):
        * runtime/Structure.h:
        (JSC):
        * runtime/StructureInlines.h: Added.
        (JSC):
        (JSC::Structure::create):
        (JSC::Structure::createStructure):
        (JSC::Structure::get):
        (JSC::Structure::masqueradesAsUndefined):
        (JSC::SlotVisitor::internalAppend):
        (JSC::Structure::transitivelyTransitionedFrom):
        (JSC::Structure::setEnumerationCache):
        (JSC::Structure::enumerationCache):
        (JSC::Structure::prototypeForLookup):
        (JSC::Structure::prototypeChain):
        (JSC::Structure::isValid):
        * runtime/StructureRareData.cpp:

2013-02-17  Roger Fong  <roger_fong@apple.com>

        Unreviewed. Windows build fix.

        * runtime/CodeCache.h:
        (CodeCacheMap):

2013-02-16  Geoffrey Garen  <ggaren@apple.com>

        Code cache should be explicit about what it caches
        https://bugs.webkit.org/show_bug.cgi?id=110039

        Reviewed by Oliver Hunt.

        This patch makes the code cache more explicit in two ways:

        (1) The cache caches top-level scripts. Any sub-functions executed as a
        part of a script are cached with it and evicted with it.

        This simplifies things by eliminating out-of-band sub-function tracking,
        and fixes pathological cases where functions for live scripts would be
        evicted in favor of functions for dead scripts, and/or high probability
        functions executed early in script lifetime would be evicted in favor of
        low probability functions executed late in script lifetime, due to LRU.

        Statistical data from general browsing and PLT confirms that caching
        functions independently of scripts is not profitable.

        (2) The cache tracks script size, not script count.

        This reduces the worst-case cache size by a factor of infinity.

        Script size is a reasonable first-order estimate of in-memory footprint 
        for a cached script because there are no syntactic constructs that have
        super-linear memory footprint.

        * bytecode/UnlinkedCodeBlock.cpp:
        (JSC::generateFunctionCodeBlock): Moved this function out of the cache
        because it does not consult the cache, and is not managed by it.

        (JSC::UnlinkedFunctionExecutable::visitChildren): Visit our code blocks
        because they are strong references now, rather than weak, a la (1).

        (JSC::UnlinkedFunctionExecutable::codeBlockFor): Updated for interface changes.

        * bytecode/UnlinkedCodeBlock.h:
        (UnlinkedFunctionExecutable):
        (UnlinkedFunctionCodeBlock): Strong now, not weak, a la (1).

        * runtime/CodeCache.cpp:
        (JSC::CodeCache::CodeCache):
        * runtime/CodeCache.h:
        (JSC::SourceCodeKey::length):
        (SourceCodeKey):
        (CodeCacheMap):
        (JSC::CodeCacheMap::CodeCacheMap):
        (JSC::CodeCacheMap::find):
        (JSC::CodeCacheMap::set):
        (JSC::CodeCacheMap::clear):
        (CodeCache):
        (JSC::CodeCache::clear): Removed individual function tracking, due to (1).
        Added explicit character counting, for (2).

        You might think 16000000 characters is a lot. It is. But this patch
        didn't establish that limit -- it just took the existing limit and
        made it more visible. I intend to reduce the size of the cache in a
        future patch.

2013-02-16  Filip Pizlo  <fpizlo@apple.com>

        Remove support for bytecode comments, since it doesn't build, and hasn't been used in a while.
        https://bugs.webkit.org/show_bug.cgi?id=110035

        Rubber stamped by Andreas Kling.
        
        There are other ways of achieving the same effect, like adding print statements to the bytecode generator.
        The fact that this feature doesn't build and nobody noticed implies that it's probably not a popular
        feature. As well, the amount of wiring that was required for it was quite big considering its relatively
        modest utility.

        * GNUmakefile.list.am:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * bytecode/CodeBlock.cpp:
        (JSC):
        (JSC::CodeBlock::dumpBytecode):
        (JSC::CodeBlock::CodeBlock):
        * bytecode/CodeBlock.h:
        (CodeBlock):
        * bytecode/Comment.h: Removed.
        * bytecompiler/BytecodeGenerator.cpp:
        (JSC::BytecodeGenerator::BytecodeGenerator):
        (JSC::BytecodeGenerator::emitOpcode):
        (JSC):
        * bytecompiler/BytecodeGenerator.h:
        (BytecodeGenerator):
        (JSC::BytecodeGenerator::symbolTable):

2013-02-16  Brent Fulgham  <bfulgham@webkit.org>

        [Windows] Unreviewed Visual Studio 2010 build fix after r143117

        * JavaScriptCore.vcxproj/LLInt/LLIntOffsetsExtractor/LLIntOffsetsExtractorDebug.props: Reference new path to property sheets.
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExports.def.in:
        Build correction after new operator == added.

2013-02-16  Filip Pizlo  <fpizlo@apple.com>

        Fix indentation of Structure.h

        Rubber stamped by Mark Hahnenberg.

        * runtime/Structure.h:

2013-02-16  Christophe Dumez  <ch.dumez@sisa.samsung.com>

        Unreviewed build fix.

        Export symbol for new CString operator== operator to fix Windows build.

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCoreExports.def:

2013-02-15  Filip Pizlo  <fpizlo@apple.com>

        Structure should be more methodical about the relationship between m_offset and m_propertyTable
        https://bugs.webkit.org/show_bug.cgi?id=109978

        Reviewed by Mark Hahnenberg.
        
        Allegedly, the previous relationship was that either m_propertyTable or m_offset
        would be set, and if m_propertyTable was not set you could rebuild it.  In reality,
        we would sometimes "reset" both: some transitions wouldn't set m_offset, and other
        transitions would clear the previous structure's m_propertyTable.  So, in a
        structure transition chain of A->B->C you could have:

        A transitions to B: B doesn't copy m_offset but does copy m_propertyTable, because
            that seemed like a good idea at the time (this was a common idiom in the code).
        B transitions to C: C steals B's m_propertyTable, leaving B with neither a
            m_propertyTable nor a m_offset.

        Then we would ask for the size of the property storage of B and get the answer
        "none".  That's not good.

        Now, there is a new relationship, which, hopefully, should fix things: m_offset is
        always set and always refers to the maximum offset ever used by the property table.
        From this, you can infer both the inline and out-of-line property size, and
        capacity.  This is accomplished by having PropertyTable::add() take a
        PropertyOffset reference, which must be Structure::m_offset.  It will update this
        offset.  As well, all transitions now copy m_offset.  And we frequently assert
        (using RELEASE_ASSERT) that the m_offset matches what m_propertyTable would tell
        you.  Hence if you ever modify the m_propertyTable, you'll also update the offset.
        If you ever copy the property table, you'll also copy the offset.  Life should be
        good, I think.

        * runtime/PropertyMapHashTable.h:
        (JSC::PropertyTable::add):
        * runtime/Structure.cpp:
        (JSC::Structure::materializePropertyMap):
        (JSC::Structure::addPropertyTransition):
        (JSC::Structure::removePropertyTransition):
        (JSC::Structure::changePrototypeTransition):
        (JSC::Structure::despecifyFunctionTransition):
        (JSC::Structure::attributeChangeTransition):
        (JSC::Structure::toDictionaryTransition):
        (JSC::Structure::sealTransition):
        (JSC::Structure::freezeTransition):
        (JSC::Structure::preventExtensionsTransition):
        (JSC::Structure::nonPropertyTransition):
        (JSC::Structure::flattenDictionaryStructure):
        (JSC::Structure::checkConsistency):
        (JSC::Structure::putSpecificValue):
        (JSC::Structure::createPropertyMap):
        (JSC::PropertyTable::checkConsistency):
        * runtime/Structure.h:
        (JSC):
        (JSC::Structure::putWillGrowOutOfLineStorage):
        (JSC::Structure::outOfLineCapacity):
        (JSC::Structure::outOfLineSize):
        (JSC::Structure::isEmpty):
        (JSC::Structure::materializePropertyMapIfNecessary):
        (JSC::Structure::materializePropertyMapIfNecessaryForPinning):
        (Structure):
        (JSC::Structure::checkOffsetConsistency):

2013-02-15  Martin Robinson  <mrobinson@igalia.com>

        [GTK] Spread the gyp build files throughout the tree
        https://bugs.webkit.org/show_bug.cgi?id=109960

        Reviewed by Dirk Pranke.

        * JavaScriptCore.gyp/JavaScriptCoreGTK.gyp: Renamed from Source/WebKit/gtk/gyp/JavaScriptCore.gyp.
        * JavaScriptCore.gyp/generate-derived-sources.sh: Renamed from Source/WebKit/gtk/gyp/generate-derived-sources.sh.

2013-02-15  Filip Pizlo  <fpizlo@apple.com>

        DFG SpeculativeJIT64 should be more precise about when it's dealing with a cell (even though it probably doesn't matter)
        https://bugs.webkit.org/show_bug.cgi?id=109625

        Reviewed by Mark Hahnenberg.

        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::compileObjectEquality):
        (JSC::DFG::SpeculativeJIT::compileObjectToObjectOrOtherEquality):
        (JSC::DFG::SpeculativeJIT::compilePeepHoleObjectToObjectOrOtherEquality):
        (JSC::DFG::SpeculativeJIT::compile):

2013-02-15  Geoffrey Garen  <ggaren@apple.com>

        Merged the global function cache into the source code cache
        https://bugs.webkit.org/show_bug.cgi?id=108660

        Reviewed by Sam Weinig.

        Responding to review comments by Darin Adler.

        * runtime/CodeCache.h:
        (JSC::SourceCodeKey::SourceCodeKey): Don't initialize m_name and m_flags
        in the hash table deleted value because they're meaningless.

2013-02-14  Filip Pizlo  <fpizlo@apple.com>

        DFG AbstractState should filter operands to NewArray more precisely
        https://bugs.webkit.org/show_bug.cgi?id=109900

        Reviewed by Mark Hahnenberg.
        
        NewArray for primitive indexing types speculates that the inputs are the appropriate
        primitives. Now, the CFA filters the abstract state accordingly, as well.

        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::execute):

2013-02-15  Andreas Kling  <akling@apple.com>

        Yarr: Use OwnPtr to make pattern/disjunction/character-class ownership clearer.
        <http://webkit.org/b/109218>

        Reviewed by Benjamin Poulain.

        - Let classes that manage lifetime of other objects hold on to them with OwnPtr instead of raw pointers.
        - Placed some strategic Vector::shrinkToFit(), ::reserveInitialCapacity() and ::swap().

        668 kB progression on Membuster3.

        * yarr/YarrInterpreter.cpp:
        (JSC::Yarr::ByteCompiler::atomParenthesesSubpatternEnd):
        (JSC::Yarr::ByteCompiler::emitDisjunction):
        (ByteCompiler):
        * yarr/YarrInterpreter.h:
        (JSC::Yarr::BytecodePattern::BytecodePattern):
        (BytecodePattern):
        * yarr/YarrJIT.cpp:
        (JSC::Yarr::YarrGenerator::opCompileParenthesesSubpattern):
        (JSC::Yarr::YarrGenerator::opCompileParentheticalAssertion):
        (JSC::Yarr::YarrGenerator::opCompileBody):
        * yarr/YarrPattern.cpp:
        (JSC::Yarr::CharacterClassConstructor::charClass):
        (JSC::Yarr::YarrPatternConstructor::YarrPatternConstructor):
        (JSC::Yarr::YarrPatternConstructor::reset):
        (JSC::Yarr::YarrPatternConstructor::atomPatternCharacter):
        (JSC::Yarr::YarrPatternConstructor::atomCharacterClassEnd):
        (JSC::Yarr::YarrPatternConstructor::copyDisjunction):
        (JSC::Yarr::YarrPatternConstructor::setupDisjunctionOffsets):
        (JSC::Yarr::YarrPatternConstructor::checkForTerminalParentheses):
        (JSC::Yarr::YarrPatternConstructor::optimizeBOL):
        (JSC::Yarr::YarrPatternConstructor::containsCapturingTerms):
        (JSC::Yarr::YarrPatternConstructor::optimizeDotStarWrappedExpressions):
        * yarr/YarrPattern.h:
        (JSC::Yarr::PatternDisjunction::addNewAlternative):
        (PatternDisjunction):
        (YarrPattern):
        (JSC::Yarr::YarrPattern::reset):
        (JSC::Yarr::YarrPattern::newlineCharacterClass):
        (JSC::Yarr::YarrPattern::digitsCharacterClass):
        (JSC::Yarr::YarrPattern::spacesCharacterClass):
        (JSC::Yarr::YarrPattern::wordcharCharacterClass):
        (JSC::Yarr::YarrPattern::nondigitsCharacterClass):
        (JSC::Yarr::YarrPattern::nonspacesCharacterClass):
        (JSC::Yarr::YarrPattern::nonwordcharCharacterClass):

2013-02-14  Geoffrey Garen  <ggaren@apple.com>

        Merged the global function cache into the source code cache
        https://bugs.webkit.org/show_bug.cgi?id=108660

        Reviewed by Sam Weinig.

        This has a few benefits:

            (*) Saves a few kB by removing a second cache data structure.

            (*) Reduces the worst case memory usage of the cache by 1.75X. (Heavy
            use of 'new Function' and other techniques could cause us to fill
            both root caches, and they didn't trade off against each other.)

            (*) Paves the way for future improvements based on a non-trivial
            cache key (for example, shrinkable pointer to the key string, and
            more precise cache size accounting).

        Also cleaned up the cache implementation and simplified it a bit.

        * heap/Handle.h:
        (HandleBase):
        * heap/Strong.h:
        (Strong): Build!

        * runtime/CodeCache.cpp:
        (JSC):
        (JSC::CodeCache::getCodeBlock):
        (JSC::CodeCache::generateFunctionCodeBlock):
        (JSC::CodeCache::getFunctionExecutableFromGlobalCode):
        (JSC::CodeCache::usedFunctionCode): Updated for three interface changes:

            (*) SourceCodeKey is a class, not a pair.

            (*) Table values are abstract pointers, since they can be executables
            or code blocks. (In a future patch, I'd like to change this so we
            always store only code blocks. But that's too much for one patch.)

            (*) The cache function is named "set" because it always overwrites
            unconditionally.

        * runtime/CodeCache.h:
        (CacheMap):
        (JSC::CacheMap::find):
        (JSC::CacheMap::set):
        (JSC::CacheMap::clear): Added support for specifying hash traits, so we
        can use a SourceCodeKey.

        Removed side table and random number generator to save space and reduce
        complexity. Hash tables are already random, so we don't need another source
        of randomness.

        (SourceCodeKey):
        (JSC::SourceCodeKey::SourceCodeKey):
        (JSC::SourceCodeKey::isHashTableDeletedValue):
        (JSC::SourceCodeKey::hash):
        (JSC::SourceCodeKey::isNull):
        (JSC::SourceCodeKey::operator==):
        (JSC::SourceCodeKeyHash::hash):
        (JSC::SourceCodeKeyHash::equal):
        (SourceCodeKeyHash):
        (SourceCodeKeyHashTraits):
        (JSC::SourceCodeKeyHashTraits::isEmptyValue): A SourceCodeKey is just a
        fancy triplet: source code string; function name (or null, for non-functions);
        and flags. Flags and function name distinguish between functions and programs
        with identical code, so they can live in the same cache.

        I chose to use the source code string as the primary hashing reference
        because it's likely to be unique. We can use profiling to choose another
        technique in future, if collisions between functions and programs prove
        to be hot. I suspect they won't.

        (JSC::CodeCache::clear):
        (CodeCache): Removed the second cache.

        * heap/Handle.h:
        (HandleBase):
        * heap/Strong.h:
        (Strong):
        * runtime/CodeCache.cpp:
        (JSC):
        (JSC::CodeCache::getCodeBlock):
        (JSC::CodeCache::generateFunctionCodeBlock):
        (JSC::CodeCache::getFunctionExecutableFromGlobalCode):
        (JSC::CodeCache::usedFunctionCode):
        * runtime/CodeCache.h:
        (JSC):
        (CacheMap):
        (JSC::CacheMap::find):
        (JSC::CacheMap::set):
        (JSC::CacheMap::clear):
        (SourceCodeKey):
        (JSC::SourceCodeKey::SourceCodeKey):
        (JSC::SourceCodeKey::isHashTableDeletedValue):
        (JSC::SourceCodeKey::hash):
        (JSC::SourceCodeKey::isNull):
        (JSC::SourceCodeKey::operator==):
        (JSC::SourceCodeKeyHash::hash):
        (JSC::SourceCodeKeyHash::equal):
        (SourceCodeKeyHash):
        (SourceCodeKeyHashTraits):
        (JSC::SourceCodeKeyHashTraits::isEmptyValue):
        (JSC::CodeCache::clear):
        (CodeCache):

2013-02-14  Tony Chang  <tony@chromium.org>

        Unreviewed, set svn:eol-style native for .sln, .vcproj, and .vsprops files.
        https://bugs.webkit.org/show_bug.cgi?id=96934

        * JavaScriptCore.vcproj/JavaScriptCore.sln: Modified property svn:eol-style.
        * JavaScriptCore.vcproj/JavaScriptCoreSubmit.sln: Modified property svn:eol-style.
        * JavaScriptCore.vcproj/testRegExp/testRegExpCommon.vsprops: Added property svn:eol-style.
        * JavaScriptCore.vcproj/testRegExp/testRegExpDebug.vsprops: Added property svn:eol-style.
        * JavaScriptCore.vcproj/testRegExp/testRegExpDebugAll.vsprops: Added property svn:eol-style.
        * JavaScriptCore.vcproj/testRegExp/testRegExpDebugCairoCFLite.vsprops: Added property svn:eol-style.
        * JavaScriptCore.vcproj/testRegExp/testRegExpProduction.vsprops: Added property svn:eol-style.
        * JavaScriptCore.vcproj/testRegExp/testRegExpRelease.vsprops: Added property svn:eol-style.
        * JavaScriptCore.vcproj/testRegExp/testRegExpReleaseCairoCFLite.vsprops: Added property svn:eol-style.
        * JavaScriptCore.vcproj/testRegExp/testRegExpReleasePGO.vsprops: Added property svn:eol-style.

2013-02-14  Tony Chang  <tony@chromium.org>

        Unreviewed, set svn:eol-style CRLF for .sln files.

        * JavaScriptCore.vcproj/JavaScriptCore.sln: Modified property svn:eol-style.
        * JavaScriptCore.vcproj/JavaScriptCoreSubmit.sln: Modified property svn:eol-style.

2013-02-14  David Kilzer  <ddkilzer@apple.com>

        [Mac] Clean up WARNING_CFLAGS
        <http://webkit.org/b/109747>
        <rdar://problem/13208373>

        Reviewed by Mark Rowe.

        * Configurations/Base.xcconfig: Use
        GCC_WARN_64_TO_32_BIT_CONVERSION to enable and disable
        -Wshorten-64-to-32 rather than WARNING_CFLAGS.

        * JavaScriptCore.vcproj/JavaScriptCore.sln: Modified property svn:eol-style.
        * JavaScriptCore.vcproj/JavaScriptCoreSubmit.sln: Modified property svn:eol-style.

2013-02-13  Anders Carlsson  <andersca@apple.com>

        Better build fix.

        * API/tests/testapi.c:
        (assertEqualsAsNumber):
        (main):

2013-02-13  Roger Fong  <roger_fong@apple.com>

        Unreviewed. Build fix.

        * API/tests/testapi.c:
        (assertEqualsAsNumber):
        (main):

2013-02-13  Oliver Hunt  <oliver@apple.com>

        Yet another build fix

        * bytecode/CodeBlock.cpp:
        (JSC::CodeBlock::CodeBlock):

2013-02-13  Zan Dobersek  <zdobersek@igalia.com>

        The 'global isinf/isnan' compiler quirk required when using clang with libstdc++
        https://bugs.webkit.org/show_bug.cgi?id=109325

        Reviewed by Anders Carlsson.

        Prefix calls to the isinf and isnan methods with std::, declaring we want to use the
        two methods as they're provided by the C++ standard library being used.

        * API/JSValueRef.cpp:
        (JSValueMakeNumber):
        * JSCTypedArrayStubs.h:
        (JSC):
        * bytecompiler/BytecodeGenerator.cpp:
        (JSC::BytecodeGenerator::emitLoad):
        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::constantNaN):
        * offlineasm/cloop.rb:
        * runtime/DateConstructor.cpp:
        (JSC::dateUTC): Also include an opportunistic style fix.
        * runtime/DateInstance.cpp:
        (JSC::DateInstance::calculateGregorianDateTime):
        (JSC::DateInstance::calculateGregorianDateTimeUTC):
        * runtime/DatePrototype.cpp:
        (JSC::dateProtoFuncGetMilliSeconds):
        (JSC::dateProtoFuncGetUTCMilliseconds):
        (JSC::setNewValueFromTimeArgs):
        (JSC::setNewValueFromDateArgs):
        (JSC::dateProtoFuncSetYear):
        * runtime/JSCJSValue.cpp:
        (JSC::JSValue::toInteger):
        * runtime/JSDateMath.cpp:
        (JSC::getUTCOffset):
        (JSC::parseDateFromNullTerminatedCharacters):
        (JSC::parseDate):
        * runtime/JSGlobalObjectFunctions.cpp:
        (JSC::globalFuncIsNaN):
        * runtime/MathObject.cpp:
        (JSC::mathProtoFuncMax):
        (JSC::mathProtoFuncMin):
        (JSC::mathProtoFuncPow):
        * runtime/PropertyDescriptor.cpp:
        (JSC::sameValue):

2013-02-13  Filip Pizlo  <fpizlo@apple.com>

        Change another use of (SpecCell & ~SpecString) to SpecObject.

        Reviewed by Mark Hahnenberg.

        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::execute):

2013-02-13  Filip Pizlo  <fpizlo@apple.com>

        ForwardInt32ToDouble is not in DFG::MinifiedNode's list of relevant node types
        https://bugs.webkit.org/show_bug.cgi?id=109726

        Reviewed by Mark Hahnenberg.
        
        If you add it to the list of relevant node types, you also need to make sure
        it's listed as either hasChild or one of the other kinds. Otherwise you get
        an assertion. This is causing test failures in run-javascriptcore-tests.

        * dfg/DFGMinifiedNode.h:
        (JSC::DFG::MinifiedNode::hasChild):

2013-02-13  Oliver Hunt  <oliver@apple.com>

        Build fix.

        Rearranged the code somewhat to reduce the number of
        DFG related ifdefs.

        * bytecode/CodeBlock.cpp:
        (JSC::CodeBlock::CodeBlock):

2013-02-13  Filip Pizlo  <fpizlo@apple.com>

        ForwardInt32ToDouble is not in DFG::MinifiedNode's list of relevant node types
        https://bugs.webkit.org/show_bug.cgi?id=109726

        Reviewed by Gavin Barraclough.
        
        This is asymptomatic because ForwardInt32ToDouble is only used in SetLocals, in
        which case the value is already stored to the stack.  Still, we should fix this.

        * dfg/DFGMinifiedNode.h:
        (JSC::DFG::belongsInMinifiedGraph):

2013-02-12  Filip Pizlo  <fpizlo@apple.com>

        DFG LogicalNot/Branch peephole removal and inversion ignores the possibility of things exiting
        https://bugs.webkit.org/show_bug.cgi?id=109489

        Reviewed by Mark Hahnenberg.
        
        If things can exit between the LogicalNot and the Branch then don't peephole.

        * dfg/DFGFixupPhase.cpp:
        (JSC::DFG::FixupPhase::fixupNode):

2013-02-13  Oliver Hunt  <oliver@apple.com>

        Remove unnecessary indirection to non-local variable access operations
        https://bugs.webkit.org/show_bug.cgi?id=109724

        Reviewed by Filip Pizlo.

        Linked bytecode now stores a direct pointer to the resolve operation
        vectors, so the interpreter no longer needs a bunch of indirection to
        to perform non-local lookup.

        * bytecode/CodeBlock.cpp:
        (JSC::CodeBlock::CodeBlock):
        * bytecode/CodeBlock.h:
        (CodeBlock):
        * bytecode/Instruction.h:
        * dfg/DFGByteCodeParser.cpp:
        (ByteCodeParser):
        (InlineStackEntry):
        (JSC::DFG::ByteCodeParser::parseResolveOperations):
        (JSC::DFG::ByteCodeParser::parseBlock):
        (JSC::DFG::ByteCodeParser::InlineStackEntry::InlineStackEntry):
        * dfg/DFGCapabilities.h:
        (JSC::DFG::canInlineOpcode):
        * dfg/DFGGraph.h:
        (ResolveGlobalData):
        (ResolveOperationData):
        (PutToBaseOperationData):
        * dfg/DFGSpeculativeJIT.h:
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):
        * jit/JITOpcodes.cpp:
        (JSC::JIT::emit_op_put_to_base):
        (JSC::JIT::emit_op_resolve):
        (JSC::JIT::emitSlow_op_resolve):
        (JSC::JIT::emit_op_resolve_base):
        (JSC::JIT::emitSlow_op_resolve_base):
        (JSC::JIT::emit_op_resolve_with_base):
        (JSC::JIT::emitSlow_op_resolve_with_base):
        (JSC::JIT::emit_op_resolve_with_this):
        (JSC::JIT::emitSlow_op_resolve_with_this):
        (JSC::JIT::emitSlow_op_put_to_base):
        * jit/JITOpcodes32_64.cpp:
        (JSC::JIT::emit_op_put_to_base):
        * llint/LLIntSlowPaths.cpp:
        (JSC::LLInt::LLINT_SLOW_PATH_DECL):
        * llint/LowLevelInterpreter.asm:

2013-02-13  Zoltan Herczeg  <zherczeg@webkit.org>

        replaceWithJump should not decrease the offset by 1 on ARM traditional.
        https://bugs.webkit.org/show_bug.cgi?id=109689

        Reviewed by Oliver Hunt.

        * assembler/ARMAssembler.h:
        (JSC::ARMAssembler::replaceWithJump):

2013-02-12  Joseph Pecoraro  <pecoraro@apple.com>

        [iOS] Enable PAGE_VISIBILITY_API
        https://bugs.webkit.org/show_bug.cgi?id=109399

        Reviewed by David Kilzer.

        * Configurations/FeatureDefines.xcconfig:

2013-02-12  Filip Pizlo  <fpizlo@apple.com>

        Renamed SpecObjectMask to SpecObject.

        Rubber stamped by Mark Hahnenberg.
        
        "SpecObjectMask" is a weird name considering that a bunch of the other speculated
        types are also masks, but don't have "Mask" in the name.

        * bytecode/SpeculatedType.h:
        (JSC):
        (JSC::isObjectSpeculation):
        (JSC::isObjectOrOtherSpeculation):
        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::execute):
        * dfg/DFGPredictionPropagationPhase.cpp:
        (JSC::DFG::PredictionPropagationPhase::propagate):
        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::compilePeepHoleObjectEquality):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::compileObjectEquality):
        (JSC::DFG::SpeculativeJIT::compileObjectToObjectOrOtherEquality):
        (JSC::DFG::SpeculativeJIT::compilePeepHoleObjectToObjectOrOtherEquality):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::compileObjectEquality):
        (JSC::DFG::SpeculativeJIT::compileObjectToObjectOrOtherEquality):
        (JSC::DFG::SpeculativeJIT::compilePeepHoleObjectToObjectOrOtherEquality):

2013-02-12  Filip Pizlo  <fpizlo@apple.com>

        DFG CFA doesn't filter precisely enough for CompareStrictEq
        https://bugs.webkit.org/show_bug.cgi?id=109618

        Reviewed by Mark Hahnenberg.
        
        The backend speculates object for this case, but the CFA was filtering on
        (SpecCell & ~SpecString) | SpecOther.

        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::execute):

2013-02-12  Martin Robinson  <mrobinson@igalia.com>

        Fix the gyp build of JavaScriptCore.

        * JavaScriptCore.gypi: Added some missing DFG files to the source list.

2013-02-12  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r142387.
        http://trac.webkit.org/changeset/142387
        https://bugs.webkit.org/show_bug.cgi?id=109601

        caused all layout and jscore tests on windows to fail
        (Requested by kling on #webkit).

        * bytecode/UnlinkedCodeBlock.cpp:
        (JSC::UnlinkedCodeBlock::UnlinkedCodeBlock):
        * bytecode/UnlinkedCodeBlock.h:
        (UnlinkedCodeBlock):

2013-02-11  Filip Pizlo  <fpizlo@apple.com>

        DFG CompareEq optimization should be retuned
        https://bugs.webkit.org/show_bug.cgi?id=109545

        Reviewed by Mark Hahnenberg.
        
        - Made the object-to-object equality case work again by hoisting the if statement
          for it. Previously, object-to-object equality would be compiled as
          object-to-object-or-other.
        
        - Added AbstractState guards for most of the type checks that the object equality
          code uses.
        
        Looks like a hint of a speed-up on all of the things.

        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::execute):
        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::compilePeepHoleObjectEquality):
        (JSC::DFG::SpeculativeJIT::compilePeepHoleBranch):
        (JSC::DFG::SpeculativeJIT::compare):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::compileObjectEquality):
        (JSC::DFG::SpeculativeJIT::compileObjectToObjectOrOtherEquality):
        (JSC::DFG::SpeculativeJIT::compilePeepHoleObjectToObjectOrOtherEquality):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::compileObjectEquality):
        (JSC::DFG::SpeculativeJIT::compileObjectToObjectOrOtherEquality):
        (JSC::DFG::SpeculativeJIT::compilePeepHoleObjectToObjectOrOtherEquality):

2013-02-12  Gabor Rapcsanyi  <rgabor@webkit.org>

        JSC asserting with long parameter list functions in debug mode on ARM traditional
        https://bugs.webkit.org/show_bug.cgi?id=109565

        Reviewed by Zoltan Herczeg.

        Increase the value of sequenceGetByIdSlowCaseInstructionSpace to 80.

        * jit/JIT.h:

2013-02-11  Oliver Hunt  <oliver@apple.com>

        Make JSC API more NULL tolerant
        https://bugs.webkit.org/show_bug.cgi?id=109515

        Reviewed by Mark Hahnenberg.

        We do so much marshalling for the C API these days anyway that a single null
        check isn't a performance issue.  Yet the existing "null is unsafe" behaviour
        leads to crashes in embedding applications whenever there's an untested code
        path, so it seems having defined behaviour is superior.

        * API/APICast.h:
        (toJS):
        (toJSForGC):
        * API/JSObjectRef.cpp:
        (JSObjectIsFunction):
        (JSObjectCallAsFunction):
        (JSObjectIsConstructor):
        (JSObjectCallAsConstructor):
        * API/tests/testapi.c:
        (main):

2013-02-11  Filip Pizlo  <fpizlo@apple.com>

        Unreviewed, adding a FIXME to remind ourselves of a bug.
        https://bugs.webkit.org/show_bug.cgi?id=109487

        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::compileStrictEqForConstant):

2013-02-11  Filip Pizlo  <fpizlo@apple.com>

        Strange bug in DFG OSR in JSC
        https://bugs.webkit.org/show_bug.cgi?id=109491

        Reviewed by Mark Hahnenberg.
        
        Int32ToDouble was being injected after a side-effecting operation and before a SetLocal. Anytime we
        inject something just before a SetLocal we should be aware that the previous operation may have been
        a side-effect associated with the current code origin. Hence, we should use a forward exit.
        Int32ToDouble does not do forward exits by default.
        
        This patch adds a forward-exiting form of Int32ToDouble, for use in SetLocal Int32ToDouble injections.
        Changed the CSE and other things to treat these nodes identically, but for the exit strategy to be
        distinct (Int32ToDouble -> backward, ForwardInt32ToDouble -> forward). The use of the NodeType for
        signaling exit direction is not "great" but it's what we use in other places already (like
        ForwardCheckStructure).

        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::execute):
        * dfg/DFGCSEPhase.cpp:
        (JSC::DFG::CSEPhase::int32ToDoubleCSE):
        (CSEPhase):
        (JSC::DFG::CSEPhase::performNodeCSE):
        * dfg/DFGCommon.h:
        * dfg/DFGFixupPhase.cpp:
        (JSC::DFG::FixupPhase::fixupNode):
        (JSC::DFG::FixupPhase::fixDoubleEdge):
        (JSC::DFG::FixupPhase::injectInt32ToDoubleNode):
        * dfg/DFGNode.h:
        (JSC::DFG::Node::willHaveCodeGenOrOSR):
        * dfg/DFGNodeType.h:
        (DFG):
        * dfg/DFGPredictionPropagationPhase.cpp:
        (JSC::DFG::PredictionPropagationPhase::propagate):
        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::convertLastOSRExitToForward):
        (JSC::DFG::SpeculativeJIT::compileInt32ToDouble):
        * dfg/DFGSpeculativeJIT.h:
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGVariableEventStream.cpp:
        (JSC::DFG::VariableEventStream::reconstruct):

2013-02-11  Filip Pizlo  <fpizlo@apple.com>

        NonStringCell and Object are practically the same thing for the purpose of speculation
        https://bugs.webkit.org/show_bug.cgi?id=109492

        Reviewed by Mark Hahnenberg.
        
        Removed isNonStringCellSpeculation, and made all callers use isObjectSpeculation.
        
        Changed isNonStringCellOrOtherSpeculation to be isObjectOrOtherSpeculation.
        
        I believe this is correct because even weird object types like JSNotAnObject end up
        being "objects" from the standpoint of our typesystem. Anyway, the assumption that
        "is cell but not a string" equates to "object" is an assumption that is already made
        in other places in the system so there's little value in being paranoid about it.

        * bytecode/SpeculatedType.h:
        (JSC::isObjectSpeculation):
        (JSC::isObjectOrOtherSpeculation):
        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::execute):
        * dfg/DFGNode.h:
        (Node):
        (JSC::DFG::Node::shouldSpeculateObjectOrOther):
        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::compilePeepHoleBranch):
        (JSC::DFG::SpeculativeJIT::compare):
        (JSC::DFG::SpeculativeJIT::compileStrictEq):
        * dfg/DFGSpeculativeJIT.h:
        (SpeculativeJIT):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::compileObjectOrOtherLogicalNot):
        (JSC::DFG::SpeculativeJIT::compileLogicalNot):
        (JSC::DFG::SpeculativeJIT::emitObjectOrOtherBranch):
        (JSC::DFG::SpeculativeJIT::emitBranch):
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::compileObjectOrOtherLogicalNot):
        (JSC::DFG::SpeculativeJIT::compileLogicalNot):
        (JSC::DFG::SpeculativeJIT::emitObjectOrOtherBranch):
        (JSC::DFG::SpeculativeJIT::emitBranch):
        (JSC::DFG::SpeculativeJIT::compile):

2013-02-10  Filip Pizlo  <fpizlo@apple.com>

        DFG CompareEq(a, null) and CompareStrictEq(a, const) are unsound with respect to constant folding
        https://bugs.webkit.org/show_bug.cgi?id=109387

        Reviewed by Oliver Hunt and Mark Hahnenberg.
        
        Lock in the decision to use a non-speculative constant comparison as early as possible
        and don't let the CFA change it by folding constants. This might be a performance
        penalty on some really weird code (FWIW, I haven't seen this on benchmarks), but on
        the other hand it completely side-steps the unsoundness that the bug speaks of.
        
        Rolling back in after adding 32-bit path.

        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::execute):
        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::isConstantForCompareStrictEq):
        (ByteCodeParser):
        (JSC::DFG::ByteCodeParser::parseBlock):
        * dfg/DFGCSEPhase.cpp:
        (JSC::DFG::CSEPhase::performNodeCSE):
        * dfg/DFGNodeType.h:
        (DFG):
        * dfg/DFGPredictionPropagationPhase.cpp:
        (JSC::DFG::PredictionPropagationPhase::propagate):
        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::compileStrictEq):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):

2013-02-10  Filip Pizlo  <fpizlo@apple.com>

        DFG TypeOf implementation should have its backend code aligned to what the CFA does
        https://bugs.webkit.org/show_bug.cgi?id=109385

        Reviewed by Sam Weinig.
        
        The problem was that if we ended up trying to constant fold, but didn't succeed
        because of prediction mismatches, then we would also fail to do filtration.
        
        Rearranged the control flow in the CFA to fix that.
        
        As far as I know, this is asymptomatic - it's sort of OK for the CFA to prove less
        things, which is what the bug was.

        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::execute):

2013-02-11  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r142491.
        http://trac.webkit.org/changeset/142491
        https://bugs.webkit.org/show_bug.cgi?id=109470

        broke the 32 bit build (Requested by jessieberlin on #webkit).

        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::execute):
        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::parseBlock):
        * dfg/DFGCSEPhase.cpp:
        (JSC::DFG::CSEPhase::performNodeCSE):
        * dfg/DFGNodeType.h:
        (DFG):
        * dfg/DFGPredictionPropagationPhase.cpp:
        (JSC::DFG::PredictionPropagationPhase::propagate):
        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::compileStrictEq):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):

2013-02-10  Filip Pizlo  <fpizlo@apple.com>

        DFG CompareEq(a, null) and CompareStrictEq(a, const) are unsound with respect to constant folding
        https://bugs.webkit.org/show_bug.cgi?id=109387

        Reviewed by Oliver Hunt.
        
        Lock in the decision to use a non-speculative constant comparison as early as possible
        and don't let the CFA change it by folding constants. This might be a performance
        penalty on some really weird code (FWIW, I haven't seen this on benchmarks), but on
        the other hand it completely side-steps the unsoundness that the bug speaks of.

        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::execute):
        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::isConstantForCompareStrictEq):
        (ByteCodeParser):
        (JSC::DFG::ByteCodeParser::parseBlock):
        * dfg/DFGCSEPhase.cpp:
        (JSC::DFG::CSEPhase::performNodeCSE):
        * dfg/DFGNodeType.h:
        (DFG):
        * dfg/DFGPredictionPropagationPhase.cpp:
        (JSC::DFG::PredictionPropagationPhase::propagate):
        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::compileStrictEq):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):

2013-02-11  Csaba Osztrogonác  <ossy@webkit.org>

        Unreviewed fix after r13954 for !ENABLE(JIT) builds.

        * llint/LowLevelInterpreter.cpp:

2013-02-11  Gabor Rapcsanyi  <rgabor@webkit.org>

        JSC build failing with verbose debug mode
        https://bugs.webkit.org/show_bug.cgi?id=109441

        Reviewed by Darin Adler.

        Fixing some verbose messages which caused build errors.

        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::mergeToSuccessors):
        * dfg/DFGCFAPhase.cpp:
        (JSC::DFG::CFAPhase::performBlockCFA):
        * dfg/DFGCSEPhase.cpp:
        (JSC::DFG::CSEPhase::setReplacement):
        (JSC::DFG::CSEPhase::eliminate):
        * dfg/DFGPredictionInjectionPhase.cpp:
        (JSC::DFG::PredictionInjectionPhase::run):

2013-02-10  Martin Robinson  <mrobinson@igalia.com>

        Fix the GTK+ gyp build

        * JavaScriptCore.gypi: Update the source list to accurately
        reflect what's in the repository and remove the offsets extractor
        from the list of JavaScriptCore files. It's only used to build
        the extractor binary.

2013-02-09  Andreas Kling  <akling@apple.com>

        Shrink-wrap UnlinkedCodeBlock members.
        <http://webkit.org/b/109368>

        Reviewed by Oliver Hunt.

        Rearrange the members of UnlinkedCodeBlock to avoid unnecessary padding on 64-bit.
        Knocks ~600 KB off of the Membuster3 peak.

        * bytecode/UnlinkedCodeBlock.cpp:
        (JSC::UnlinkedCodeBlock::UnlinkedCodeBlock):
        * bytecode/UnlinkedCodeBlock.h:
        (UnlinkedCodeBlock):

2013-02-08  Filip Pizlo  <fpizlo@apple.com>

        DFG should allow phases to break Phi's and then have one phase to rebuild them
        https://bugs.webkit.org/show_bug.cgi?id=108414

        Reviewed by Mark Hahnenberg.
        
        Introduces two new DFG forms: LoadStore and ThreadedCPS. These are described in
        detail in DFGCommon.h.
        
        Consequently, DFG phases no longer have to worry about preserving data flow
        links between basic blocks. It is generally always safe to request that the
        graph be dethreaded (Graph::dethread), which brings it into LoadStore form, where
        the data flow is implicit. In this form, only liveness-at-head needs to be
        preserved.
        
        All of the machinery for "threading" the graph to introduce data flow between
        blocks is now moved out of the bytecode parser and into the CPSRethreadingPhase.
        All phases that previously did this maintenance themselves now just rely on
        being able to dethread the graph. The one exception is the structure check
        hoising phase, which operates over a threaded graph and preserves it, for the
        sake of performance.
        
        Also moved two other things into their own phases: unification (previously found
        in the parser) and prediction injection (previously found in various places).

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * Target.pri:
        * bytecode/Operands.h:
        (Operands):
        (JSC::Operands::sizeFor):
        (JSC::Operands::atFor):
        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::execute):
        (JSC::DFG::AbstractState::mergeStateAtTail):
        * dfg/DFGAllocator.h:
        (JSC::DFG::::allocateSlow):
        * dfg/DFGArgumentsSimplificationPhase.cpp:
        (JSC::DFG::ArgumentsSimplificationPhase::run):
        * dfg/DFGBasicBlockInlines.h:
        (DFG):
        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::getLocal):
        (JSC::DFG::ByteCodeParser::getArgument):
        (JSC::DFG::ByteCodeParser::flushDirect):
        (JSC::DFG::ByteCodeParser::parseBlock):
        (DFG):
        (JSC::DFG::ByteCodeParser::parse):
        * dfg/DFGCFGSimplificationPhase.cpp:
        (JSC::DFG::CFGSimplificationPhase::run):
        (JSC::DFG::CFGSimplificationPhase::killUnreachable):
        (JSC::DFG::CFGSimplificationPhase::keepOperandAlive):
        (CFGSimplificationPhase):
        (JSC::DFG::CFGSimplificationPhase::fixJettisonedPredecessors):
        (JSC::DFG::CFGSimplificationPhase::mergeBlocks):
        * dfg/DFGCPSRethreadingPhase.cpp: Added.
        (DFG):
        (CPSRethreadingPhase):
        (JSC::DFG::CPSRethreadingPhase::CPSRethreadingPhase):
        (JSC::DFG::CPSRethreadingPhase::run):
        (JSC::DFG::CPSRethreadingPhase::freeUnnecessaryNodes):
        (JSC::DFG::CPSRethreadingPhase::clearVariablesAtHeadAndTail):
        (JSC::DFG::CPSRethreadingPhase::addPhiSilently):
        (JSC::DFG::CPSRethreadingPhase::addPhi):
        (JSC::DFG::CPSRethreadingPhase::canonicalizeGetLocalFor):
        (JSC::DFG::CPSRethreadingPhase::canonicalizeGetLocal):
        (JSC::DFG::CPSRethreadingPhase::canonicalizeSetLocal):
        (JSC::DFG::CPSRethreadingPhase::canonicalizeFlushOrPhantomLocalFor):
        (JSC::DFG::CPSRethreadingPhase::canonicalizeFlushOrPhantomLocal):
        (JSC::DFG::CPSRethreadingPhase::canonicalizeSetArgument):
        (JSC::DFG::CPSRethreadingPhase::canonicalizeLocalsInBlock):
        (JSC::DFG::CPSRethreadingPhase::canonicalizeLocalsInBlocks):
        (JSC::DFG::CPSRethreadingPhase::propagatePhis):
        (JSC::DFG::CPSRethreadingPhase::PhiStackEntry::PhiStackEntry):
        (PhiStackEntry):
        (JSC::DFG::CPSRethreadingPhase::phiStackFor):
        (JSC::DFG::performCPSRethreading):
        * dfg/DFGCPSRethreadingPhase.h: Added.
        (DFG):
        * dfg/DFGCSEPhase.cpp:
        (CSEPhase):
        (JSC::DFG::CSEPhase::performNodeCSE):
        * dfg/DFGCommon.cpp:
        (WTF):
        (WTF::printInternal):
        * dfg/DFGCommon.h:
        (JSC::DFG::logCompilationChanges):
        (DFG):
        (WTF):
        * dfg/DFGConstantFoldingPhase.cpp:
        (JSC::DFG::ConstantFoldingPhase::foldConstants):
        * dfg/DFGDriver.cpp:
        (JSC::DFG::compile):
        * dfg/DFGGraph.cpp:
        (JSC::DFG::Graph::Graph):
        (JSC::DFG::Graph::dump):
        (JSC::DFG::Graph::dethread):
        (JSC::DFG::Graph::collectGarbage):
        * dfg/DFGGraph.h:
        (JSC::DFG::Graph::performSubstitution):
        (Graph):
        (JSC::DFG::Graph::performSubstitutionForEdge):
        (JSC::DFG::Graph::convertToConstant):
        * dfg/DFGNode.h:
        (JSC::DFG::Node::convertToPhantomLocal):
        (Node):
        (JSC::DFG::Node::convertToGetLocal):
        (JSC::DFG::Node::hasVariableAccessData):
        * dfg/DFGNodeType.h:
        (DFG):
        * dfg/DFGPhase.cpp:
        (JSC::DFG::Phase::beginPhase):
        * dfg/DFGPhase.h:
        (JSC::DFG::runAndLog):
        * dfg/DFGPredictionInjectionPhase.cpp: Added.
        (DFG):
        (PredictionInjectionPhase):
        (JSC::DFG::PredictionInjectionPhase::PredictionInjectionPhase):
        (JSC::DFG::PredictionInjectionPhase::run):
        (JSC::DFG::performPredictionInjection):
        * dfg/DFGPredictionInjectionPhase.h: Added.
        (DFG):
        * dfg/DFGPredictionPropagationPhase.cpp:
        (JSC::DFG::PredictionPropagationPhase::run):
        (JSC::DFG::PredictionPropagationPhase::propagate):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGStructureCheckHoistingPhase.cpp:
        (JSC::DFG::StructureCheckHoistingPhase::run):
        * dfg/DFGUnificationPhase.cpp: Added.
        (DFG):
        (UnificationPhase):
        (JSC::DFG::UnificationPhase::UnificationPhase):
        (JSC::DFG::UnificationPhase::run):
        (JSC::DFG::performUnification):
        * dfg/DFGUnificationPhase.h: Added.
        (DFG):
        * dfg/DFGValidate.cpp:
        (JSC::DFG::Validate::validate):
        (JSC::DFG::Validate::dumpGraphIfAppropriate):
        * dfg/DFGVirtualRegisterAllocationPhase.cpp:
        (JSC::DFG::VirtualRegisterAllocationPhase::run):
        * llint/LLIntSlowPaths.cpp:
        (JSC::LLInt::setUpCall):
        * runtime/JSCJSValue.cpp:
        (JSC::JSValue::dump):
        * runtime/JSString.h:
        (JSString):
        * runtime/Options.h:
        (JSC):

2013-02-08  Jer Noble  <jer.noble@apple.com>

        Bring WebKit up to speed with latest Encrypted Media spec.
        https://bugs.webkit.org/show_bug.cgi?id=97037

        Reviewed by Eric Carlson.

        Define the ENABLE_ENCRYPTED_MEDIA_V2 setting.

        * Configurations/FeatureDefines.xcconfig:

2013-02-08  Gavin Barraclough  <barraclough@apple.com>

        Objective-C API for JavaScriptCore
        https://bugs.webkit.org/show_bug.cgi?id=105889

        Reviewed by Joseph Pecoraro

        Following up on review comments, mostly typos.

        * API/JSBlockAdaptor.h:
        * API/JSBlockAdaptor.mm:
        (-[JSBlockAdaptor blockFromValue:inContext:withException:]):
        * API/JSContext.h:
        * API/JSExport.h:
        * API/JSValue.h:
        * API/JSValue.mm:
        * API/JSWrapperMap.mm:
        (selectorToPropertyName):
        (-[JSWrapperMap classInfoForClass:]):
        (-[JSWrapperMap wrapperForObject:]):

2013-02-08  Martin Robinson  <mrobinson@igalia.com>

        [GTK] Add an experimental gyp build
        https://bugs.webkit.org/show_bug.cgi?id=109003

        Reviewed by Gustavo Noronha Silva.

        * JavaScriptCore.gypi: Update the list of source files to include those
        necessary for the GTK+ build.

2013-02-08  Andreas Kling  <akling@apple.com>

        JSC: Lower minimum PropertyTable size.
        <http://webkit.org/b/109247>

        Reviewed by Darin Adler.

        Lower the minimum table size for PropertyTable from 16 to 8.
        3.32 MB progression on Membuster3 (a ~13% reduction in memory used by PropertyTables.)

        * runtime/PropertyMapHashTable.h:
        (PropertyTable):
        (JSC::PropertyTable::sizeForCapacity):

2013-02-07  Roger Fong  <roger_fong@apple.com>

        Unreviewed. More VS2010 WebKit solution touchups.
        Make JavaScriptCoreExports.def.in be treated as a custom build file so that changes to it cause the exports to be rebuilt.

        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGenerator.vcxproj:
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGenerator.vcxproj.filters:
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExports.def.in:

2013-02-07  Mark Hahnenberg  <mhahnenberg@apple.com>

        Objective-C API: testapi.mm should use ARC
        https://bugs.webkit.org/show_bug.cgi?id=107838

        Reviewed by Mark Rowe.

        Removing the changes to the Xcode project file and moving the equivalent flags into 
        the ToolExecutable xcconfig file.

        * Configurations/ToolExecutable.xcconfig:
        * JavaScriptCore.xcodeproj/project.pbxproj:

2013-02-07  Brent Fulgham  <bfulgham@webkit.org>

        [Windows] Unreviewed Visual Studio 2010 build fixes after r142179.

        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExports.def.in: Correct changed symbols
        * JavaScriptCore.vcxproj/JavaScriptCoreExports.def: Removed autogenerated file.

2013-02-05  Filip Pizlo  <fpizlo@apple.com>

        DFG::ByteCodeParser should do surgical constant folding to reduce load on the optimization fixpoint
        https://bugs.webkit.org/show_bug.cgi?id=109000

        Reviewed by Oliver Hunt.
        
        Previously our source parser's ASTBuilder did some surgical constant folding, but it
        didn't cover some cases.  It was particularly incapable of doing constant folding for
        cases where we do some minimal loop peeling in the bytecode generator - since it
        didn't "see" those constants prior to the peeling.  Example:

        for (var i = 0; i < 4; ++i)
            things;

        This will get peeled just a bit by the bytecode generator, so that the "i < 4" is
        duplicated both at the top of the loop and the bottom.  This means that we have a
        constant comparison: "0 < 4", which the bytecode generator emits without any further
        thought.

        The DFG optimization fixpoint of course folds this and simplifies the CFG 
        accordingly, but this incurs a compile-time cost.  The purpose of this change is to
        do some surgical constant folding in the DFG's bytecode parser, so that such
        constructs reduce load on the CFG simplifier and the optimization fixpoint.  The goal
        is not to cover all cases, since the DFG CFA and CFG simplifier have a powerful
        sparse conditional constant propagation that we can always fall back on. Instead the
        goal is to cover enough cases that for common small functions we don't have to
        perform such transformations, thereby reducing compile times.
        
        This also refactors m_inlineStackEntry->m_inlineCallFrame to be a handy method call
        and also adds the notion of a TriState-based JSValue::pureToBoolean(). Both of these
        things are used by the folder.
        
        As well, care has been taken to make sure that the bytecode parser only does folding
        that is statically provable, and that doesn't arise out of speculation. This means
        we cannot fold on data flow that crosses inlining boundaries. On the other hand, the
        folding that the bytecode parser uses doesn't require phantoming anything. Such is
        the trade-off: for anything that we do need phantoming, we defer it to the
        optimization fixpoint.
        
        Slight SunSpider speed-up.

        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::get):
        (JSC::DFG::ByteCodeParser::getLocal):
        (JSC::DFG::ByteCodeParser::setLocal):
        (JSC::DFG::ByteCodeParser::flushDirect):
        (JSC::DFG::ByteCodeParser::flushArgumentsAndCapturedVariables):
        (JSC::DFG::ByteCodeParser::toInt32):
        (ByteCodeParser):
        (JSC::DFG::ByteCodeParser::inlineCallFrame):
        (JSC::DFG::ByteCodeParser::currentCodeOrigin):
        (JSC::DFG::ByteCodeParser::canFold):
        (JSC::DFG::ByteCodeParser::handleInlining):
        (JSC::DFG::ByteCodeParser::getScope):
        (JSC::DFG::ByteCodeParser::parseResolveOperations):
        (JSC::DFG::ByteCodeParser::parseBlock):
        (JSC::DFG::ByteCodeParser::parseCodeBlock):
        * dfg/DFGNode.h:
        (JSC::DFG::Node::isStronglyProvedConstantIn):
        (Node):
        * runtime/JSCJSValue.h:
        * runtime/JSCJSValueInlines.h:
        (JSC::JSValue::pureToBoolean):
        (JSC):

2013-02-07  Zoltan Herczeg  <zherczeg@webkit.org>

        Invalid code is generated for storing constants with baseindex addressing modes on ARM traditional.
        https://bugs.webkit.org/show_bug.cgi?id=109050

        Reviewed by Oliver Hunt.

        The S! scratch register is reused, but it should contain the constant value.

        * assembler/ARMAssembler.cpp:
        (JSC::ARMAssembler::baseIndexTransfer32):
        (JSC::ARMAssembler::baseIndexTransfer16):

2013-02-07  Andras Becsi  <andras.becsi@digia.com>

        [Qt] Use GNU ar's thin archive format for intermediate static libs
        https://bugs.webkit.org/show_bug.cgi?id=109052

        Reviewed by Jocelyn Turcotte.

        Adjust project files that used activeBuildConfig()
        to use targetSubDir().

        * JavaScriptCore.pri:
        * LLIntOffsetsExtractor.pro:
        * Target.pri:

2013-02-06  Roger Fong  <roger_fong@apple.com>

        Unreviewed. Touchups to VS2010 WebKit solution.
        Fix an export generator script, modify some property sheets, add resouce file.

        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGeneratorDebug.props:
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGeneratorPostBuild.cmd:
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGeneratorRelease.props:
        * JavaScriptCore.vcxproj/resource.h: Added.

2013-02-06  Ilya Tikhonovsky  <loislo@chromium.org>

        Web Inspector: Native Memory Instrumentation: assign class name to the heap graph node automatically
        https://bugs.webkit.org/show_bug.cgi?id=107262

        Reviewed by Yury Semikhatsky.

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCoreExports.def:

2013-02-06  Mike West  <mkwst@chromium.org>

        Add an ENABLE_NOSNIFF feature flag.
        https://bugs.webkit.org/show_bug.cgi?id=109029

        Reviewed by Jochen Eisinger.

        This new flag will control the behavior of 'X-Content-Type-Options: nosniff'
        when processing script and other resource types.

        * Configurations/FeatureDefines.xcconfig:

2013-02-05  Mark Hahnenberg  <mhahnenberg@apple.com>

        put_to_base should emit a Phantom for "value" across the ForceOSRExit
        https://bugs.webkit.org/show_bug.cgi?id=108998

        Reviewed by Oliver Hunt.

        Otherwise, the OSR exit compiler could clobber it, which would lead to badness.

        * bytecode/CodeBlock.cpp:
        (JSC::CodeBlock::tallyFrequentExitSites): Build fixes for when DFG debug logging is enabled.
        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::parseBlock): Added extra Phantoms for the "value" field where needed.
        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::compile): Ditto.

2013-02-05  Michael Saboff  <msaboff@apple.com>

        Crash at JSC::call when loading www.gap.com with JSVALUE32_64 Enabled
        https://bugs.webkit.org/show_bug.cgi?id=108991

        Reviewed by Oliver Hunt.

        Changed the restoration from calleeGPR to nonArgGPR0 because the restoration of the return location
        may step on calleeGPR is it happen to be nonArgGPR2.

        * dfg/DFGRepatch.cpp:
        (JSC::DFG::dfgLinkClosureCall):

2013-02-05  Roger Fong  <roger_fong@apple.com>

        Add a JavaScriptCore Export Generator project.
        https://bugs.webkit.org/show_bug.cgi?id=108971.

        Reviewed by Brent Fulgham.

        * JavaScriptCore.vcxproj/JavaScriptCore.sln:
        * JavaScriptCore.vcxproj/JavaScriptCore.vcxproj:
        * JavaScriptCore.vcxproj/JavaScriptCore.vcxproj.filters:
        * JavaScriptCore.vcxproj/JavaScriptCoreCommon.props:
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGenerator.vcxproj: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGenerator.vcxproj.filters: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGenerator.vcxproj.user: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGeneratorBuildCmd.cmd: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGeneratorCommon.props: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGeneratorDebug.props: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGeneratorPostBuild.cmd: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGeneratorPreBuild.cmd: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExportGeneratorRelease.props: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreExportGenerator/JavaScriptCoreExports.def.in: Added.

2013-02-04  Filip Pizlo  <fpizlo@apple.com>

        DFG should have a precise view of jump targets
        https://bugs.webkit.org/show_bug.cgi?id=108868

        Reviewed by Oliver Hunt.
        
        Previously, the DFG relied entirely on the CodeBlock's jump targets list for
        determining when to break basic blocks. This worked great, except sometimes it
        would be too conservative since the CodeBlock just says where the bytecode
        generator inserted labels.
        
        This change keeps the old jump target list in CodeBlock since it is still
        valuable to the baseline JIT, but switches the DFG to use its own jump target
        calculator. This ought to reduce pressure on the DFG simplifier, which would
        previously do a lot of work to try to merge redundantly created basic blocks.
        It appears to be a 1% progression on SunSpider.

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * Target.pri:
        * bytecode/PreciseJumpTargets.cpp: Added.
        (JSC):
        (JSC::addSimpleSwitchTargets):
        (JSC::computePreciseJumpTargets):
        * bytecode/PreciseJumpTargets.h: Added.
        (JSC):
        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::parseCodeBlock):

2013-02-01  Roger Fong  <roger_fong@apple.com>

        Make ConfigurationBuildDir include directories precede WebKitLibraries in JSC.
        https://bugs.webkit.org/show_bug.cgi?id=108693.

        Rubberstamped by Timothy Horton.

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCoreCommon.vsprops:

2013-02-04  Mark Hahnenberg  <mhahnenberg@apple.com>

        Structure::m_outOfLineCapacity is unnecessary
        https://bugs.webkit.org/show_bug.cgi?id=108206

        Reviewed by Darin Adler.

        Simplifying the utility functions that we use since we don't need a 
        bunch of fancy templates for this one specific call site.

        * runtime/Structure.h:
        (JSC::Structure::outOfLineCapacity):

2013-02-05  Mark Hahnenberg  <mhahnenberg@apple.com>

        Objective-C API: testapi.mm should use ARC
        https://bugs.webkit.org/show_bug.cgi?id=107838

        Reviewed by Oliver Hunt.

        In ToT testapi.mm uses the Obj-C garbage collector, which hides a lot of our object lifetime bugs.
        We should enable ARC, since that is what most of our clients will be using. We use Xcode project 
        settings to make sure we don't try to compile ARC on 32-bit.

        * API/tests/testapi.mm:
        (+[TestObject testObject]):
        (testObjectiveCAPI):
        * JavaScriptCore.xcodeproj/project.pbxproj:

2013-02-05  Brent Fulgham  <bfulgham@webkit.org>

        [Windows] Unreviewed VS2010 Build Correction after r141651

        * JavaScriptCore.vcxproj/JavaScriptCore.vcxproj: Add missing
        StructureRareData.h and StructureRareData.cpp files.
        * JavaScriptCore.vcxproj/JavaScriptCore.vcxproj.filters: Ditto.

2013-02-05  Michael Saboff  <msaboff@apple.com>

        r141788 won't build due to not having all changes needed by Node* change
        https://bugs.webkit.org/show_bug.cgi?id=108944

        Reviewed by David Kilzer.

        Fixed three instances of integerResult(..., m_compileIndex) to be integerResult(..., node).

        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::compileSoftModulo):
        (JSC::DFG::SpeculativeJIT::compileIntegerArithDivForARMv7s):

2013-02-04  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r141809.
        http://trac.webkit.org/changeset/141809
        https://bugs.webkit.org/show_bug.cgi?id=108860

        ARC isn't supported on 32-bit. (Requested by mhahnenberg on
        #webkit).

        * API/tests/testapi.mm:
        (+[TestObject testObject]):
        (testObjectiveCAPI):
        * JavaScriptCore.xcodeproj/project.pbxproj:

2013-02-04  Mark Hahnenberg  <mhahnenberg@apple.com>

        Objective-C API: testapi.mm should use ARC
        https://bugs.webkit.org/show_bug.cgi?id=107838

        Reviewed by Oliver Hunt.

        In ToT testapi.mm uses the Obj-C garbage collector, which hides a lot of our object lifetime bugs. 
        We should enable ARC, since that is what most of our clients will be using.

        * API/tests/testapi.mm:
        (-[TestObject init]):
        (-[TestObject dealloc]):
        (+[TestObject testObject]):
        (testObjectiveCAPI):
        * JavaScriptCore.xcodeproj/project.pbxproj:

2013-02-04  Mark Hahnenberg  <mhahnenberg@apple.com>

        Objective-C API: ObjCCallbackFunction should retain the target of its NSInvocation
        https://bugs.webkit.org/show_bug.cgi?id=108843

        Reviewed by Darin Adler.

        Currently, ObjCCallbackFunction doesn't retain the target of its NSInvocation. It needs to do 
        this to prevent crashes when trying to invoke a callback later on.

        * API/ObjCCallbackFunction.mm:
        (ObjCCallbackFunction::ObjCCallbackFunction):
        (ObjCCallbackFunction::~ObjCCallbackFunction):

2013-02-04  Martin Robinson  <mrobinson@igalia.com>

        Fix GTK+ 'make dist' in preparation for the 1.11.5 release.

        * GNUmakefile.list.am: Update the source lists.

2013-02-04  Michael Saboff  <msaboff@apple.com>

        For ARMv7s use integer divide instruction for divide and modulo when possible
        https://bugs.webkit.org/show_bug.cgi?id=108840

        Reviewed in person by Filip Pizlo.

        Added ARMv7s integer divide path for ArithDiv and ArithMod where operands and results are integer.
        This is patterned after the similar code for X86.  Also added modulo power of 2 optimization
        that uses logical and.  Added sdiv and udiv to the ARMv7 disassembler.  Put all the changes
        behind #if CPU(APPLE_ARMV7S). 

        * assembler/ARMv7Assembler.h:
        (ARMv7Assembler):
        (JSC::ARMv7Assembler::sdiv):
        (JSC::ARMv7Assembler::udiv):
        * dfg/DFGCommon.h:
        (JSC::DFG::isARMv7s):
        * dfg/DFGFixupPhase.cpp:
        (JSC::DFG::FixupPhase::fixupNode):
        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::compileSoftModulo):
        (JSC::DFG::SpeculativeJIT::compileIntegerArithDivForARMv7s):
        * dfg/DFGSpeculativeJIT.h:
        (SpeculativeJIT):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):

2013-02-04  David Kilzer  <ddkilzer@apple.com>

        Check PrivateHeaders/JSBasePrivate.h for inappropriate macros
        <http://webkit.org/b/108749>

        Reviewed by Joseph Pecoraro.

        * JavaScriptCore.xcodeproj/project.pbxproj: Add
        PrivateHeaders/JSBasePrivate.h to list of headers to check in
        "Check for Inappropriate Macros in External Headers" build phase
        script.

2013-02-04  David Kilzer  <ddkilzer@apple.com>

        Remove duplicate entries from JavaScriptCore Xcode project

            $ uniq Source/JavaScriptCore/JavaScriptCore.xcodeproj/project.pbxproj | diff -u - Source/JavaScriptCore/JavaScriptCore.xcodeproj/project.pbxproj | patch -p0 -R
            patching file Source/JavaScriptCore/JavaScriptCore.xcodeproj/project.pbxproj

        * JavaScriptCore.xcodeproj/project.pbxproj: Remove duplicates.

2013-02-04  David Kilzer  <ddkilzer@apple.com>

        Sort JavaScriptCore Xcode project file

        * JavaScriptCore.xcodeproj/project.pbxproj:

2013-02-03  David Kilzer  <ddkilzer@apple.com>

        Upstream ENABLE_PDFKIT_PLUGIN settting
        <http://webkit.org/b/108792>

        Reviewed by Tim Horton.

        * Configurations/FeatureDefines.xcconfig: Disable PDFKIT_PLUGIN
        on iOS since PDFKit is a Mac-only framework.

2013-02-02  Andreas Kling  <akling@apple.com>

        Vector should consult allocator about ideal size when choosing capacity.
        <http://webkit.org/b/108410>
        <rdar://problem/13124002>

        Reviewed by Benjamin Poulain.

        Remove assertion about Vector capacity that won't hold anymore since capacity()
        may not be what you passed to reserveCapacity().
        Also export WTF::fastMallocGoodSize() for Windows builds.

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCoreExports.def:
        * bytecode/CodeBlock.cpp:
        (JSC::CodeBlock::CodeBlock):

2013-02-02  Patrick Gansterer  <paroga@webkit.org>

        [CMake] Adopt the WinCE port to new CMake
        https://bugs.webkit.org/show_bug.cgi?id=108754

        Reviewed by Laszlo Gombos.

        * os-win32/WinMain.cpp: Removed.
        * shell/PlatformWinCE.cmake: Removed.

2013-02-02  Mark Rowe  <mrowe@apple.com>

        <http://webkit.org/b/108745> WTF shouldn't use a script build phase to detect the presence of headers when the compiler can do it for us

        Reviewed by Sam Weinig.

        * DerivedSources.make: Remove an obsolete Makefile rule. This should have been removed when the use
        of the generated file moved to WTF.

2013-02-02  David Kilzer  <ddkilzer@apple.com>

        Upstream iOS FeatureDefines
        <http://webkit.org/b/108753>

        Reviewed by Anders Carlsson.

        * Configurations/FeatureDefines.xcconfig:
        - ENABLE_DEVICE_ORIENTATION: Add iOS configurations.
        - ENABLE_PLUGIN_PROXY_FOR_VIDEO: Ditto.
        - FEATURE_DEFINES: Add ENABLE_PLUGIN_PROXY_FOR_VIDEO.  Add
          PLATFORM_NAME variant to reduce future merge conflicts. 

2013-02-01  Mark Hahnenberg  <mhahnenberg@apple.com>

        Structure::m_enumerationCache should be moved to StructureRareData
        https://bugs.webkit.org/show_bug.cgi?id=108723

        Reviewed by Oliver Hunt.

        m_enumerationCache is only used by objects whose properties are iterated over, so not every Structure needs this 
        field and it can therefore be moved safely to StructureRareData to help with memory savings.

        * runtime/JSPropertyNameIterator.h:
        (JSPropertyNameIterator):
        (JSC::Register::propertyNameIterator):
        (JSC::StructureRareData::enumerationCache): Add to JSPropertyNameIterator.h so that it can see the correct type.
        (JSC::StructureRareData::setEnumerationCache): Ditto.
        * runtime/Structure.cpp:
        (JSC::Structure::addPropertyWithoutTransition): Use the enumerationCache() getter rather than accessing the field.
        (JSC::Structure::removePropertyWithoutTransition): Ditto.
        (JSC::Structure::visitChildren): We no longer have to worry about marking the m_enumerationCache field.
        * runtime/Structure.h: 
        (JSC::Structure::setEnumerationCache): Move the old accessors back since we don't have to have any knowledge of 
        the JSPropertyNameIterator type.
        (JSC::Structure::enumerationCache): Ditto.
        * runtime/StructureRareData.cpp:
        (JSC::StructureRareData::visitChildren): Mark the new m_enumerationCache field.
        * runtime/StructureRareData.h: Add new functions/fields.
        (StructureRareData):

2013-02-01  Roger Fong  <roger_fong@apple.com>

        Unreviewed. JavaScriptCore VS2010 project cleanup.

        * JavaScriptCore.vcxproj/JavaScriptCore.vcxproj:
        * JavaScriptCore.vcxproj/JavaScriptCore.vcxproj.filters:
        * JavaScriptCore.vcxproj/JavaScriptCoreCommon.props:
        * JavaScriptCore.vcxproj/testRegExp/testRegExp.vcxproj:

2013-02-01  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r141662.
        http://trac.webkit.org/changeset/141662
        https://bugs.webkit.org/show_bug.cgi?id=108738

        it's an incorrect change since processPhiStack will
        dereference dangling BasicBlock pointers (Requested by pizlo
        on #webkit).

        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::parse):

2013-02-01  Filip Pizlo  <fpizlo@apple.com>

        Eliminate dead blocks sooner in the DFG::ByteCodeParser to make clear that you don't need to hold onto them during Phi construction
        https://bugs.webkit.org/show_bug.cgi?id=108717

        Reviewed by Mark Hahnenberg.
        
        I think this makes the code clearer. It doesn't change behavior.

        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::parse):

2013-02-01  Mark Hahnenberg  <mhahnenberg@apple.com>

        Structure should have a StructureRareData field to save space
        https://bugs.webkit.org/show_bug.cgi?id=108659

        Reviewed by Oliver Hunt.

        Many of the fields in Structure are used in a subset of all total Structures; however, all Structures must 
        pay the memory cost of those fields, regardless of whether they use them or not. Since we can have potentially 
        many Structures on a single page (e.g. bing.com creates ~1500 Structures), it would be profitable to 
        refactor Structure so that not every Structure has to pay the memory costs for these infrequently used fields.

        To accomplish this, we can create a new StructureRareData class to house these seldom used fields which we 
        can allocate on demand whenever a Structure requires it. This StructureRareData can itself be a JSCell, and 
        can do all the marking of the fields for the Structure. The StructureRareData field will be part of a union 
        with m_previous to minimize overhead. We'll add a new field to JSTypeInfo to indicate that the Structure has 
        a StructureRareData field. During transitions, a Structure will clone its previous Structure's StructureRareData 
        if it has one. There could be some potential for optimizing this process, but the initial implementation will 
        be dumb since we'd be paying these overhead costs for each Structure anyways.

        Initially we'll only put two fields in the StructureRareData to avoid a memory regression. Over time we'll 
        continue to move fields from Structure to StructureRareData. Optimistically, this could potentially reduce our 
        Structure memory footprint by up to around 75%. It could also clear the way for removing destructors from 
        Structures (and into StructureRareData).

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * Target.pri:
        * dfg/DFGRepatch.cpp: Includes for linking purposes.
        * jit/JITStubs.cpp:
        * jsc.cpp:
        * llint/LLIntSlowPaths.cpp:
        * runtime/JSCellInlines.h: Added ifdef guards.
        * runtime/JSGlobalData.cpp: New Structure for StructureRareData class.
        (JSC::JSGlobalData::JSGlobalData):
        * runtime/JSGlobalData.h:
        (JSGlobalData):
        * runtime/JSGlobalObject.h:
        * runtime/JSTypeInfo.h: New flag to indicate whether or not a Structure has a StructureRareData field.
        (JSC::TypeInfo::flags):
        (JSC::TypeInfo::structureHasRareData):
        * runtime/ObjectPrototype.cpp:
        * runtime/Structure.cpp: We use a combined WriteBarrier<JSCell> field m_previousOrRareData to avoid compiler issues.
        (JSC::Structure::dumpStatistics):
        (JSC::Structure::Structure): 
        (JSC::Structure::materializePropertyMap):
        (JSC::Structure::addPropertyTransition):
        (JSC::Structure::nonPropertyTransition):
        (JSC::Structure::pin):
        (JSC::Structure::allocateRareData): Handles allocating a brand new StructureRareData field.
        (JSC::Structure::cloneRareDataFrom): Handles cloning a StructureRareData field from another. Used during Structure 
        transitions.
        (JSC::Structure::visitChildren): We no longer have to worry about marking m_objectToStringValue.
        * runtime/Structure.h:
        (JSC::Structure::previousID): Checks the structureHasRareData flag to see where it should get the previous Structure.
        (JSC::Structure::objectToStringValue): Reads the value from the StructureRareData. If it doesn't exist, returns 0.
        (JSC::Structure::setObjectToStringValue): Ensures that we have a StructureRareData field, then forwards the function 
        call to it.
        (JSC::Structure::materializePropertyMapIfNecessary):
        (JSC::Structure::setPreviousID): Checks for StructureRareData and forwards if necessary.
        (Structure):
        (JSC::Structure::clearPreviousID): Ditto.
        (JSC::Structure::create):
        * runtime/StructureRareData.cpp: Added. All of the basic functionality of a JSCell with the fields that we've moved 
        from Structure and the functions required to access/modify those fields as Structure would have done.
        (JSC):
        (JSC::StructureRareData::createStructure):
        (JSC::StructureRareData::create):
        (JSC::StructureRareData::clone):
        (JSC::StructureRareData::StructureRareData):
        (JSC::StructureRareData::visitChildren):
        * runtime/StructureRareData.h: Added.
        (JSC):
        (StructureRareData):
        * runtime/StructureRareDataInlines.h: Added.
        (JSC):
        (JSC::StructureRareData::previousID):
        (JSC::StructureRareData::setPreviousID):
        (JSC::StructureRareData::clearPreviousID):
        (JSC::Structure::previous): Handles the ugly casting to get the value of the right type of m_previousOrRareData.
        (JSC::Structure::rareData): Ditto.
        (JSC::StructureRareData::objectToStringValue):
        (JSC::StructureRareData::setObjectToStringValue):

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * Target.pri:
        * dfg/DFGRepatch.cpp:
        * jit/JITStubs.cpp:
        * jsc.cpp:
        * llint/LLIntSlowPaths.cpp:
        * runtime/JSCellInlines.h:
        * runtime/JSGlobalData.cpp:
        (JSC::JSGlobalData::JSGlobalData):
        * runtime/JSGlobalData.h:
        (JSGlobalData):
        * runtime/JSGlobalObject.h:
        * runtime/JSTypeInfo.h:
        (JSC):
        (JSC::TypeInfo::flags):
        (JSC::TypeInfo::structureHasRareData):
        * runtime/ObjectPrototype.cpp:
        * runtime/Structure.cpp:
        (JSC::Structure::dumpStatistics):
        (JSC::Structure::Structure):
        (JSC::Structure::materializePropertyMap):
        (JSC::Structure::addPropertyTransition):
        (JSC::Structure::nonPropertyTransition):
        (JSC::Structure::pin):
        (JSC::Structure::allocateRareData):
        (JSC):
        (JSC::Structure::cloneRareDataFrom):
        (JSC::Structure::visitChildren):
        * runtime/Structure.h:
        (JSC::Structure::previousID):
        (JSC::Structure::objectToStringValue):
        (JSC::Structure::setObjectToStringValue):
        (JSC::Structure::materializePropertyMapIfNecessary):
        (JSC::Structure::setPreviousID):
        (Structure):
        (JSC::Structure::clearPreviousID):
        (JSC::Structure::previous):
        (JSC::Structure::rareData):
        (JSC::Structure::create):
        * runtime/StructureRareData.cpp: Added.
        (JSC):
        (JSC::StructureRareData::createStructure):
        (JSC::StructureRareData::create):
        (JSC::StructureRareData::clone):
        (JSC::StructureRareData::StructureRareData):
        (JSC::StructureRareData::visitChildren):
        * runtime/StructureRareData.h: Added.
        (JSC):
        (StructureRareData):
        * runtime/StructureRareDataInlines.h: Added.
        (JSC):
        (JSC::StructureRareData::previousID):
        (JSC::StructureRareData::setPreviousID):
        (JSC::StructureRareData::clearPreviousID):
        (JSC::StructureRareData::objectToStringValue):
        (JSC::StructureRareData::setObjectToStringValue):

2013-02-01  Balazs Kilvady  <kilvadyb@homejinni.com>

        offlineasm BaseIndex handling is broken on ARM due to MIPS changes
        https://bugs.webkit.org/show_bug.cgi?id=108261

        Reviewed by Filip Pizlo.

        offlineasm BaseIndex handling fix on MIPS.

        * offlineasm/mips.rb:
        * offlineasm/risc.rb:

2013-02-01  Geoffrey Garen  <ggaren@apple.com>

        Removed an unused function: JSGlobalObject::createFunctionExecutableFromGlobalCode
        https://bugs.webkit.org/show_bug.cgi?id=108657

        Reviewed by Anders Carlsson.

        * runtime/JSGlobalObject.cpp:
        (JSC):
        * runtime/JSGlobalObject.h:
        (JSGlobalObject):

2013-02-01  Geoffrey Garen  <ggaren@apple.com>

        Added TriState to WTF and started using it in one place
        https://bugs.webkit.org/show_bug.cgi?id=108628

        Reviewed by Beth Dakin.

        * runtime/PrototypeMap.h:
        (JSC::PrototypeMap::isPrototype): Use TriState instead of boolean. In
        response to review feedback, this is an attempt to clarify that our
        'true' condition is actually just a 'maybe'.

        * runtime/PrototypeMap.h:
        (PrototypeMap):
        (JSC::PrototypeMap::isPrototype):

2013-02-01  Alexis Menard  <alexis@webkit.org>

        Enable unprefixed CSS transitions by default.
        https://bugs.webkit.org/show_bug.cgi?id=108216

        Reviewed by Dean Jackson.

        Rename the flag CSS_TRANSFORMS_ANIMATIONS_TRANSITIONS_UNPREFIXED
        to CSS_TRANSFORMS_ANIMATIONS_UNPREFIXED which will be used later to 
        guard the unprefixing work for CSS Transforms and animations.

        * Configurations/FeatureDefines.xcconfig:

2013-01-31  Filip Pizlo  <fpizlo@apple.com>

        DFG::CFGSimplificationPhase::keepOperandAlive() conflates liveness and availability
        https://bugs.webkit.org/show_bug.cgi?id=108580

        Reviewed by Oliver Hunt.
        
        This is a harmless bug in that it only results in us keeping a bit too many things
        for OSR.  But it's worth fixing so that the code is consistent.

        keepOperandAlive() is called when block A has a branch to blocks B and C, but the
        A->B edge is proven to never be taken and we want to optimize the code to have A
        unconditionally jump to C.  In that case, for the purposes of OSR, we need to
        preserve the knowledge that the state that B expected to be live incoming from A
        ought still to be live up to the point of where the A->B,C branch used to be.  The
        way we keep things alive is by using the variablesAtTail of A (i.e., we use the
        knowledge of in what manner A made state available to B and C).  The way we choose
        which state should be kept alive ought to be chosen by the variablesAtHead of B
        (i.e. the things B says it needs from its predecessors, including A), except that
        keepOperandAlive() was previously just using variablesAtTail of A for this
        purpose.
        
        The fix is to have keepOperandAlive() use both liveness and availability in its
        logic. It should use liveness (i.e. B->variablesAtHead) to decide what to keep
        alive, and it should use availability (i.e. A->variablesAtTail) to decide how to
        keep it alive.
        
        This might be a microscopic win on some programs, but it's mainly intended to be
        a code clean-up so that I don't end up scratching my head in confusion the next
        time I look at this code.

        * dfg/DFGCFGSimplificationPhase.cpp:
        (JSC::DFG::CFGSimplificationPhase::keepOperandAlive):
        (JSC::DFG::CFGSimplificationPhase::jettisonBlock):
        (JSC::DFG::CFGSimplificationPhase::mergeBlocks):

2013-01-31  Geoffrey Garen  <ggaren@apple.com>

        REGRESSION (r141192): Crash beneath cti_op_get_by_id_generic @ discussions.apple.com
        https://bugs.webkit.org/show_bug.cgi?id=108576

        Reviewed by Filip Pizlo.

        This was a long-standing bug. The DFG would destructively reuse a register
        in op_convert_this, but:

            * The bug only presented during speculation failure for type Other

            * The bug presented by removing the low bits of a pointer, which
            used to be harmless, since all objects were so aligned anyway.

        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::compile): Don't reuse our this register as
        our scratch register. The whole point of our scratch register is to
        avoid destructively modifying our this register. I'm pretty sure this
        was a copy-paste error.

2013-01-31  Roger Fong  <roger_fong@apple.com>

        Unreviewed. Windows build fix.

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCoreExports.def:

2013-01-31  Jessie Berlin  <jberlin@apple.com>

        Rolling out r141407 because it is causing crashes under
        WTF::TCMalloc_Central_FreeList::FetchFromSpans() in Release builds.

        * bytecode/CodeBlock.cpp:
        (JSC::CodeBlock::CodeBlock):

2013-01-31  Mark Hahnenberg  <mhahnenberg@apple.com>

        Objective-C API: JSContext exception property causes reference cycle
        https://bugs.webkit.org/show_bug.cgi?id=107778

        Reviewed by Darin Adler.

        JSContext has a (retain) JSValue * exception property which, when non-null, creates a 
        reference cycle (since the JSValue * holds a strong reference back to the JSContext *).

        * API/JSContext.mm: Instead of JSValue *, we now use a plain JSValueRef, which eliminates the reference cycle.
        (-[JSContext initWithVirtualMachine:]):
        (-[JSContext setException:]):
        (-[JSContext exception]):

2013-01-31  Roger Fong  <roger_fong@apple.com>

        Unreviewed build fix. Win7 port.

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCoreExports.def:

2013-01-31  Joseph Pecoraro  <pecoraro@apple.com>

        Disable ENABLE_FULLSCREEN_API on iOS
        https://bugs.webkit.org/show_bug.cgi?id=108250

        Reviewed by Benjamin Poulain.

        * Configurations/FeatureDefines.xcconfig:

2013-01-31  Mark Hahnenberg  <mhahnenberg@apple.com>

        Objective-C API: Fix insertion of values greater than the max index allowed by the spec
        https://bugs.webkit.org/show_bug.cgi?id=108264

        Reviewed by Oliver Hunt.

        Fixed a bug, added a test to the API tests, cleaned up some code.

        * API/JSValue.h: Changed some of the documentation on setValue:atIndex: to indicate that 
        setting values at indices greater than UINT_MAX - 1 wont' affect the length of JS arrays.
        * API/JSValue.mm:
        (-[JSValue valueAtIndex:]): We weren't returning when we should have been.
        (-[JSValue setValue:atIndex:]): Added a comment about why we do the early check for being larger than UINT_MAX.
        (objectToValueWithoutCopy): Removed two redundant cases that were already checked previously.
        * API/tests/testapi.mm:

2013-01-30  Andreas Kling  <akling@apple.com>

        Vector should consult allocator about ideal size when choosing capacity.
        <http://webkit.org/b/108410>
        <rdar://problem/13124002>

        Reviewed by Benjamin Poulain.

        Remove assertion about Vector capacity that won't hold anymore since capacity()
        may not be what you passed to reserveCapacity().

        * bytecode/CodeBlock.cpp:
        (JSC::CodeBlock::CodeBlock):

2013-01-30  Filip Pizlo  <fpizlo@apple.com>

        DFG bytecode parser should have more assertions about the status of local accesses
        https://bugs.webkit.org/show_bug.cgi?id=108417

        Reviewed by Mark Hahnenberg.
        
        Assert some things that we already know to be true, just to reassure ourselves that they are true.
        This is meant as a prerequisite for https://bugs.webkit.org/show_bug.cgi?id=108414, which will
        make these rules even stricter.

        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::getLocal):
        (JSC::DFG::ByteCodeParser::getArgument):

2013-01-30  Mark Hahnenberg  <mhahnenberg@apple.com>

        Objective-C API: JSContext's dealloc causes ASSERT due to ordering of releases
        https://bugs.webkit.org/show_bug.cgi?id=107978

        Reviewed by Filip Pizlo.

        We need to add the Identifier table save/restore in JSContextGroupRelease so that we 
        have the correct table if we end up destroying the JSGlobalData/Heap.

        * API/JSContextRef.cpp:
        (JSContextGroupRelease):

2013-01-30  Mark Hahnenberg  <mhahnenberg@apple.com>

        Objective-C API: exceptionHandler needs to be released in JSContext dealloc
        https://bugs.webkit.org/show_bug.cgi?id=108378

        Reviewed by Filip Pizlo.

        JSContext has a (copy) exceptionHandler property that it doesn't release in dealloc. 
        That sounds like the potential for a leak. It should be released.

        * API/JSContext.mm:
        (-[JSContext dealloc]):

2013-01-30  Filip Pizlo  <fpizlo@apple.com>

        REGRESSION(140504): pure CSE no longer matches things, 10% regression on Kraken
        https://bugs.webkit.org/show_bug.cgi?id=108366

        Reviewed by Geoffrey Garen and Mark Hahnenberg.
        
        This was a longstanding bug that was revealed by http://trac.webkit.org/changeset/140504.
        Pure CSE requires that the Node::flags() that may affect the behavior of a node match,
        when comparing a possibly redundant node to its possible replacement. It was doing this
        by comparing Node::arithNodeFlags(), which as the name might appear to suggest, returns
        just those flag bits that correspond to actual node behavior and not auxiliary things.
        Unfortunately, Node::arithNodeFlags() wasn't actually masking off the irrelevant bits.
        This worked prior to r140504 because CSE itself didn't mutate the flags, so there was a
        very high probability that matching nodes would also have completely identical flag bits
        (even the ones that aren't relevant to arithmetic behavior, like NodeDoesNotExit). But
        r140504 moved one of CSE's side-tables (m_relevantToOSR) into a flag bit for quicker
        access. These bits would be mutated as the CSE ran over a basic block, in such a way that
        there was a very high probability that the possible replacement would already have the
        bit set, while the redundant node did not have the bit set. Since Node::arithNodeFlags()
        returned all of the bits, this would cause CSEPhase::pureCSE() to reject the match
        almost every time.
        
        The solution is to make Node::arithNodeFlags() do as its name suggests: only return those
        flags that are relevant to arithmetic behavior. This patch introduces a new mask that
        represents those bits, and includes NodeBehaviorMask and NodeBackPropMask, which are both
        used for queries on Node::arithNodeFlags(), and both affect arithmetic code gen. None of
        the other flags are relevant to Node::arithNodeFlags() since they either correspond to
        information already conveyed by the opcode (like NodeResultMask, NodeMustGenerate,
        NodeHasVarArgs, NodeClobbersWorld, NodeMightClobber) or information that doesn't affect
        the result that the node will produce or any of the queries performed on the result of
        Node::arithNodeFlags (NodeDoesNotExit and of course NodeRelevantToOSR).
        
        This is a 10% speed-up on Kraken, undoing the regression from r140504.

        * dfg/DFGNode.h:
        (JSC::DFG::Node::arithNodeFlags):
        * dfg/DFGNodeFlags.h:
        (DFG):

2013-01-29  Mark Hahnenberg  <mhahnenberg@apple.com>

        Structure::m_outOfLineCapacity is unnecessary
        https://bugs.webkit.org/show_bug.cgi?id=108206

        Reviewed by Geoffrey Garen.

        We can calculate our out of line capacity by using the outOfLineSize and our knowledge about our resize policy.
        According to GDB, this knocks Structures down from 136 bytes to 128 bytes (I'm guessing the extra bytes are from
        better alignment of object fields), which puts Structures in a smaller size class. Woohoo! Looks neutral on our 
        benchmarks.

        * runtime/Structure.cpp:
        (JSC::Structure::Structure):
        (JSC):
        (JSC::Structure::suggestedNewOutOfLineStorageCapacity):
        (JSC::Structure::addPropertyTransition):
        (JSC::Structure::addPropertyWithoutTransition):
        * runtime/Structure.h:
        (Structure):
        (JSC::Structure::outOfLineCapacity):
        (JSC::Structure::totalStorageCapacity):

2013-01-29  Geoffrey Garen  <ggaren@apple.com>

        Be a little more conservative about emitting table-based switches
        https://bugs.webkit.org/show_bug.cgi?id=108292

        Reviewed by Filip Pizlo.

        Profiling shows we're using op_switch in cases where it's a regression.

        * bytecompiler/NodesCodegen.cpp:
        (JSC):
        (JSC::length):
        (JSC::CaseBlockNode::tryTableSwitch):
        (JSC::CaseBlockNode::emitBytecodeForBlock):
        * parser/Nodes.h:
        (CaseBlockNode):

2013-01-29  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r140983.
        http://trac.webkit.org/changeset/140983
        https://bugs.webkit.org/show_bug.cgi?id=108277

        Unfortunately, this API has one last client (Requested by
        abarth on #webkit).

        * Configurations/FeatureDefines.xcconfig:

2013-01-29  Mark Hahnenberg  <mhahnenberg@apple.com>

        Objective-C API: JSObjCClassInfo creates reference cycle with JSContext
        https://bugs.webkit.org/show_bug.cgi?id=107839

        Reviewed by Geoffrey Garen.

        Fixing several ASSERTs that were incorrect along with some of the reallocation of m_prototype and 
        m_constructor that they were based on.

        * API/JSWrapperMap.mm:
        (-[JSObjCClassInfo allocateConstructorAndPrototypeWithSuperClassInfo:]): We now only allocate those
        fields that are null (i.e. have been collected or have never been allocated to begin with).
        (-[JSObjCClassInfo reallocateConstructorAndOrPrototype]): Renamed to better indicate that we're 
        reallocating one or both of the prototype/constructor combo.
        (-[JSObjCClassInfo wrapperForObject:]): Call new reallocate function.
        (-[JSObjCClassInfo constructor]): Ditto.

2013-01-29  Geoffrey Garen  <ggaren@apple.com>

        Make precise size classes more precise
        https://bugs.webkit.org/show_bug.cgi?id=108270

        Reviewed by Mark Hahnenberg.

        Size inference makes this profitable.

        I chose 8 byte increments because JSString is 24 bytes. Otherwise, 16
        byte increments might be better.

        * heap/Heap.h:
        (Heap): Removed firstAllocatorWithoutDestructors because it's unused now.

        * heap/MarkedBlock.h:
        (MarkedBlock): Updated constants.

        * heap/MarkedSpace.h:
        (MarkedSpace):
        (JSC): Also reduced the maximum precise size class because my testing
        has shown that the smaller size classes are much more common. This
        offsets some of the size class explosion caused by reducing the precise
        increment.

        * llint/LLIntData.cpp:
        (JSC::LLInt::Data::performAssertions): No need for this ASSERT anymore
        because we don't rely on firstAllocatorWithoutDestructors anymore, since
        we pick size classes dynamically now.

2013-01-29  Oliver Hunt  <oliver@apple.com>

        Add some hardening to methodTable()
        https://bugs.webkit.org/show_bug.cgi?id=108253

        Reviewed by Mark Hahnenberg.

        When accessing methodTable() we now always make sure that our
        structure _could_ be valid.  Added a separate method to get a
        classes methodTable during destruction as it's not possible to
        validate the structure at that point.  This separation might
        also make it possible to improve the performance of methodTable
        access more generally in future.

        * heap/MarkedBlock.cpp:
        (JSC::MarkedBlock::callDestructor):
        * runtime/JSCell.h:
        (JSCell):
        * runtime/JSCellInlines.h:
        (JSC::JSCell::methodTableForDestruction):
        (JSC):
        (JSC::JSCell::methodTable):

2013-01-29  Filip Pizlo  <fpizlo@apple.com>

        offlineasm BaseIndex handling is broken on ARM due to MIPS changes
        https://bugs.webkit.org/show_bug.cgi?id=108261

        Reviewed by Oliver Hunt.
        
        Backends shouldn't override each other's methods. That's not cool.

        * offlineasm/mips.rb:

2013-01-29  Filip Pizlo  <fpizlo@apple.com>

        cloop.rb shouldn't use a method called 'dump' for code generation
        https://bugs.webkit.org/show_bug.cgi?id=108251

        Reviewed by Mark Hahnenberg.
        
        Revert http://trac.webkit.org/changeset/141178 and rename 'dump' to 'clDump'.
        
        Also made trivial build fixes for !ENABLE(JIT).

        * offlineasm/cloop.rb:
        * runtime/Executable.h:
        (ExecutableBase):
        (JSC::ExecutableBase::intrinsicFor):
        * runtime/JSGlobalData.h:

2013-01-29  Geoffrey Garen  <ggaren@apple.com>

        Removed GGC because it has been disabled for a long time
        https://bugs.webkit.org/show_bug.cgi?id=108245

        Reviewed by Filip Pizlo.

        * GNUmakefile.list.am:
        * JavaScriptCore.vcxproj/JavaScriptCore.vcxproj:
        * JavaScriptCore.vcxproj/JavaScriptCore.vcxproj.filters:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * dfg/DFGRepatch.cpp:
        (JSC::DFG::emitPutReplaceStub):
        (JSC::DFG::emitPutTransitionStub):
        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::writeBarrier):
        * dfg/DFGSpeculativeJIT.h:
        (SpeculativeJIT):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):
        * heap/CardSet.h: Removed.
        * heap/Heap.cpp:
        (JSC::Heap::markRoots):
        (JSC::Heap::collect):
        * heap/Heap.h:
        (Heap):
        (JSC::Heap::shouldCollect):
        (JSC::Heap::isWriteBarrierEnabled):
        (JSC):
        (JSC::Heap::writeBarrier):
        * heap/MarkedBlock.h:
        (MarkedBlock):
        (JSC):
        * heap/MarkedSpace.cpp:
        (JSC):
        * jit/JITPropertyAccess.cpp:
        (JSC::JIT::emitWriteBarrier):

2013-01-29  Filip Pizlo  <fpizlo@apple.com>

        Remove redundant AST dump method from cloop.rb, since they are already defined in ast.rb
        https://bugs.webkit.org/show_bug.cgi?id=108247

        Reviewed by Oliver Hunt.
        
        Makes offlineasm dumping easier to read and less likely to cause assertion failures.
        Also fixes the strange situation where cloop.rb and ast.rb both defined dump methods,
        but cloop.rb was winning.

        * offlineasm/cloop.rb:

2013-01-29  Mark Hahnenberg  <mhahnenberg@apple.com>

        Objective-C API: JSObjCClassInfo creates reference cycle with JSContext
        https://bugs.webkit.org/show_bug.cgi?id=107839

        Reviewed by Oliver Hunt.

        JSContext has a JSWrapperMap, which has an NSMutableDictionary m_classMap, which has values that 
        are JSObjCClassInfo objects, which have strong references to two JSValue *'s, m_prototype and 
        m_constructor, which in turn have strong references to the JSContext, creating a reference cycle. 
        We should make m_prototype and m_constructor Weak<JSObject>. This gets rid of the strong reference 
        to the JSContext and also prevents clients from accidentally creating reference cycles by assigning 
        to the prototype of the constructor. If Weak<JSObject> fields are ever garbage collected, we will 
        reallocate them.

        * API/JSContext.mm:
        (-[JSContext wrapperMap]):
        * API/JSContextInternal.h:
        * API/JSWrapperMap.mm:
        (-[JSObjCClassInfo initWithContext:forClass:superClassInfo:]):
        (-[JSObjCClassInfo dealloc]):
        (-[JSObjCClassInfo allocateConstructorAndPrototypeWithSuperClassInfo:]):
        (-[JSObjCClassInfo allocateConstructorAndPrototype]):
        (-[JSObjCClassInfo wrapperForObject:]):
        (-[JSObjCClassInfo constructor]):

2013-01-29  Oliver Hunt  <oliver@apple.com>

        REGRESSION (r140594): RELEASE_ASSERT_NOT_REACHED in JSC::Interpreter::execute
        https://bugs.webkit.org/show_bug.cgi?id=108097

        Reviewed by Geoffrey Garen.

        LiteralParser was accepting a bogus 'var a.b = c' statement

        * runtime/LiteralParser.cpp:
        (JSC::::tryJSONPParse):

2013-01-29  Oliver Hunt  <oliver@apple.com>

        Force debug builds to do bounds checks on contiguous property storage
        https://bugs.webkit.org/show_bug.cgi?id=108212

        Reviewed by Mark Hahnenberg.

        Add a ContiguousData type that we use to represent contiguous property
        storage.  In release builds it is simply a pointer to the correct type,
        but in debug builds it also carries the data length and performs bounds
        checks.  This means we don't have to add as many manual bounds assertions
        when performing operations over contiguous data.

        * dfg/DFGOperations.cpp:
        * runtime/ArrayStorage.h:
        (ArrayStorage):
        (JSC::ArrayStorage::vector):
        * runtime/Butterfly.h:
        (JSC::ContiguousData::ContiguousData):
        (ContiguousData):
        (JSC::ContiguousData::operator[]):
        (JSC::ContiguousData::data):
        (JSC::ContiguousData::length):
        (JSC):
        (JSC::Butterfly::contiguousInt32):
        (Butterfly):
        (JSC::Butterfly::contiguousDouble):
        (JSC::Butterfly::contiguous):
        * runtime/JSArray.cpp:
        (JSC::JSArray::sortNumericVector):
        (ContiguousTypeAccessor):
        (JSC::ContiguousTypeAccessor::getAsValue):
        (JSC::ContiguousTypeAccessor::setWithValue):
        (JSC::ContiguousTypeAccessor::replaceDataReference):
        (JSC):
        (JSC::JSArray::sortCompactedVector):
        (JSC::JSArray::sort):
        (JSC::JSArray::fillArgList):
        (JSC::JSArray::copyToArguments):
        * runtime/JSArray.h:
        (JSArray):
        * runtime/JSObject.cpp:
        (JSC::JSObject::copyButterfly):
        (JSC::JSObject::visitButterfly):
        (JSC::JSObject::createInitialInt32):
        (JSC::JSObject::createInitialDouble):
        (JSC::JSObject::createInitialContiguous):
        (JSC::JSObject::convertUndecidedToInt32):
        (JSC::JSObject::convertUndecidedToDouble):
        (JSC::JSObject::convertUndecidedToContiguous):
        (JSC::JSObject::convertInt32ToDouble):
        (JSC::JSObject::convertInt32ToContiguous):
        (JSC::JSObject::genericConvertDoubleToContiguous):
        (JSC::JSObject::convertDoubleToContiguous):
        (JSC::JSObject::rageConvertDoubleToContiguous):
        (JSC::JSObject::ensureInt32Slow):
        (JSC::JSObject::ensureDoubleSlow):
        (JSC::JSObject::ensureContiguousSlow):
        (JSC::JSObject::rageEnsureContiguousSlow):
        (JSC::JSObject::ensureLengthSlow):
        * runtime/JSObject.h:
        (JSC::JSObject::ensureInt32):
        (JSC::JSObject::ensureDouble):
        (JSC::JSObject::ensureContiguous):
        (JSC::JSObject::rageEnsureContiguous):
        (JSObject):
        (JSC::JSObject::indexingData):
        (JSC::JSObject::currentIndexingData):

2013-01-29  Brent Fulgham  <bfulgham@webkit.org>

        [Windows, WinCairo] Unreviewed build fix after r141050

        * JavaScriptCore.vcxproj/JavaScriptCoreExports.def: Update symbols
        to match JavaScriptCore.vcproj version.

2013-01-29  Allan Sandfeld Jensen  <allan.jensen@digia.com>

        [Qt] Implement GCActivityCallback
        https://bugs.webkit.org/show_bug.cgi?id=103998

        Reviewed by Simon Hausmann.

        Implements the activity triggered garbage collector.

        * runtime/GCActivityCallback.cpp:
        (JSC::DefaultGCActivityCallback::DefaultGCActivityCallback):
        (JSC::DefaultGCActivityCallback::scheduleTimer):
        (JSC::DefaultGCActivityCallback::cancelTimer):
        * runtime/GCActivityCallback.h:
        (GCActivityCallback):
        (DefaultGCActivityCallback):

2013-01-29  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        Compilation warning in JSC
        https://bugs.webkit.org/show_bug.cgi?id=108178

        Reviewed by Kentaro Hara.

        Fixed 'comparison between signed and unsigned integer' warning in JSC::Structure constructor.

        * runtime/Structure.cpp:
        (JSC::Structure::Structure):

2013-01-29  Jocelyn Turcotte  <jocelyn.turcotte@digia.com>

        [Qt] Fix the JSC build on Mac

        Unreviewed, build fix.

        * heap/HeapTimer.h:
        Qt on Mac has USE(CF) true, and should use the CF HeapTimer in that case.

2013-01-29  Allan Sandfeld Jensen  <allan.jensen@digia.com>

        [Qt] Implement IncrementalSweeper and HeapTimer
        https://bugs.webkit.org/show_bug.cgi?id=103996

        Reviewed by Simon Hausmann.

        Implements the incremental sweeping garbage collection for the Qt platform.

        * heap/HeapTimer.cpp:
        (JSC::HeapTimer::HeapTimer):
        (JSC::HeapTimer::~HeapTimer):
        (JSC::HeapTimer::timerEvent):
        (JSC::HeapTimer::synchronize):
        (JSC::HeapTimer::invalidate):
        (JSC::HeapTimer::didStartVMShutdown):
        * heap/HeapTimer.h:
        (HeapTimer):
        * heap/IncrementalSweeper.cpp:
        (JSC::IncrementalSweeper::IncrementalSweeper):
        (JSC::IncrementalSweeper::scheduleTimer):
        * heap/IncrementalSweeper.h:
        (IncrementalSweeper):

2013-01-28  Filip Pizlo  <fpizlo@apple.com>

        DFG should not use a graph that is a vector, Nodes shouldn't move after allocation, and we should always refer to nodes by Node*
        https://bugs.webkit.org/show_bug.cgi?id=106868

        Reviewed by Oliver Hunt.
        
        This adds a pool allocator for Nodes, and uses that instead of a Vector. Changes all
        uses of Node& and NodeIndex to be simply Node*. Nodes no longer have an index except
        for debugging (Node::index(), which is not guaranteed to be O(1)).
        
        1% speed-up on SunSpider, presumably because this improves compile times.

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * Target.pri:
        * bytecode/DataFormat.h:
        (JSC::dataFormatToString):
        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::initialize):
        (JSC::DFG::AbstractState::booleanResult):
        (JSC::DFG::AbstractState::execute):
        (JSC::DFG::AbstractState::mergeStateAtTail):
        (JSC::DFG::AbstractState::mergeToSuccessors):
        (JSC::DFG::AbstractState::mergeVariableBetweenBlocks):
        (JSC::DFG::AbstractState::dump):
        * dfg/DFGAbstractState.h:
        (DFG):
        (JSC::DFG::AbstractState::forNode):
        (AbstractState):
        (JSC::DFG::AbstractState::speculateInt32Unary):
        (JSC::DFG::AbstractState::speculateNumberUnary):
        (JSC::DFG::AbstractState::speculateBooleanUnary):
        (JSC::DFG::AbstractState::speculateInt32Binary):
        (JSC::DFG::AbstractState::speculateNumberBinary):
        (JSC::DFG::AbstractState::trySetConstant):
        * dfg/DFGAbstractValue.h:
        (AbstractValue):
        * dfg/DFGAdjacencyList.h:
        (JSC::DFG::AdjacencyList::AdjacencyList):
        (JSC::DFG::AdjacencyList::initialize):
        * dfg/DFGAllocator.h: Added.
        (DFG):
        (Allocator):
        (JSC::DFG::Allocator::Region::size):
        (JSC::DFG::Allocator::Region::headerSize):
        (JSC::DFG::Allocator::Region::numberOfThingsPerRegion):
        (JSC::DFG::Allocator::Region::data):
        (JSC::DFG::Allocator::Region::isInThisRegion):
        (JSC::DFG::Allocator::Region::regionFor):
        (Region):
        (JSC::DFG::::Allocator):
        (JSC::DFG::::~Allocator):
        (JSC::DFG::::allocate):
        (JSC::DFG::::free):
        (JSC::DFG::::freeAll):
        (JSC::DFG::::reset):
        (JSC::DFG::::indexOf):
        (JSC::DFG::::allocatorOf):
        (JSC::DFG::::bumpAllocate):
        (JSC::DFG::::freeListAllocate):
        (JSC::DFG::::allocateSlow):
        (JSC::DFG::::freeRegionsStartingAt):
        (JSC::DFG::::startBumpingIn):
        * dfg/DFGArgumentsSimplificationPhase.cpp:
        (JSC::DFG::ArgumentsSimplificationPhase::run):
        (JSC::DFG::ArgumentsSimplificationPhase::observeBadArgumentsUse):
        (JSC::DFG::ArgumentsSimplificationPhase::observeBadArgumentsUses):
        (JSC::DFG::ArgumentsSimplificationPhase::observeProperArgumentsUse):
        (JSC::DFG::ArgumentsSimplificationPhase::isOKToOptimize):
        (JSC::DFG::ArgumentsSimplificationPhase::removeArgumentsReferencingPhantomChild):
        * dfg/DFGArrayMode.cpp:
        (JSC::DFG::ArrayMode::originalArrayStructure):
        (JSC::DFG::ArrayMode::alreadyChecked):
        * dfg/DFGArrayMode.h:
        (ArrayMode):
        * dfg/DFGArrayifySlowPathGenerator.h:
        (JSC::DFG::ArrayifySlowPathGenerator::ArrayifySlowPathGenerator):
        * dfg/DFGBasicBlock.h:
        (JSC::DFG::BasicBlock::node):
        (JSC::DFG::BasicBlock::isInPhis):
        (JSC::DFG::BasicBlock::isInBlock):
        (BasicBlock):
        * dfg/DFGBasicBlockInlines.h:
        (DFG):
        * dfg/DFGByteCodeParser.cpp:
        (ByteCodeParser):
        (JSC::DFG::ByteCodeParser::getDirect):
        (JSC::DFG::ByteCodeParser::get):
        (JSC::DFG::ByteCodeParser::setDirect):
        (JSC::DFG::ByteCodeParser::set):
        (JSC::DFG::ByteCodeParser::setPair):
        (JSC::DFG::ByteCodeParser::injectLazyOperandSpeculation):
        (JSC::DFG::ByteCodeParser::getLocal):
        (JSC::DFG::ByteCodeParser::setLocal):
        (JSC::DFG::ByteCodeParser::getArgument):
        (JSC::DFG::ByteCodeParser::setArgument):
        (JSC::DFG::ByteCodeParser::flushDirect):
        (JSC::DFG::ByteCodeParser::getToInt32):
        (JSC::DFG::ByteCodeParser::toInt32):
        (JSC::DFG::ByteCodeParser::getJSConstantForValue):
        (JSC::DFG::ByteCodeParser::getJSConstant):
        (JSC::DFG::ByteCodeParser::getCallee):
        (JSC::DFG::ByteCodeParser::getThis):
        (JSC::DFG::ByteCodeParser::setThis):
        (JSC::DFG::ByteCodeParser::isJSConstant):
        (JSC::DFG::ByteCodeParser::isInt32Constant):
        (JSC::DFG::ByteCodeParser::valueOfJSConstant):
        (JSC::DFG::ByteCodeParser::valueOfInt32Constant):
        (JSC::DFG::ByteCodeParser::constantUndefined):
        (JSC::DFG::ByteCodeParser::constantNull):
        (JSC::DFG::ByteCodeParser::one):
        (JSC::DFG::ByteCodeParser::constantNaN):
        (JSC::DFG::ByteCodeParser::cellConstant):
        (JSC::DFG::ByteCodeParser::addToGraph):
        (JSC::DFG::ByteCodeParser::insertPhiNode):
        (JSC::DFG::ByteCodeParser::addVarArgChild):
        (JSC::DFG::ByteCodeParser::addCall):
        (JSC::DFG::ByteCodeParser::addStructureTransitionCheck):
        (JSC::DFG::ByteCodeParser::getPredictionWithoutOSRExit):
        (JSC::DFG::ByteCodeParser::getPrediction):
        (JSC::DFG::ByteCodeParser::getArrayModeAndEmitChecks):
        (JSC::DFG::ByteCodeParser::makeSafe):
        (JSC::DFG::ByteCodeParser::makeDivSafe):
        (JSC::DFG::ByteCodeParser::ConstantRecord::ConstantRecord):
        (ConstantRecord):
        (JSC::DFG::ByteCodeParser::PhiStackEntry::PhiStackEntry):
        (PhiStackEntry):
        (JSC::DFG::ByteCodeParser::handleCall):
        (JSC::DFG::ByteCodeParser::emitFunctionChecks):
        (JSC::DFG::ByteCodeParser::handleInlining):
        (JSC::DFG::ByteCodeParser::setIntrinsicResult):
        (JSC::DFG::ByteCodeParser::handleMinMax):
        (JSC::DFG::ByteCodeParser::handleIntrinsic):
        (JSC::DFG::ByteCodeParser::handleGetByOffset):
        (JSC::DFG::ByteCodeParser::handleGetById):
        (JSC::DFG::ByteCodeParser::getScope):
        (JSC::DFG::ByteCodeParser::parseResolveOperations):
        (JSC::DFG::ByteCodeParser::parseBlock):
        (JSC::DFG::ByteCodeParser::processPhiStack):
        (JSC::DFG::ByteCodeParser::linkBlock):
        (JSC::DFG::ByteCodeParser::parseCodeBlock):
        (JSC::DFG::ByteCodeParser::parse):
        * dfg/DFGCFAPhase.cpp:
        (JSC::DFG::CFAPhase::performBlockCFA):
        * dfg/DFGCFGSimplificationPhase.cpp:
        (JSC::DFG::CFGSimplificationPhase::run):
        (JSC::DFG::CFGSimplificationPhase::keepOperandAlive):
        (JSC::DFG::CFGSimplificationPhase::fixPossibleGetLocal):
        (JSC::DFG::CFGSimplificationPhase::fixPhis):
        (JSC::DFG::CFGSimplificationPhase::removePotentiallyDeadPhiReference):
        (JSC::DFG::CFGSimplificationPhase::OperandSubstitution::OperandSubstitution):
        (JSC::DFG::CFGSimplificationPhase::OperandSubstitution::dump):
        (OperandSubstitution):
        (JSC::DFG::CFGSimplificationPhase::skipGetLocal):
        (JSC::DFG::CFGSimplificationPhase::recordNewTarget):
        (JSC::DFG::CFGSimplificationPhase::fixTailOperand):
        (JSC::DFG::CFGSimplificationPhase::mergeBlocks):
        * dfg/DFGCSEPhase.cpp:
        (JSC::DFG::CSEPhase::canonicalize):
        (JSC::DFG::CSEPhase::endIndexForPureCSE):
        (JSC::DFG::CSEPhase::pureCSE):
        (JSC::DFG::CSEPhase::constantCSE):
        (JSC::DFG::CSEPhase::weakConstantCSE):
        (JSC::DFG::CSEPhase::getCalleeLoadElimination):
        (JSC::DFG::CSEPhase::getArrayLengthElimination):
        (JSC::DFG::CSEPhase::globalVarLoadElimination):
        (JSC::DFG::CSEPhase::scopedVarLoadElimination):
        (JSC::DFG::CSEPhase::globalVarWatchpointElimination):
        (JSC::DFG::CSEPhase::globalVarStoreElimination):
        (JSC::DFG::CSEPhase::scopedVarStoreElimination):
        (JSC::DFG::CSEPhase::getByValLoadElimination):
        (JSC::DFG::CSEPhase::checkFunctionElimination):
        (JSC::DFG::CSEPhase::checkExecutableElimination):
        (JSC::DFG::CSEPhase::checkStructureElimination):
        (JSC::DFG::CSEPhase::structureTransitionWatchpointElimination):
        (JSC::DFG::CSEPhase::putStructureStoreElimination):
        (JSC::DFG::CSEPhase::getByOffsetLoadElimination):
        (JSC::DFG::CSEPhase::putByOffsetStoreElimination):
        (JSC::DFG::CSEPhase::getPropertyStorageLoadElimination):
        (JSC::DFG::CSEPhase::checkArrayElimination):
        (JSC::DFG::CSEPhase::getIndexedPropertyStorageLoadElimination):
        (JSC::DFG::CSEPhase::getMyScopeLoadElimination):
        (JSC::DFG::CSEPhase::getLocalLoadElimination):
        (JSC::DFG::CSEPhase::setLocalStoreElimination):
        (JSC::DFG::CSEPhase::performSubstitution):
        (JSC::DFG::CSEPhase::eliminateIrrelevantPhantomChildren):
        (JSC::DFG::CSEPhase::setReplacement):
        (JSC::DFG::CSEPhase::eliminate):
        (JSC::DFG::CSEPhase::performNodeCSE):
        (JSC::DFG::CSEPhase::performBlockCSE):
        (CSEPhase):
        * dfg/DFGCommon.cpp: Added.
        (DFG):
        (JSC::DFG::NodePointerTraits::dump):
        * dfg/DFGCommon.h:
        (DFG):
        (JSC::DFG::NodePointerTraits::defaultValue):
        (NodePointerTraits):
        (JSC::DFG::verboseCompilationEnabled):
        (JSC::DFG::shouldDumpGraphAtEachPhase):
        (JSC::DFG::validationEnabled):
        * dfg/DFGConstantFoldingPhase.cpp:
        (JSC::DFG::ConstantFoldingPhase::foldConstants):
        (JSC::DFG::ConstantFoldingPhase::isCapturedAtOrAfter):
        (JSC::DFG::ConstantFoldingPhase::addStructureTransitionCheck):
        (JSC::DFG::ConstantFoldingPhase::paintUnreachableCode):
        * dfg/DFGDisassembler.cpp:
        (JSC::DFG::Disassembler::Disassembler):
        (JSC::DFG::Disassembler::createDumpList):
        (JSC::DFG::Disassembler::dumpDisassembly):
        * dfg/DFGDisassembler.h:
        (JSC::DFG::Disassembler::setForNode):
        (Disassembler):
        * dfg/DFGDriver.cpp:
        (JSC::DFG::compile):
        * dfg/DFGEdge.cpp: Added.
        (DFG):
        (JSC::DFG::Edge::dump):
        * dfg/DFGEdge.h:
        (JSC::DFG::Edge::Edge):
        (JSC::DFG::Edge::node):
        (JSC::DFG::Edge::operator*):
        (JSC::DFG::Edge::operator->):
        (Edge):
        (JSC::DFG::Edge::setNode):
        (JSC::DFG::Edge::useKind):
        (JSC::DFG::Edge::setUseKind):
        (JSC::DFG::Edge::isSet):
        (JSC::DFG::Edge::shift):
        (JSC::DFG::Edge::makeWord):
        (JSC::DFG::operator==):
        (JSC::DFG::operator!=):
        * dfg/DFGFixupPhase.cpp:
        (JSC::DFG::FixupPhase::fixupBlock):
        (JSC::DFG::FixupPhase::fixupNode):
        (JSC::DFG::FixupPhase::checkArray):
        (JSC::DFG::FixupPhase::blessArrayOperation):
        (JSC::DFG::FixupPhase::fixIntEdge):
        (JSC::DFG::FixupPhase::fixDoubleEdge):
        (JSC::DFG::FixupPhase::injectInt32ToDoubleNode):
        (FixupPhase):
        * dfg/DFGGenerationInfo.h:
        (JSC::DFG::GenerationInfo::GenerationInfo):
        (JSC::DFG::GenerationInfo::initConstant):
        (JSC::DFG::GenerationInfo::initInteger):
        (JSC::DFG::GenerationInfo::initJSValue):
        (JSC::DFG::GenerationInfo::initCell):
        (JSC::DFG::GenerationInfo::initBoolean):
        (JSC::DFG::GenerationInfo::initDouble):
        (JSC::DFG::GenerationInfo::initStorage):
        (GenerationInfo):
        (JSC::DFG::GenerationInfo::node):
        (JSC::DFG::GenerationInfo::noticeOSRBirth):
        (JSC::DFG::GenerationInfo::use):
        (JSC::DFG::GenerationInfo::appendFill):
        (JSC::DFG::GenerationInfo::appendSpill):
        * dfg/DFGGraph.cpp:
        (JSC::DFG::Graph::Graph):
        (JSC::DFG::Graph::~Graph):
        (DFG):
        (JSC::DFG::Graph::dumpCodeOrigin):
        (JSC::DFG::Graph::amountOfNodeWhiteSpace):
        (JSC::DFG::Graph::printNodeWhiteSpace):
        (JSC::DFG::Graph::dump):
        (JSC::DFG::Graph::dumpBlockHeader):
        (JSC::DFG::Graph::refChildren):
        (JSC::DFG::Graph::derefChildren):
        (JSC::DFG::Graph::predictArgumentTypes):
        (JSC::DFG::Graph::collectGarbage):
        (JSC::DFG::Graph::determineReachability):
        (JSC::DFG::Graph::resetExitStates):
        * dfg/DFGGraph.h:
        (Graph):
        (JSC::DFG::Graph::ref):
        (JSC::DFG::Graph::deref):
        (JSC::DFG::Graph::changeChild):
        (JSC::DFG::Graph::compareAndSwap):
        (JSC::DFG::Graph::clearAndDerefChild):
        (JSC::DFG::Graph::clearAndDerefChild1):
        (JSC::DFG::Graph::clearAndDerefChild2):
        (JSC::DFG::Graph::clearAndDerefChild3):
        (JSC::DFG::Graph::convertToConstant):
        (JSC::DFG::Graph::getJSConstantSpeculation):
        (JSC::DFG::Graph::addSpeculationMode):
        (JSC::DFG::Graph::valueAddSpeculationMode):
        (JSC::DFG::Graph::arithAddSpeculationMode):
        (JSC::DFG::Graph::addShouldSpeculateInteger):
        (JSC::DFG::Graph::mulShouldSpeculateInteger):
        (JSC::DFG::Graph::negateShouldSpeculateInteger):
        (JSC::DFG::Graph::isConstant):
        (JSC::DFG::Graph::isJSConstant):
        (JSC::DFG::Graph::isInt32Constant):
        (JSC::DFG::Graph::isDoubleConstant):
        (JSC::DFG::Graph::isNumberConstant):
        (JSC::DFG::Graph::isBooleanConstant):
        (JSC::DFG::Graph::isCellConstant):
        (JSC::DFG::Graph::isFunctionConstant):
        (JSC::DFG::Graph::isInternalFunctionConstant):
        (JSC::DFG::Graph::valueOfJSConstant):
        (JSC::DFG::Graph::valueOfInt32Constant):
        (JSC::DFG::Graph::valueOfNumberConstant):
        (JSC::DFG::Graph::valueOfBooleanConstant):
        (JSC::DFG::Graph::valueOfFunctionConstant):
        (JSC::DFG::Graph::valueProfileFor):
        (JSC::DFG::Graph::methodOfGettingAValueProfileFor):
        (JSC::DFG::Graph::numSuccessors):
        (JSC::DFG::Graph::successor):
        (JSC::DFG::Graph::successorForCondition):
        (JSC::DFG::Graph::isPredictedNumerical):
        (JSC::DFG::Graph::byValIsPure):
        (JSC::DFG::Graph::clobbersWorld):
        (JSC::DFG::Graph::varArgNumChildren):
        (JSC::DFG::Graph::numChildren):
        (JSC::DFG::Graph::varArgChild):
        (JSC::DFG::Graph::child):
        (JSC::DFG::Graph::voteNode):
        (JSC::DFG::Graph::voteChildren):
        (JSC::DFG::Graph::substitute):
        (JSC::DFG::Graph::substituteGetLocal):
        (JSC::DFG::Graph::addImmediateShouldSpeculateInteger):
        (JSC::DFG::Graph::mulImmediateShouldSpeculateInteger):
        * dfg/DFGInsertionSet.h:
        (JSC::DFG::Insertion::Insertion):
        (JSC::DFG::Insertion::element):
        (Insertion):
        (JSC::DFG::InsertionSet::insert):
        (InsertionSet):
        * dfg/DFGJITCompiler.cpp:
        * dfg/DFGJITCompiler.h:
        (JSC::DFG::JITCompiler::setForNode):
        (JSC::DFG::JITCompiler::addressOfDoubleConstant):
        (JSC::DFG::JITCompiler::noticeOSREntry):
        * dfg/DFGLongLivedState.cpp: Added.
        (DFG):
        (JSC::DFG::LongLivedState::LongLivedState):
        (JSC::DFG::LongLivedState::~LongLivedState):
        (JSC::DFG::LongLivedState::shrinkToFit):
        * dfg/DFGLongLivedState.h: Added.
        (DFG):
        (LongLivedState):
        * dfg/DFGMinifiedID.h:
        (JSC::DFG::MinifiedID::MinifiedID):
        (JSC::DFG::MinifiedID::node):
        * dfg/DFGMinifiedNode.cpp:
        (JSC::DFG::MinifiedNode::fromNode):
        * dfg/DFGMinifiedNode.h:
        (MinifiedNode):
        * dfg/DFGNode.cpp: Added.
        (DFG):
        (JSC::DFG::Node::index):
        (WTF):
        (WTF::printInternal):
        * dfg/DFGNode.h:
        (DFG):
        (JSC::DFG::Node::Node):
        (Node):
        (JSC::DFG::Node::convertToGetByOffset):
        (JSC::DFG::Node::convertToPutByOffset):
        (JSC::DFG::Node::ref):
        (JSC::DFG::Node::shouldSpeculateInteger):
        (JSC::DFG::Node::shouldSpeculateIntegerForArithmetic):
        (JSC::DFG::Node::shouldSpeculateIntegerExpectingDefined):
        (JSC::DFG::Node::shouldSpeculateDoubleForArithmetic):
        (JSC::DFG::Node::shouldSpeculateNumber):
        (JSC::DFG::Node::shouldSpeculateNumberExpectingDefined):
        (JSC::DFG::Node::shouldSpeculateFinalObject):
        (JSC::DFG::Node::shouldSpeculateArray):
        (JSC::DFG::Node::dumpChildren):
        (WTF):
        * dfg/DFGNodeAllocator.h: Added.
        (DFG):
        (operator new ):
        * dfg/DFGOSRExit.cpp:
        (JSC::DFG::OSRExit::OSRExit):
        * dfg/DFGOSRExit.h:
        (OSRExit):
        (SpeculationFailureDebugInfo):
        * dfg/DFGOSRExitCompiler.cpp:
        * dfg/DFGOSRExitCompiler32_64.cpp:
        (JSC::DFG::OSRExitCompiler::compileExit):
        * dfg/DFGOSRExitCompiler64.cpp:
        (JSC::DFG::OSRExitCompiler::compileExit):
        * dfg/DFGOperations.cpp:
        * dfg/DFGPhase.cpp:
        (DFG):
        (JSC::DFG::Phase::beginPhase):
        (JSC::DFG::Phase::endPhase):
        * dfg/DFGPhase.h:
        (Phase):
        (JSC::DFG::runAndLog):
        * dfg/DFGPredictionPropagationPhase.cpp:
        (JSC::DFG::PredictionPropagationPhase::setPrediction):
        (JSC::DFG::PredictionPropagationPhase::mergePrediction):
        (JSC::DFG::PredictionPropagationPhase::isNotNegZero):
        (JSC::DFG::PredictionPropagationPhase::isNotZero):
        (JSC::DFG::PredictionPropagationPhase::isWithinPowerOfTwoForConstant):
        (JSC::DFG::PredictionPropagationPhase::isWithinPowerOfTwoNonRecursive):
        (JSC::DFG::PredictionPropagationPhase::isWithinPowerOfTwo):
        (JSC::DFG::PredictionPropagationPhase::propagate):
        (JSC::DFG::PredictionPropagationPhase::mergeDefaultFlags):
        (JSC::DFG::PredictionPropagationPhase::propagateForward):
        (JSC::DFG::PredictionPropagationPhase::propagateBackward):
        (JSC::DFG::PredictionPropagationPhase::doDoubleVoting):
        (PredictionPropagationPhase):
        (JSC::DFG::PredictionPropagationPhase::doRoundOfDoubleVoting):
        * dfg/DFGScoreBoard.h:
        (JSC::DFG::ScoreBoard::ScoreBoard):
        (JSC::DFG::ScoreBoard::use):
        (JSC::DFG::ScoreBoard::useIfHasResult):
        (ScoreBoard):
        * dfg/DFGSilentRegisterSavePlan.h:
        (JSC::DFG::SilentRegisterSavePlan::SilentRegisterSavePlan):
        (JSC::DFG::SilentRegisterSavePlan::node):
        (SilentRegisterSavePlan):
        * dfg/DFGSlowPathGenerator.h:
        (JSC::DFG::SlowPathGenerator::SlowPathGenerator):
        (JSC::DFG::SlowPathGenerator::generate):
        (SlowPathGenerator):
        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::SpeculativeJIT):
        (JSC::DFG::SpeculativeJIT::speculationCheck):
        (JSC::DFG::SpeculativeJIT::speculationWatchpoint):
        (JSC::DFG::SpeculativeJIT::convertLastOSRExitToForward):
        (JSC::DFG::SpeculativeJIT::forwardSpeculationCheck):
        (JSC::DFG::SpeculativeJIT::terminateSpeculativeExecution):
        (JSC::DFG::SpeculativeJIT::silentSavePlanForGPR):
        (JSC::DFG::SpeculativeJIT::silentSavePlanForFPR):
        (JSC::DFG::SpeculativeJIT::silentSpill):
        (JSC::DFG::SpeculativeJIT::silentFill):
        (JSC::DFG::SpeculativeJIT::checkArray):
        (JSC::DFG::SpeculativeJIT::arrayify):
        (JSC::DFG::SpeculativeJIT::fillStorage):
        (JSC::DFG::SpeculativeJIT::useChildren):
        (JSC::DFG::SpeculativeJIT::isStrictInt32):
        (JSC::DFG::SpeculativeJIT::isKnownInteger):
        (JSC::DFG::SpeculativeJIT::isKnownNumeric):
        (JSC::DFG::SpeculativeJIT::isKnownCell):
        (JSC::DFG::SpeculativeJIT::isKnownNotCell):
        (JSC::DFG::SpeculativeJIT::isKnownNotInteger):
        (JSC::DFG::SpeculativeJIT::isKnownNotNumber):
        (JSC::DFG::SpeculativeJIT::writeBarrier):
        (JSC::DFG::SpeculativeJIT::nonSpeculativeCompare):
        (JSC::DFG::SpeculativeJIT::nonSpeculativeStrictEq):
        (JSC::DFG::GPRTemporary::GPRTemporary):
        (JSC::DFG::FPRTemporary::FPRTemporary):
        (JSC::DFG::SpeculativeJIT::compilePeepHoleDoubleBranch):
        (JSC::DFG::SpeculativeJIT::compilePeepHoleObjectEquality):
        (JSC::DFG::SpeculativeJIT::compilePeepHoleIntegerBranch):
        (JSC::DFG::SpeculativeJIT::compilePeepHoleBranch):
        (JSC::DFG::SpeculativeJIT::noticeOSRBirth):
        (JSC::DFG::SpeculativeJIT::compileMovHint):
        (JSC::DFG::SpeculativeJIT::compile):
        (JSC::DFG::SpeculativeJIT::checkArgumentTypes):
        (JSC::DFG::SpeculativeJIT::computeValueRecoveryFor):
        (JSC::DFG::SpeculativeJIT::compileDoublePutByVal):
        (JSC::DFG::SpeculativeJIT::compileGetCharCodeAt):
        (JSC::DFG::SpeculativeJIT::compileGetByValOnString):
        (JSC::DFG::SpeculativeJIT::checkGeneratedTypeForToInt32):
        (JSC::DFG::SpeculativeJIT::compileValueToInt32):
        (JSC::DFG::SpeculativeJIT::compileUInt32ToNumber):
        (JSC::DFG::SpeculativeJIT::compileDoubleAsInt32):
        (JSC::DFG::SpeculativeJIT::compileInt32ToDouble):
        (JSC::DFG::SpeculativeJIT::compileGetByValOnIntTypedArray):
        (JSC::DFG::SpeculativeJIT::compilePutByValForIntTypedArray):
        (JSC::DFG::SpeculativeJIT::compileGetByValOnFloatTypedArray):
        (JSC::DFG::SpeculativeJIT::compilePutByValForFloatTypedArray):
        (JSC::DFG::SpeculativeJIT::compileInstanceOfForObject):
        (JSC::DFG::SpeculativeJIT::compileInstanceOf):
        (JSC::DFG::SpeculativeJIT::compileSoftModulo):
        (JSC::DFG::SpeculativeJIT::compileAdd):
        (JSC::DFG::SpeculativeJIT::compileArithSub):
        (JSC::DFG::SpeculativeJIT::compileArithNegate):
        (JSC::DFG::SpeculativeJIT::compileArithMul):
        (JSC::DFG::SpeculativeJIT::compileIntegerArithDivForX86):
        (JSC::DFG::SpeculativeJIT::compileArithMod):
        (JSC::DFG::SpeculativeJIT::compare):
        (JSC::DFG::SpeculativeJIT::compileStrictEqForConstant):
        (JSC::DFG::SpeculativeJIT::compileStrictEq):
        (JSC::DFG::SpeculativeJIT::compileGetIndexedPropertyStorage):
        (JSC::DFG::SpeculativeJIT::compileGetByValOnArguments):
        (JSC::DFG::SpeculativeJIT::compileGetArgumentsLength):
        (JSC::DFG::SpeculativeJIT::compileGetArrayLength):
        (JSC::DFG::SpeculativeJIT::compileNewFunctionNoCheck):
        (JSC::DFG::SpeculativeJIT::compileNewFunctionExpression):
        (JSC::DFG::SpeculativeJIT::compileRegExpExec):
        (JSC::DFG::SpeculativeJIT::compileAllocatePropertyStorage):
        (JSC::DFG::SpeculativeJIT::compileReallocatePropertyStorage):
        * dfg/DFGSpeculativeJIT.h:
        (SpeculativeJIT):
        (JSC::DFG::SpeculativeJIT::canReuse):
        (JSC::DFG::SpeculativeJIT::isFilled):
        (JSC::DFG::SpeculativeJIT::isFilledDouble):
        (JSC::DFG::SpeculativeJIT::use):
        (JSC::DFG::SpeculativeJIT::isConstant):
        (JSC::DFG::SpeculativeJIT::isJSConstant):
        (JSC::DFG::SpeculativeJIT::isInt32Constant):
        (JSC::DFG::SpeculativeJIT::isDoubleConstant):
        (JSC::DFG::SpeculativeJIT::isNumberConstant):
        (JSC::DFG::SpeculativeJIT::isBooleanConstant):
        (JSC::DFG::SpeculativeJIT::isFunctionConstant):
        (JSC::DFG::SpeculativeJIT::valueOfInt32Constant):
        (JSC::DFG::SpeculativeJIT::valueOfNumberConstant):
        (JSC::DFG::SpeculativeJIT::valueOfNumberConstantAsInt32):
        (JSC::DFG::SpeculativeJIT::addressOfDoubleConstant):
        (JSC::DFG::SpeculativeJIT::valueOfJSConstant):
        (JSC::DFG::SpeculativeJIT::valueOfBooleanConstant):
        (JSC::DFG::SpeculativeJIT::valueOfFunctionConstant):
        (JSC::DFG::SpeculativeJIT::isNullConstant):
        (JSC::DFG::SpeculativeJIT::valueOfJSConstantAsImm64):
        (JSC::DFG::SpeculativeJIT::detectPeepHoleBranch):
        (JSC::DFG::SpeculativeJIT::integerResult):
        (JSC::DFG::SpeculativeJIT::noResult):
        (JSC::DFG::SpeculativeJIT::cellResult):
        (JSC::DFG::SpeculativeJIT::booleanResult):
        (JSC::DFG::SpeculativeJIT::jsValueResult):
        (JSC::DFG::SpeculativeJIT::storageResult):
        (JSC::DFG::SpeculativeJIT::doubleResult):
        (JSC::DFG::SpeculativeJIT::initConstantInfo):
        (JSC::DFG::SpeculativeJIT::appendCallWithExceptionCheck):
        (JSC::DFG::SpeculativeJIT::isInteger):
        (JSC::DFG::SpeculativeJIT::temporaryRegisterForPutByVal):
        (JSC::DFG::SpeculativeJIT::emitAllocateBasicStorage):
        (JSC::DFG::SpeculativeJIT::setNodeForOperand):
        (JSC::DFG::IntegerOperand::IntegerOperand):
        (JSC::DFG::IntegerOperand::node):
        (JSC::DFG::IntegerOperand::gpr):
        (JSC::DFG::IntegerOperand::use):
        (IntegerOperand):
        (JSC::DFG::DoubleOperand::DoubleOperand):
        (JSC::DFG::DoubleOperand::node):
        (JSC::DFG::DoubleOperand::fpr):
        (JSC::DFG::DoubleOperand::use):
        (DoubleOperand):
        (JSC::DFG::JSValueOperand::JSValueOperand):
        (JSC::DFG::JSValueOperand::node):
        (JSC::DFG::JSValueOperand::gpr):
        (JSC::DFG::JSValueOperand::fill):
        (JSC::DFG::JSValueOperand::use):
        (JSValueOperand):
        (JSC::DFG::StorageOperand::StorageOperand):
        (JSC::DFG::StorageOperand::node):
        (JSC::DFG::StorageOperand::gpr):
        (JSC::DFG::StorageOperand::use):
        (StorageOperand):
        (JSC::DFG::SpeculateIntegerOperand::SpeculateIntegerOperand):
        (JSC::DFG::SpeculateIntegerOperand::node):
        (JSC::DFG::SpeculateIntegerOperand::gpr):
        (JSC::DFG::SpeculateIntegerOperand::use):
        (SpeculateIntegerOperand):
        (JSC::DFG::SpeculateStrictInt32Operand::SpeculateStrictInt32Operand):
        (JSC::DFG::SpeculateStrictInt32Operand::node):
        (JSC::DFG::SpeculateStrictInt32Operand::gpr):
        (JSC::DFG::SpeculateStrictInt32Operand::use):
        (SpeculateStrictInt32Operand):
        (JSC::DFG::SpeculateDoubleOperand::SpeculateDoubleOperand):
        (JSC::DFG::SpeculateDoubleOperand::node):
        (JSC::DFG::SpeculateDoubleOperand::fpr):
        (JSC::DFG::SpeculateDoubleOperand::use):
        (SpeculateDoubleOperand):
        (JSC::DFG::SpeculateCellOperand::SpeculateCellOperand):
        (JSC::DFG::SpeculateCellOperand::node):
        (JSC::DFG::SpeculateCellOperand::gpr):
        (JSC::DFG::SpeculateCellOperand::use):
        (SpeculateCellOperand):
        (JSC::DFG::SpeculateBooleanOperand::SpeculateBooleanOperand):
        (JSC::DFG::SpeculateBooleanOperand::node):
        (JSC::DFG::SpeculateBooleanOperand::gpr):
        (JSC::DFG::SpeculateBooleanOperand::use):
        (SpeculateBooleanOperand):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::fillInteger):
        (JSC::DFG::SpeculativeJIT::fillDouble):
        (JSC::DFG::SpeculativeJIT::fillJSValue):
        (JSC::DFG::SpeculativeJIT::nonSpeculativeValueToNumber):
        (JSC::DFG::SpeculativeJIT::nonSpeculativeValueToInt32):
        (JSC::DFG::SpeculativeJIT::nonSpeculativeUInt32ToNumber):
        (JSC::DFG::SpeculativeJIT::cachedPutById):
        (JSC::DFG::SpeculativeJIT::nonSpeculativeNonPeepholeCompareNull):
        (JSC::DFG::SpeculativeJIT::nonSpeculativePeepholeBranchNull):
        (JSC::DFG::SpeculativeJIT::nonSpeculativeCompareNull):
        (JSC::DFG::SpeculativeJIT::nonSpeculativePeepholeBranch):
        (JSC::DFG::SpeculativeJIT::nonSpeculativeNonPeepholeCompare):
        (JSC::DFG::SpeculativeJIT::nonSpeculativePeepholeStrictEq):
        (JSC::DFG::SpeculativeJIT::nonSpeculativeNonPeepholeStrictEq):
        (JSC::DFG::SpeculativeJIT::emitCall):
        (JSC::DFG::SpeculativeJIT::fillSpeculateIntInternal):
        (JSC::DFG::SpeculativeJIT::fillSpeculateInt):
        (JSC::DFG::SpeculativeJIT::fillSpeculateIntStrict):
        (JSC::DFG::SpeculativeJIT::fillSpeculateDouble):
        (JSC::DFG::SpeculativeJIT::fillSpeculateCell):
        (JSC::DFG::SpeculativeJIT::fillSpeculateBoolean):
        (JSC::DFG::SpeculativeJIT::compileObjectEquality):
        (JSC::DFG::SpeculativeJIT::compileObjectToObjectOrOtherEquality):
        (JSC::DFG::SpeculativeJIT::compilePeepHoleObjectToObjectOrOtherEquality):
        (JSC::DFG::SpeculativeJIT::compileIntegerCompare):
        (JSC::DFG::SpeculativeJIT::compileDoubleCompare):
        (JSC::DFG::SpeculativeJIT::compileValueAdd):
        (JSC::DFG::SpeculativeJIT::compileNonStringCellOrOtherLogicalNot):
        (JSC::DFG::SpeculativeJIT::compileLogicalNot):
        (JSC::DFG::SpeculativeJIT::emitNonStringCellOrOtherBranch):
        (JSC::DFG::SpeculativeJIT::emitBranch):
        (JSC::DFG::SpeculativeJIT::compileContiguousPutByVal):
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::fillInteger):
        (JSC::DFG::SpeculativeJIT::fillDouble):
        (JSC::DFG::SpeculativeJIT::fillJSValue):
        (JSC::DFG::SpeculativeJIT::nonSpeculativeValueToNumber):
        (JSC::DFG::SpeculativeJIT::nonSpeculativeValueToInt32):
        (JSC::DFG::SpeculativeJIT::nonSpeculativeUInt32ToNumber):
        (JSC::DFG::SpeculativeJIT::cachedPutById):
        (JSC::DFG::SpeculativeJIT::nonSpeculativeNonPeepholeCompareNull):
        (JSC::DFG::SpeculativeJIT::nonSpeculativePeepholeBranchNull):
        (JSC::DFG::SpeculativeJIT::nonSpeculativeCompareNull):
        (JSC::DFG::SpeculativeJIT::nonSpeculativePeepholeBranch):
        (JSC::DFG::SpeculativeJIT::nonSpeculativeNonPeepholeCompare):
        (JSC::DFG::SpeculativeJIT::nonSpeculativePeepholeStrictEq):
        (JSC::DFG::SpeculativeJIT::nonSpeculativeNonPeepholeStrictEq):
        (JSC::DFG::SpeculativeJIT::emitCall):
        (JSC::DFG::SpeculativeJIT::fillSpeculateIntInternal):
        (JSC::DFG::SpeculativeJIT::fillSpeculateInt):
        (JSC::DFG::SpeculativeJIT::fillSpeculateIntStrict):
        (JSC::DFG::SpeculativeJIT::fillSpeculateDouble):
        (JSC::DFG::SpeculativeJIT::fillSpeculateCell):
        (JSC::DFG::SpeculativeJIT::fillSpeculateBoolean):
        (JSC::DFG::SpeculativeJIT::compileObjectEquality):
        (JSC::DFG::SpeculativeJIT::compileObjectToObjectOrOtherEquality):
        (JSC::DFG::SpeculativeJIT::compilePeepHoleObjectToObjectOrOtherEquality):
        (JSC::DFG::SpeculativeJIT::compileIntegerCompare):
        (JSC::DFG::SpeculativeJIT::compileDoubleCompare):
        (JSC::DFG::SpeculativeJIT::compileValueAdd):
        (JSC::DFG::SpeculativeJIT::compileNonStringCellOrOtherLogicalNot):
        (JSC::DFG::SpeculativeJIT::compileLogicalNot):
        (JSC::DFG::SpeculativeJIT::emitNonStringCellOrOtherBranch):
        (JSC::DFG::SpeculativeJIT::emitBranch):
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGStructureAbstractValue.h:
        (StructureAbstractValue):
        * dfg/DFGStructureCheckHoistingPhase.cpp:
        (JSC::DFG::StructureCheckHoistingPhase::run):
        * dfg/DFGValidate.cpp:
        (DFG):
        (Validate):
        (JSC::DFG::Validate::validate):
        (JSC::DFG::Validate::reportValidationContext):
        * dfg/DFGValidate.h:
        * dfg/DFGValueSource.cpp:
        (JSC::DFG::ValueSource::dump):
        * dfg/DFGValueSource.h:
        (JSC::DFG::ValueSource::ValueSource):
        * dfg/DFGVirtualRegisterAllocationPhase.cpp:
        (JSC::DFG::VirtualRegisterAllocationPhase::run):
        * runtime/FunctionExecutableDump.cpp: Added.
        (JSC):
        (JSC::FunctionExecutableDump::dump):
        * runtime/FunctionExecutableDump.h: Added.
        (JSC):
        (FunctionExecutableDump):
        (JSC::FunctionExecutableDump::FunctionExecutableDump):
        * runtime/JSGlobalData.cpp:
        (JSC::JSGlobalData::JSGlobalData):
        * runtime/JSGlobalData.h:
        (JSC):
        (DFG):
        (JSGlobalData):
        * runtime/Options.h:
        (JSC):

2013-01-28  Laszlo Gombos  <l.gombos@samsung.com>

        Collapse testing for a list of PLATFORM() into OS() and USE() tests
        https://bugs.webkit.org/show_bug.cgi?id=108018

        Reviewed by Eric Seidel.

        No functional change as "OS(DARWIN) && USE(CF)" equals to the
        following platforms: MAC, WX, QT and CHROMIUM. CHROMIUM
        is not using JavaScriptCore. 

        * runtime/DatePrototype.cpp:
        (JSC):

2013-01-28  Geoffrey Garen  <ggaren@apple.com>

        Static size inference for JavaScript objects
        https://bugs.webkit.org/show_bug.cgi?id=108093

        Reviewed by Phil Pizlo.

        * API/JSObjectRef.cpp:
        * JavaScriptCore.order:
        * JavaScriptCore.xcodeproj/project.pbxproj: Pay the tax man.

        * bytecode/CodeBlock.cpp:
        (JSC::CodeBlock::dumpBytecode): op_new_object and op_create_this now
        have an extra inferredInlineCapacity argument. This is the statically
        inferred inline capacity, just from analyzing source text. op_new_object
        also gets a pointer to an allocation profile. (For op_create_this, the
        profile is in the construtor function.)

        (JSC::CodeBlock::CodeBlock): Link op_new_object.

        (JSC::CodeBlock::stronglyVisitStrongReferences): Mark our profiles.

        * bytecode/CodeBlock.h:
        (CodeBlock): Removed some dead code. Added object allocation profiles.

        * bytecode/Instruction.h:
        (JSC): New union type, since an instruction operand may point to an
        object allocation profile now.

        * bytecode/ObjectAllocationProfile.h: Added.
        (JSC):
        (ObjectAllocationProfile):
        (JSC::ObjectAllocationProfile::offsetOfAllocator):
        (JSC::ObjectAllocationProfile::offsetOfStructure):
        (JSC::ObjectAllocationProfile::ObjectAllocationProfile):
        (JSC::ObjectAllocationProfile::isNull):
        (JSC::ObjectAllocationProfile::initialize):
        (JSC::ObjectAllocationProfile::structure):
        (JSC::ObjectAllocationProfile::inlineCapacity):
        (JSC::ObjectAllocationProfile::clear):
        (JSC::ObjectAllocationProfile::visitAggregate):
        (JSC::ObjectAllocationProfile::possibleDefaultPropertyCount): New class
        for tracking a prediction about object allocation: structure, inline
        capacity, allocator to use.

        * bytecode/Opcode.h:
        (JSC):
        (JSC::padOpcodeName): Updated instruction sizes.

        * bytecode/UnlinkedCodeBlock.cpp:
        (JSC::UnlinkedCodeBlock::UnlinkedCodeBlock):
        * bytecode/UnlinkedCodeBlock.h:
        (JSC):
        (JSC::UnlinkedCodeBlock::addObjectAllocationProfile):
        (JSC::UnlinkedCodeBlock::numberOfObjectAllocationProfiles):
        (UnlinkedCodeBlock): Unlinked support for allocation profiles.

        * bytecompiler/BytecodeGenerator.cpp:
        (JSC::BytecodeGenerator::generate): Kill all remaining analyses at the
        end of codegen, since this is our last opportunity.

        (JSC::BytecodeGenerator::BytecodeGenerator): Added a static property
        analyzer to bytecode generation. It tracks initializing assignments and
        makes a guess about how many will happen.

        (JSC::BytecodeGenerator::newObjectAllocationProfile):
        (JSC):
        (JSC::BytecodeGenerator::emitProfiledOpcode):
        (JSC::BytecodeGenerator::emitMove):
        (JSC::BytecodeGenerator::emitResolve):
        (JSC::BytecodeGenerator::emitResolveBase):
        (JSC::BytecodeGenerator::emitResolveBaseForPut):
        (JSC::BytecodeGenerator::emitResolveWithBaseForPut):
        (JSC::BytecodeGenerator::emitResolveWithThis):
        (JSC::BytecodeGenerator::emitGetById):
        (JSC::BytecodeGenerator::emitPutById):
        (JSC::BytecodeGenerator::emitDirectPutById):
        (JSC::BytecodeGenerator::emitPutGetterSetter):
        (JSC::BytecodeGenerator::emitGetArgumentByVal):
        (JSC::BytecodeGenerator::emitGetByVal): Added hooks to the static property
        analyzer, so it can observe allocations and stores.

        (JSC::BytecodeGenerator::emitCreateThis): Factored this into a helper
        function because it was a significant amount of logic, and I wanted to
        add to it.

        (JSC::BytecodeGenerator::emitNewObject):
        (JSC::BytecodeGenerator::emitExpectedFunctionSnippet):
        (JSC::BytecodeGenerator::emitCall):
        (JSC::BytecodeGenerator::emitCallVarargs):
        (JSC::BytecodeGenerator::emitConstruct): Added a hook to profiled opcodes
        to track their stores, in case a store kills a profiled allocation. Since
        profiled opcodes are basically the only interesting stores we do, this
        is a convenient place to notice any store that might kill an allocation.

        * bytecompiler/BytecodeGenerator.h:
        (BytecodeGenerator): As above.

        * bytecompiler/StaticPropertyAnalysis.h: Added.
        (JSC):
        (StaticPropertyAnalysis):
        (JSC::StaticPropertyAnalysis::create):
        (JSC::StaticPropertyAnalysis::addPropertyIndex):
        (JSC::StaticPropertyAnalysis::record):
        (JSC::StaticPropertyAnalysis::propertyIndexCount):
        (JSC::StaticPropertyAnalysis::StaticPropertyAnalysis): Simple helper
        class for tracking allocations and stores.

        * bytecompiler/StaticPropertyAnalyzer.h: Added.
        (StaticPropertyAnalyzer):
        (JSC::StaticPropertyAnalyzer::StaticPropertyAnalyzer):
        (JSC::StaticPropertyAnalyzer::createThis):
        (JSC::StaticPropertyAnalyzer::newObject):
        (JSC::StaticPropertyAnalyzer::putById):
        (JSC::StaticPropertyAnalyzer::mov):
        (JSC::StaticPropertyAnalyzer::kill): Helper class for observing allocations
        and stores and making an inline capacity guess. The heuristics here are
        intentionally minimal because we don't want this one class to try to
        re-create something like a DFG or a runtime analysis. If we discover that
        we need those kinds of analyses, we should just replace this class with
        something else.

        This class tracks multiple registers that alias the same object -- that
        happens a lot, when moving locals into temporary registers -- but it
        doesn't track control flow or multiple objects that alias the same register.

        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::execute): Updated for rename.

        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::parseBlock): Updated for inline capacity and
        allocation profile.

        * dfg/DFGNode.h:
        (JSC::DFG::Node::hasInlineCapacity):
        (Node):
        (JSC::DFG::Node::inlineCapacity):
        (JSC::DFG::Node::hasFunction): Give the graph a good way to represent
        inline capacity for an allocation.

        * dfg/DFGNodeType.h:
        (DFG): Updated for rename.

        * dfg/DFGOperations.cpp: Updated for interface change.

        * dfg/DFGOperations.h: We pass the inline capacity to the slow case as
        an argument. This is the simplest way, since it's stored as a bytecode operand.

        * dfg/DFGPredictionPropagationPhase.cpp:
        (JSC::DFG::PredictionPropagationPhase::propagate): Updated for rename.

        * dfg/DFGRepatch.cpp:
        (JSC::DFG::tryCacheGetByID): Fixed a horrible off-by-one-half bug that only
        appears when doing an inline cached load for property number 64 on a 32-bit
        system. In JSVALUE32_64 land, "offsetRelativeToPatchedStorage" is the
        offset of the 64bit JSValue -- but we'll actually issue two loads, one for
        the payload at that offset, and one for the tag at that offset + 4. We need
        to ensure that both loads have a compact representation, or we'll corrupt
        the instruction stream.

        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::emitAllocateJSArray):
        * dfg/DFGSpeculativeJIT.h:
        (JSC::DFG::SpeculativeJIT::callOperation):
        (JSC::DFG::SpeculativeJIT::emitAllocateBasicStorage):
        (SpeculativeJIT):
        (JSC::DFG::SpeculativeJIT::emitAllocateJSObject):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::compile): Lots of refactoring to support
        passing an allocator to our allocation function, and/or passing a Structure
        as a register instead of an immediate.

        * heap/MarkedAllocator.h:
        (DFG):
        (MarkedAllocator):
        (JSC::MarkedAllocator::offsetOfFreeListHead): Added an accessor to simplify
        JIT code generation of allocation from an arbitrary allocator.

        * jit/JIT.h:
        (JSC):
        * jit/JITInlines.h:
        (JSC):
        (JSC::JIT::emitAllocateJSObject):
        * jit/JITOpcodes.cpp:
        (JSC::JIT::emit_op_new_object):
        (JSC::JIT::emitSlow_op_new_object):
        (JSC::JIT::emit_op_create_this):
        (JSC::JIT::emitSlow_op_create_this):
        * jit/JITOpcodes32_64.cpp:
        (JSC::JIT::emit_op_new_object):
        (JSC::JIT::emitSlow_op_new_object):
        (JSC::JIT::emit_op_create_this):
        (JSC::JIT::emitSlow_op_create_this): Same refactoring as done for the DFG.

        * jit/JITStubs.cpp:
        (JSC::tryCacheGetByID): Fixed the same bug mentioned above.

        (JSC::DEFINE_STUB_FUNCTION): Updated for interface changes.

        * llint/LLIntData.cpp:
        (JSC::LLInt::Data::performAssertions): Updated for interface changes.

        * llint/LLIntSlowPaths.cpp:
        (JSC::LLInt::LLINT_SLOW_PATH_DECL):
        * llint/LowLevelInterpreter.asm:
        * llint/LowLevelInterpreter32_64.asm:
        * llint/LowLevelInterpreter64.asm: Same refactoring as for the JITs.

        * profiler/ProfilerBytecode.cpp:
        * profiler/ProfilerBytecodes.cpp:
        * profiler/ProfilerCompilation.cpp:
        * profiler/ProfilerCompiledBytecode.cpp:
        * profiler/ProfilerDatabase.cpp:
        * profiler/ProfilerOSRExit.cpp:
        * profiler/ProfilerOrigin.cpp:
        * profiler/ProfilerProfiledBytecodes.cpp: Include ObjectConstructor.h
        because that's where createEmptyObject() lives now.

        * runtime/Executable.h:
        (JSC::JSFunction::JSFunction): Updated for rename.

        * runtime/JSCellInlines.h:
        (JSC::allocateCell): Updated to match the allocator selection code in
        the JIT, so it's clearer that both are correct.

        * runtime/JSFunction.cpp:
        (JSC::JSFunction::JSFunction):
        (JSC::JSFunction::createAllocationProfile):
        (JSC::JSFunction::visitChildren):
        (JSC::JSFunction::getOwnPropertySlot):
        (JSC::JSFunction::put):
        (JSC::JSFunction::defineOwnProperty):
        (JSC::JSFunction::getConstructData):
        * runtime/JSFunction.h:
        (JSC::JSFunction::offsetOfScopeChain):
        (JSC::JSFunction::offsetOfExecutable):
        (JSC::JSFunction::offsetOfAllocationProfile):
        (JSC::JSFunction::allocationProfile):
        (JSFunction):
        (JSC::JSFunction::tryGetAllocationProfile):
        (JSC::JSFunction::addAllocationProfileWatchpoint): Changed inheritorID
        data member to be an ObjectAllocationProfile, which includes a pointer
        to the desired allocator. This simplifies JIT code, since we don't have
        to compute the allocator on the fly. I verified by code inspection that
        JSFunction is still only 64 bytes.

        * runtime/JSGlobalObject.cpp:
        (JSC::JSGlobalObject::reset):
        (JSC::JSGlobalObject::visitChildren):
        * runtime/JSGlobalObject.h:
        (JSGlobalObject):
        (JSC::JSGlobalObject::dateStructure): No direct pointer to the empty
        object structure anymore, because now clients need to specify how much
        inline capacity they want.

        * runtime/JSONObject.cpp:
        * runtime/JSObject.h:
        (JSC):
        (JSFinalObject):
        (JSC::JSFinalObject::defaultInlineCapacity):
        (JSC::JSFinalObject::maxInlineCapacity):
        (JSC::JSFinalObject::createStructure): A little refactoring to try to 
        clarify where some of these constants derive from.

        (JSC::maxOffsetRelativeToPatchedStorage): Used for bug fix, above.

        * runtime/JSProxy.cpp:
        (JSC::JSProxy::setTarget): Ugly, but effective.

        * runtime/LiteralParser.cpp:
        * runtime/ObjectConstructor.cpp:
        (JSC::constructObject):
        (JSC::constructWithObjectConstructor):
        (JSC::callObjectConstructor):
        (JSC::objectConstructorCreate): Updated for interface changes.

        * runtime/ObjectConstructor.h:
        (JSC::constructEmptyObject): Clarified your options for how to allocate
        an empty object, to emphasize what things can actually vary.

        * runtime/PropertyOffset.h: These constants have moved because they're
        really higher level concepts to do with the layout of objects and the
        collector. PropertyOffset is just an abstract number line, independent
        of those things.

        * runtime/PrototypeMap.cpp:
        (JSC::PrototypeMap::emptyObjectStructureForPrototype):
        (JSC::PrototypeMap::clearEmptyObjectStructureForPrototype):
        * runtime/PrototypeMap.h:
        (PrototypeMap): The map key is now a pair of prototype and inline capacity,
        since Structure encodes inline capacity.

        * runtime/Structure.cpp:
        (JSC::Structure::Structure):
        (JSC::Structure::materializePropertyMap):
        (JSC::Structure::addPropertyTransition):
        (JSC::Structure::nonPropertyTransition):
        (JSC::Structure::copyPropertyTableForPinning):
        * runtime/Structure.h:
        (Structure):
        (JSC::Structure::totalStorageSize):
        (JSC::Structure::transitionCount):
        (JSC::Structure::create): Fixed a nasty refactoring bug that only shows
        up after enabling variable-sized inline capacities: we were passing our
        type info where our inline capacity was expected. The compiler didn't
        notice because both have type int :(.

2013-01-28  Oliver Hunt  <oliver@apple.com>

        Add more assertions to the property storage use in arrays
        https://bugs.webkit.org/show_bug.cgi?id=107728

        Reviewed by Filip Pizlo.

        Add a bunch of assertions to array and object butterfly
        usage.  This should make debugging somewhat easier.

        I also converted a couple of assertions to release asserts
        as they were so low cost it seemed a sensible thing to do.

        * runtime/JSArray.cpp:
        (JSC::JSArray::sortVector):
        (JSC::JSArray::compactForSorting):
        * runtime/JSObject.h:
        (JSC::JSObject::getHolyIndexQuickly):

2013-01-28  Adam Barth  <abarth@webkit.org>

        Remove webkitNotifications.createHTMLNotification
        https://bugs.webkit.org/show_bug.cgi?id=107598

        Reviewed by Benjamin Poulain.

        * Configurations/FeatureDefines.xcconfig:

2013-01-28  Michael Saboff  <msaboff@apple.com>

        Cleanup ARM version of debugName() in DFGFPRInfo.h
        https://bugs.webkit.org/show_bug.cgi?id=108090

        Reviewed by David Kilzer.

        Fixed debugName() so it will compile by adding static_cast<int> and missing commas.

        * dfg/DFGFPRInfo.h:
        (JSC::DFG::FPRInfo::debugName):

2013-01-27  Andreas Kling  <akling@apple.com>

        JSC: FunctionParameters are memory hungry.
        <http://webkit.org/b/108033>
        <rdar://problem/13094803>

        Reviewed by Sam Weinig.

        Instead of inheriting from Vector<Identifier>, make FunctionParameters a simple fixed-size array
        with a custom-allocating create() function. Removes one step of indirection and cuts memory usage
        roughly in half.

        2.73 MB progression on Membuster3.

        * bytecode/UnlinkedCodeBlock.cpp:
        (JSC::UnlinkedFunctionExecutable::paramString):
        * bytecompiler/BytecodeGenerator.cpp:
        (JSC::BytecodeGenerator::BytecodeGenerator):
        * parser/Nodes.cpp:
        (JSC::FunctionParameters::create):
        (JSC::FunctionParameters::FunctionParameters):
        (JSC::FunctionParameters::~FunctionParameters):
        * parser/Nodes.h:
        (FunctionParameters):
        (JSC::FunctionParameters::size):
        (JSC::FunctionParameters::at):
        (JSC::FunctionParameters::identifiers):

2013-01-27  Andreas Kling  <akling@apple.com>

        JSC: SourceProviderCache is memory hungry.
        <http://webkit.org/b/108029>
        <rdar://problem/13094806>

        Reviewed by Sam Weinig.

        Use fixed-size arrays for SourceProviderCacheItem's lists of captured variables.
        Since the lists never change after the object is created, there's no need to keep them in Vectors
        and we can instead create the whole cache item in a single allocation.

        13.37 MB progression on Membuster3.

        * parser/Parser.cpp:
        (JSC::::parseFunctionInfo):
        * parser/Parser.h:
        (JSC::Scope::copyCapturedVariablesToVector):
        (JSC::Scope::fillParametersForSourceProviderCache):
        (JSC::Scope::restoreFromSourceProviderCache):
        * parser/SourceProviderCacheItem.h:
        (SourceProviderCacheItemCreationParameters):
        (SourceProviderCacheItem):
        (JSC::SourceProviderCacheItem::approximateByteSize):
        (JSC::SourceProviderCacheItem::usedVariables):
        (JSC::SourceProviderCacheItem::writtenVariables):
        (JSC::SourceProviderCacheItem::~SourceProviderCacheItem):
        (JSC::SourceProviderCacheItem::create):
        (JSC::SourceProviderCacheItem::SourceProviderCacheItem):

2013-01-27  Zoltan Arvai  <zarvai@inf.u-szeged.hu>

        Fixing atomicIncrement implementation for Windows by dropping support before XP SP2.
        https://bugs.webkit.org/show_bug.cgi?id=106740

        Reviewed by Benjamin Poulain.

        * config.h:

2013-01-25  Filip Pizlo  <fpizlo@apple.com>

        DFG variable event stream shouldn't use NodeIndex
        https://bugs.webkit.org/show_bug.cgi?id=107996

        Reviewed by Oliver Hunt.
        
        Introduce the notion of a DFG::MinifiedID, which is just a unique ID of a DFG Node.
        Internally it currently uses a NodeIndex, but we could change this without having
        to recode all of the users of MinifiedID. This effectively decouples the OSR exit
        compiler's way of identifying nodes from the speculative JIT's way of identifying
        nodes, and should make it easier to make changes to the speculative JIT's internals
        in the future.
        
        Also changed variable event stream logging to exclude information about births and
        deaths of constants, since the OSR exit compiler never cares about which register
        holds a constant; if a value is constant then the OSR exit compiler can reify it.
        
        Also changed the variable event stream's value recovery computation to use a
        HashMap keyed by MinifiedID rather than a Vector indexed by NodeIndex.
        
        This appears to be performance-neutral. It's primarily meant as a small step
        towards https://bugs.webkit.org/show_bug.cgi?id=106868.

        * GNUmakefile.list.am:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * dfg/DFGGenerationInfo.h:
        (JSC::DFG::GenerationInfo::GenerationInfo):
        (JSC::DFG::GenerationInfo::initConstant):
        (JSC::DFG::GenerationInfo::initInteger):
        (JSC::DFG::GenerationInfo::initJSValue):
        (JSC::DFG::GenerationInfo::initCell):
        (JSC::DFG::GenerationInfo::initBoolean):
        (JSC::DFG::GenerationInfo::initDouble):
        (JSC::DFG::GenerationInfo::initStorage):
        (JSC::DFG::GenerationInfo::noticeOSRBirth):
        (JSC::DFG::GenerationInfo::use):
        (JSC::DFG::GenerationInfo::appendFill):
        (JSC::DFG::GenerationInfo::appendSpill):
        (GenerationInfo):
        * dfg/DFGJITCompiler.cpp:
        (JSC::DFG::JITCompiler::link):
        * dfg/DFGMinifiedGraph.h:
        (JSC::DFG::MinifiedGraph::at):
        (MinifiedGraph):
        * dfg/DFGMinifiedID.h: Added.
        (DFG):
        (MinifiedID):
        (JSC::DFG::MinifiedID::MinifiedID):
        (JSC::DFG::MinifiedID::operator!):
        (JSC::DFG::MinifiedID::nodeIndex):
        (JSC::DFG::MinifiedID::operator==):
        (JSC::DFG::MinifiedID::operator!=):
        (JSC::DFG::MinifiedID::operator<):
        (JSC::DFG::MinifiedID::operator>):
        (JSC::DFG::MinifiedID::operator<=):
        (JSC::DFG::MinifiedID::operator>=):
        (JSC::DFG::MinifiedID::hash):
        (JSC::DFG::MinifiedID::dump):
        (JSC::DFG::MinifiedID::isHashTableDeletedValue):
        (JSC::DFG::MinifiedID::invalidID):
        (JSC::DFG::MinifiedID::otherInvalidID):
        (JSC::DFG::MinifiedID::fromBits):
        (JSC::DFG::MinifiedIDHash::hash):
        (JSC::DFG::MinifiedIDHash::equal):
        (MinifiedIDHash):
        (WTF):
        * dfg/DFGMinifiedNode.cpp:
        (JSC::DFG::MinifiedNode::fromNode):
        * dfg/DFGMinifiedNode.h:
        (JSC::DFG::MinifiedNode::id):
        (JSC::DFG::MinifiedNode::child1):
        (JSC::DFG::MinifiedNode::getID):
        (JSC::DFG::MinifiedNode::compareByNodeIndex):
        (MinifiedNode):
        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::compileMovHint):
        (JSC::DFG::SpeculativeJIT::computeValueRecoveryFor):
        * dfg/DFGSpeculativeJIT.h:
        (JSC::DFG::SpeculativeJIT::setNodeIndexForOperand):
        * dfg/DFGValueSource.cpp:
        (JSC::DFG::ValueSource::dump):
        * dfg/DFGValueSource.h:
        (JSC::DFG::ValueSource::ValueSource):
        (JSC::DFG::ValueSource::isSet):
        (JSC::DFG::ValueSource::kind):
        (JSC::DFG::ValueSource::id):
        (ValueSource):
        (JSC::DFG::ValueSource::idFromKind):
        (JSC::DFG::ValueSource::kindFromID):
        * dfg/DFGVariableEvent.cpp:
        (JSC::DFG::VariableEvent::dump):
        (JSC::DFG::VariableEvent::dumpFillInfo):
        (JSC::DFG::VariableEvent::dumpSpillInfo):
        * dfg/DFGVariableEvent.h:
        (JSC::DFG::VariableEvent::fillGPR):
        (JSC::DFG::VariableEvent::fillPair):
        (JSC::DFG::VariableEvent::fillFPR):
        (JSC::DFG::VariableEvent::spill):
        (JSC::DFG::VariableEvent::death):
        (JSC::DFG::VariableEvent::movHint):
        (JSC::DFG::VariableEvent::id):
        (VariableEvent):
        * dfg/DFGVariableEventStream.cpp:
        (DFG):
        (JSC::DFG::VariableEventStream::tryToSetConstantRecovery):
        (JSC::DFG::VariableEventStream::reconstruct):
        * dfg/DFGVariableEventStream.h:
        (VariableEventStream):

2013-01-25  Roger Fong  <roger_fong@apple.com>

        Unreviewed. Rename LLInt projects folder and make appropriate changes to solutions.

        * JavaScriptCore.vcxproj/JavaScriptCore.sln:
        * JavaScriptCore.vcxproj/LLInt: Copied from JavaScriptCore.vcxproj/LLInt.vcproj.
        * JavaScriptCore.vcxproj/LLInt.vcproj: Removed.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntAssembly: Removed.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntAssembly/LLIntAssembly.make: Removed.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntAssembly/LLIntAssembly.vcxproj: Removed.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntAssembly/LLIntAssembly.vcxproj.user: Removed.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntAssembly/build-LLIntAssembly.sh: Removed.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntDesiredOffsets: Removed.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntDesiredOffsets/LLIntDesiredOffsets.make: Removed.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntDesiredOffsets/LLIntDesiredOffsets.vcxproj: Removed.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntDesiredOffsets/LLIntDesiredOffsets.vcxproj.user: Removed.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntDesiredOffsets/build-LLIntDesiredOffsets.sh: Removed.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntOffsetsExtractor: Removed.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntOffsetsExtractor/LLIntOffsetsExtractor.vcxproj: Removed.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntOffsetsExtractor/LLIntOffsetsExtractor.vcxproj.user: Removed.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntOffsetsExtractor/LLIntOffsetsExtractorCommon.props: Removed.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntOffsetsExtractor/LLIntOffsetsExtractorDebug.props: Removed.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntOffsetsExtractor/LLIntOffsetsExtractorRelease.props: Removed.

2013-01-24  Roger Fong  <roger_fong@apple.com>

        VS2010 JavascriptCore: Clean up property sheets, add a JSC solution, add testRegExp and testAPI projects.
        https://bugs.webkit.org/show_bug.cgi?id=106987

        Reviewed by Brent Fulgham.

        * JavaScriptCore.vcxproj/JavaScriptCore.sln: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreCF.props:
        * JavaScriptCore.vcxproj/JavaScriptCoreCommon.props:
        * JavaScriptCore.vcxproj/JavaScriptCorePreLink.cmd:
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntOffsetsExtractor/LLIntOffsetsExtractorCommon.props:
        * JavaScriptCore.vcxproj/jsc/jscCommon.props:
        * JavaScriptCore.vcxproj/jsc/jscDebug.props:
        * JavaScriptCore.vcxproj/jsc/jscPostBuild.cmd:
        * JavaScriptCore.vcxproj/jsc/jscPreLink.cmd:
        * JavaScriptCore.vcxproj/testRegExp: Added.
        * JavaScriptCore.vcxproj/testRegExp/testRegExp.vcxproj: Added.
        * JavaScriptCore.vcxproj/testRegExp/testRegExp.vcxproj.filters: Added.
        * JavaScriptCore.vcxproj/testRegExp/testRegExp.vcxproj.user: Added.
        * JavaScriptCore.vcxproj/testRegExp/testRegExpCommon.props: Added.
        * JavaScriptCore.vcxproj/testRegExp/testRegExpDebug.props: Added.
        * JavaScriptCore.vcxproj/testRegExp/testRegExpPostBuild.cmd: Added.
        * JavaScriptCore.vcxproj/testRegExp/testRegExpPreBuild.cmd: Added.
        * JavaScriptCore.vcxproj/testRegExp/testRegExpPreLink.cmd: Added.
        * JavaScriptCore.vcxproj/testRegExp/testRegExpRelease.props: Added.
        * JavaScriptCore.vcxproj/testapi: Added.
        * JavaScriptCore.vcxproj/testapi/testapi.vcxproj: Added.
        * JavaScriptCore.vcxproj/testapi/testapi.vcxproj.filters: Added.
        * JavaScriptCore.vcxproj/testapi/testapi.vcxproj.user: Added.
        * JavaScriptCore.vcxproj/testapi/testapiCommon.props: Added.
        * JavaScriptCore.vcxproj/testapi/testapiDebug.props: Added.
        * JavaScriptCore.vcxproj/testapi/testapiPostBuild.cmd: Added.
        * JavaScriptCore.vcxproj/testapi/testapiPreBuild.cmd: Added.
        * JavaScriptCore.vcxproj/testapi/testapiPreLink.cmd: Added.
        * JavaScriptCore.vcxproj/testapi/testapiRelease.props: Added.

2013-01-24  Roger Fong  <roger_fong@apple.com>

        Unreviewed. Windows build fix.

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCoreExports.def:

2013-01-24  Filip Pizlo  <fpizlo@apple.com>

        DFG::JITCompiler::getSpeculation() methods are badly named and superfluous
        https://bugs.webkit.org/show_bug.cgi?id=107860

        Reviewed by Mark Hahnenberg.

        * dfg/DFGJITCompiler.h:
        (JITCompiler):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::compileLogicalNot):
        (JSC::DFG::SpeculativeJIT::emitBranch):

2013-01-24  Mark Hahnenberg  <mhahnenberg@apple.com>

        Objective-C API: Rename JSValue.h/APIJSValue.h to JSCJSValue.h/JSValue.h
        https://bugs.webkit.org/show_bug.cgi?id=107327

        Reviewed by Filip Pizlo.

        We're renaming these two files, so we have to replace the names everywhere.

        * API/APICast.h:
        * API/APIJSValue.h: Removed.
        * API/JSBlockAdaptor.mm:
        * API/JSStringRefCF.cpp:
        * API/JSValue.h: Copied from Source/JavaScriptCore/API/APIJSValue.h.
        * API/JSValue.mm:
        * API/JSValueInternal.h:
        * API/JSValueRef.cpp:
        * API/JSWeakObjectMapRefPrivate.cpp:
        * API/JavaScriptCore.h:
        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * Target.pri:
        * bytecode/CallLinkStatus.h:
        * bytecode/CodeBlock.cpp:
        * bytecode/MethodOfGettingAValueProfile.h:
        * bytecode/ResolveGlobalStatus.cpp:
        * bytecode/ResolveGlobalStatus.h:
        * bytecode/SpeculatedType.h:
        * bytecode/ValueRecovery.h:
        * dfg/DFGByteCodeParser.cpp:
        * dfg/DFGJITCompiler.cpp:
        * dfg/DFGNode.h:
        * dfg/DFGSpeculativeJIT.cpp:
        * dfg/DFGSpeculativeJIT64.cpp:
        * heap/CopiedBlock.h:
        * heap/HandleStack.cpp:
        * heap/HandleTypes.h:
        * heap/WeakImpl.h:
        * interpreter/Interpreter.h:
        * interpreter/Register.h:
        * interpreter/VMInspector.h:
        * jit/HostCallReturnValue.cpp:
        * jit/HostCallReturnValue.h:
        * jit/JITCode.h:
        * jit/JITExceptions.cpp:
        * jit/JITExceptions.h:
        * jit/JSInterfaceJIT.h:
        * llint/LLIntCLoop.h:
        * llint/LLIntData.h:
        * llint/LLIntSlowPaths.cpp:
        * profiler/ProfilerBytecode.h:
        * profiler/ProfilerBytecodeSequence.h:
        * profiler/ProfilerBytecodes.h:
        * profiler/ProfilerCompilation.h:
        * profiler/ProfilerCompiledBytecode.h:
        * profiler/ProfilerDatabase.h:
        * profiler/ProfilerOSRExit.h:
        * profiler/ProfilerOSRExitSite.h:
        * profiler/ProfilerOrigin.h:
        * profiler/ProfilerOriginStack.h:
        * runtime/ArgList.cpp:
        * runtime/CachedTranscendentalFunction.h:
        * runtime/CallData.h:
        * runtime/Completion.h:
        * runtime/ConstructData.h:
        * runtime/DateConstructor.cpp:
        * runtime/DateInstance.cpp:
        * runtime/DatePrototype.cpp:
        * runtime/JSAPIValueWrapper.h:
        * runtime/JSCJSValue.cpp: Copied from Source/JavaScriptCore/runtime/JSValue.cpp.
        * runtime/JSCJSValue.h: Copied from Source/JavaScriptCore/runtime/JSValue.h.
        (JSValue):
        * runtime/JSCJSValueInlines.h: Copied from Source/JavaScriptCore/runtime/JSValueInlines.h.
        * runtime/JSGlobalData.h:
        * runtime/JSGlobalObject.cpp:
        * runtime/JSGlobalObjectFunctions.h:
        * runtime/JSStringJoiner.h:
        * runtime/JSValue.cpp: Removed.
        * runtime/JSValue.h: Removed.
        * runtime/JSValueInlines.h: Removed.
        * runtime/LiteralParser.h:
        * runtime/Operations.h:
        * runtime/PropertyDescriptor.h:
        * runtime/PropertySlot.h:
        * runtime/Protect.h:
        * runtime/RegExpPrototype.cpp:
        * runtime/Structure.h:

2013-01-23  Oliver Hunt  <oliver@apple.com>

        Harden JSC a bit with RELEASE_ASSERT
        https://bugs.webkit.org/show_bug.cgi?id=107766

        Reviewed by Mark Hahnenberg.

        Went through and replaced a pile of ASSERTs that were covering
        significantly important details (bounds checks, etc) where
        having the checks did not impact release performance in any
        measurable way.

        * API/JSContextRef.cpp:
        (JSContextCreateBacktrace):
        * assembler/MacroAssembler.h:
        (JSC::MacroAssembler::branchAdd32):
        (JSC::MacroAssembler::branchMul32):
        * bytecode/CodeBlock.cpp:
        (JSC::CodeBlock::dumpBytecode):
        (JSC::CodeBlock::handlerForBytecodeOffset):
        (JSC::CodeBlock::lineNumberForBytecodeOffset):
        (JSC::CodeBlock::bytecodeOffset):
        * bytecode/CodeBlock.h:
        (JSC::CodeBlock::bytecodeOffsetForCallAtIndex):
        (JSC::CodeBlock::bytecodeOffset):
        (JSC::CodeBlock::exceptionHandler):
        (JSC::CodeBlock::codeOrigin):
        (JSC::CodeBlock::immediateSwitchJumpTable):
        (JSC::CodeBlock::characterSwitchJumpTable):
        (JSC::CodeBlock::stringSwitchJumpTable):
        (JSC::CodeBlock::setIdentifiers):
        (JSC::baselineCodeBlockForInlineCallFrame):
        (JSC::ExecState::uncheckedR):
        * bytecode/CodeOrigin.cpp:
        (JSC::CodeOrigin::inlineStack):
        * bytecode/CodeOrigin.h:
        (JSC::CodeOrigin::CodeOrigin):
        * dfg/DFGCSEPhase.cpp:
        * dfg/DFGOSRExit.cpp:
        * dfg/DFGScratchRegisterAllocator.h:
        (JSC::DFG::ScratchRegisterAllocator::preserveUsedRegistersToScratchBuffer):
        (JSC::DFG::ScratchRegisterAllocator::restoreUsedRegistersFromScratchBuffer):
        * dfg/DFGSpeculativeJIT.h:
        (JSC::DFG::SpeculativeJIT::allocate):
        (JSC::DFG::SpeculativeJIT::spill):
        (JSC::DFG::SpeculativeJIT::integerResult):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::fillInteger):
        (JSC::DFG::SpeculativeJIT::fillDouble):
        (JSC::DFG::SpeculativeJIT::fillJSValue):
        (JSC::DFG::SpeculativeJIT::nonSpeculativeCompareNull):
        (JSC::DFG::SpeculativeJIT::emitCall):
        (JSC::DFG::SpeculativeJIT::fillSpeculateIntInternal):
        (JSC::DFG::SpeculativeJIT::fillSpeculateIntStrict):
        (JSC::DFG::SpeculativeJIT::fillSpeculateDouble):
        (JSC::DFG::SpeculativeJIT::fillSpeculateCell):
        (JSC::DFG::SpeculativeJIT::fillSpeculateBoolean):
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGValueSource.h:
        (JSC::DFG::dataFormatToValueSourceKind):
        (JSC::DFG::ValueSource::ValueSource):
        * dfg/DFGVirtualRegisterAllocationPhase.cpp:
        * heap/BlockAllocator.cpp:
        (JSC::BlockAllocator::BlockAllocator):
        (JSC::BlockAllocator::releaseFreeRegions):
        (JSC::BlockAllocator::blockFreeingThreadMain):
        * heap/Heap.cpp:
        (JSC::Heap::lastChanceToFinalize):
        (JSC::Heap::collect):
        * interpreter/Interpreter.cpp:
        (JSC::Interpreter::throwException):
        (JSC::Interpreter::execute):
        * jit/GCAwareJITStubRoutine.cpp:
        (JSC::GCAwareJITStubRoutine::observeZeroRefCount):
        * jit/JIT.cpp:
        (JSC::JIT::privateCompileMainPass):
        (JSC::JIT::privateCompileSlowCases):
        * jit/JITExceptions.cpp:
        (JSC::genericThrow):
        * jit/JITInlines.h:
        (JSC::JIT::emitLoad):
        * jit/JITOpcodes.cpp:
        (JSC::JIT::emit_op_end):
        (JSC::JIT::emit_resolve_operations):
        * jit/JITStubRoutine.cpp:
        (JSC::JITStubRoutine::observeZeroRefCount):
        * jit/JITStubs.cpp:
        (JSC::returnToThrowTrampoline):
        * runtime/Arguments.cpp:
        (JSC::Arguments::getOwnPropertySlot):
        (JSC::Arguments::getOwnPropertyDescriptor):
        (JSC::Arguments::deleteProperty):
        (JSC::Arguments::defineOwnProperty):
        (JSC::Arguments::didTearOffActivation):
        * runtime/ArrayPrototype.cpp:
        (JSC::shift):
        (JSC::unshift):
        (JSC::arrayProtoFuncLastIndexOf):
        * runtime/ButterflyInlines.h:
        (JSC::Butterfly::growPropertyStorage):
        * runtime/CodeCache.cpp:
        (JSC::CodeCache::getFunctionExecutableFromGlobalCode):
        * runtime/CodeCache.h:
        (JSC::CacheMap::add):
        * runtime/Completion.cpp:
        (JSC::checkSyntax):
        (JSC::evaluate):
        * runtime/Executable.cpp:
        (JSC::FunctionExecutable::FunctionExecutable):
        (JSC::EvalExecutable::unlinkCalls):
        (JSC::ProgramExecutable::compileOptimized):
        (JSC::ProgramExecutable::unlinkCalls):
        (JSC::ProgramExecutable::initializeGlobalProperties):
        (JSC::FunctionExecutable::baselineCodeBlockFor):
        (JSC::FunctionExecutable::compileOptimizedForCall):
        (JSC::FunctionExecutable::compileOptimizedForConstruct):
        (JSC::FunctionExecutable::compileForCallInternal):
        (JSC::FunctionExecutable::compileForConstructInternal):
        (JSC::FunctionExecutable::unlinkCalls):
        (JSC::NativeExecutable::hashFor):
        * runtime/Executable.h:
        (JSC::EvalExecutable::compile):
        (JSC::ProgramExecutable::compile):
        (JSC::FunctionExecutable::compileForCall):
        (JSC::FunctionExecutable::compileForConstruct):
        * runtime/IndexingHeader.h:
        (JSC::IndexingHeader::setVectorLength):
        * runtime/JSArray.cpp:
        (JSC::JSArray::pop):
        (JSC::JSArray::shiftCountWithArrayStorage):
        (JSC::JSArray::shiftCountWithAnyIndexingType):
        (JSC::JSArray::unshiftCountWithArrayStorage):
        * runtime/JSGlobalObjectFunctions.cpp:
        (JSC::jsStrDecimalLiteral):
        * runtime/JSObject.cpp:
        (JSC::JSObject::copyButterfly):
        (JSC::JSObject::defineOwnIndexedProperty):
        (JSC::JSObject::putByIndexBeyondVectorLengthWithoutAttributes):
        * runtime/JSString.cpp:
        (JSC::JSRopeString::getIndexSlowCase):
        * yarr/YarrInterpreter.cpp:
        (JSC::Yarr::Interpreter::popParenthesesDisjunctionContext):

2013-01-23  Filip Pizlo  <fpizlo@apple.com>

        Constant folding an access to an uncaptured variable that is captured later in the same basic block shouldn't lead to assertion failures
        https://bugs.webkit.org/show_bug.cgi?id=107750
        <rdar://problem/12387265>

        Reviewed by Mark Hahnenberg.
        
        The point of this assertion was that if there is no variable capturing going on, then there should only be one GetLocal
        for the variable anywhere in the basic block. But if there is some capturing, then we'll have an unbounded number of
        GetLocals. The assertion was too imprecise for the latter case. I want to keep this assertion, so I introduced a
        checker that verifies this precisely: if there are any captured accesses to the variable anywhere at or after the
        GetLocal we are eliminating, then we allow redundant GetLocals.

        * dfg/DFGConstantFoldingPhase.cpp:
        (JSC::DFG::ConstantFoldingPhase::foldConstants):
        (ConstantFoldingPhase):
        (JSC::DFG::ConstantFoldingPhase::isCapturedAtOrAfter):

2013-01-23  Oliver Hunt  <oliver@apple.com>

        Replace ASSERT_NOT_REACHED with RELEASE_ASSERT_NOT_REACHED in JSC
        https://bugs.webkit.org/show_bug.cgi?id=107736

        Reviewed by Mark Hahnenberg.

        Mechanical change with no performance impact.

        * API/JSBlockAdaptor.mm:
        (BlockArgumentTypeDelegate::typeVoid):
        * API/JSCallbackObjectFunctions.h:
        (JSC::::construct):
        (JSC::::call):
        * API/JSScriptRef.cpp:
        * API/ObjCCallbackFunction.mm:
        (ArgumentTypeDelegate::typeVoid):
        * assembler/ARMv7Assembler.h:
        (JSC::ARMv7Assembler::link):
        (JSC::ARMv7Assembler::replaceWithLoad):
        (JSC::ARMv7Assembler::replaceWithAddressComputation):
        * assembler/MacroAssembler.h:
        (JSC::MacroAssembler::invert):
        * assembler/MacroAssemblerARM.h:
        (JSC::MacroAssemblerARM::countLeadingZeros32):
        (JSC::MacroAssemblerARM::divDouble):
        * assembler/MacroAssemblerMIPS.h:
        (JSC::MacroAssemblerMIPS::absDouble):
        (JSC::MacroAssemblerMIPS::replaceWithJump):
        (JSC::MacroAssemblerMIPS::maxJumpReplacementSize):
        * assembler/MacroAssemblerSH4.h:
        (JSC::MacroAssemblerSH4::absDouble):
        (JSC::MacroAssemblerSH4::replaceWithJump):
        (JSC::MacroAssemblerSH4::maxJumpReplacementSize):
        * assembler/SH4Assembler.h:
        (JSC::SH4Assembler::shllImm8r):
        (JSC::SH4Assembler::shlrImm8r):
        (JSC::SH4Assembler::cmplRegReg):
        (JSC::SH4Assembler::branch):
        * assembler/X86Assembler.h:
        (JSC::X86Assembler::replaceWithLoad):
        (JSC::X86Assembler::replaceWithAddressComputation):
        * bytecode/CallLinkInfo.cpp:
        (JSC::CallLinkInfo::unlink):
        * bytecode/CodeBlock.cpp:
        (JSC::debugHookName):
        (JSC::CodeBlock::printGetByIdOp):
        (JSC::CodeBlock::printGetByIdCacheStatus):
        (JSC::CodeBlock::visitAggregate):
        (JSC::CodeBlock::finalizeUnconditionally):
        (JSC::CodeBlock::usesOpcode):
        * bytecode/DataFormat.h:
        (JSC::needDataFormatConversion):
        * bytecode/ExitKind.cpp:
        (JSC::exitKindToString):
        (JSC::exitKindIsCountable):
        * bytecode/MethodOfGettingAValueProfile.cpp:
        (JSC::MethodOfGettingAValueProfile::getSpecFailBucket):
        * bytecode/Opcode.h:
        (JSC::opcodeLength):
        * bytecode/PolymorphicPutByIdList.cpp:
        (JSC::PutByIdAccess::fromStructureStubInfo):
        (JSC::PutByIdAccess::visitWeak):
        * bytecode/StructureStubInfo.cpp:
        (JSC::StructureStubInfo::deref):
        * bytecompiler/BytecodeGenerator.cpp:
        (JSC::ResolveResult::checkValidity):
        (JSC::BytecodeGenerator::emitGetLocalVar):
        (JSC::BytecodeGenerator::beginSwitch):
        * bytecompiler/NodesCodegen.cpp:
        (JSC::BinaryOpNode::emitBytecode):
        (JSC::emitReadModifyAssignment):
        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::execute):
        (JSC::DFG::AbstractState::mergeStateAtTail):
        (JSC::DFG::AbstractState::mergeToSuccessors):
        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::makeSafe):
        (JSC::DFG::ByteCodeParser::parseBlock):
        * dfg/DFGCFGSimplificationPhase.cpp:
        (JSC::DFG::CFGSimplificationPhase::fixPossibleGetLocal):
        (JSC::DFG::CFGSimplificationPhase::fixTailOperand):
        * dfg/DFGCSEPhase.cpp:
        (JSC::DFG::CSEPhase::setLocalStoreElimination):
        * dfg/DFGCapabilities.cpp:
        (JSC::DFG::canHandleOpcodes):
        * dfg/DFGCommon.h:
        (JSC::DFG::useKindToString):
        * dfg/DFGDoubleFormatState.h:
        (JSC::DFG::mergeDoubleFormatStates):
        (JSC::DFG::doubleFormatStateToString):
        * dfg/DFGFixupPhase.cpp:
        (JSC::DFG::FixupPhase::blessArrayOperation):
        * dfg/DFGGraph.h:
        (JSC::DFG::Graph::clobbersWorld):
        * dfg/DFGNode.h:
        (JSC::DFG::Node::valueOfJSConstant):
        (JSC::DFG::Node::successor):
        * dfg/DFGNodeFlags.cpp:
        (JSC::DFG::nodeFlagsAsString):
        * dfg/DFGNodeType.h:
        (JSC::DFG::defaultFlags):
        * dfg/DFGRepatch.h:
        (JSC::DFG::dfgResetGetByID):
        (JSC::DFG::dfgResetPutByID):
        * dfg/DFGSlowPathGenerator.h:
        (JSC::DFG::SlowPathGenerator::call):
        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::silentSavePlanForGPR):
        (JSC::DFG::SpeculativeJIT::silentSpill):
        (JSC::DFG::SpeculativeJIT::silentFill):
        (JSC::DFG::SpeculativeJIT::checkArray):
        (JSC::DFG::SpeculativeJIT::checkGeneratedTypeForToInt32):
        (JSC::DFG::SpeculativeJIT::compileValueToInt32):
        (JSC::DFG::SpeculativeJIT::compileGetByValOnFloatTypedArray):
        (JSC::DFG::SpeculativeJIT::compilePutByValForFloatTypedArray):
        * dfg/DFGSpeculativeJIT.h:
        (JSC::DFG::SpeculativeJIT::bitOp):
        (JSC::DFG::SpeculativeJIT::shiftOp):
        (JSC::DFG::SpeculativeJIT::integerResult):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::fillInteger):
        (JSC::DFG::SpeculativeJIT::fillDouble):
        (JSC::DFG::SpeculativeJIT::fillJSValue):
        (JSC::DFG::SpeculativeJIT::fillSpeculateIntInternal):
        (JSC::DFG::SpeculativeJIT::fillSpeculateDouble):
        (JSC::DFG::SpeculativeJIT::fillSpeculateCell):
        (JSC::DFG::SpeculativeJIT::fillSpeculateBoolean):
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::fillInteger):
        (JSC::DFG::SpeculativeJIT::fillDouble):
        (JSC::DFG::SpeculativeJIT::fillJSValue):
        (JSC::DFG::SpeculativeJIT::fillSpeculateIntInternal):
        (JSC::DFG::SpeculativeJIT::fillSpeculateDouble):
        (JSC::DFG::SpeculativeJIT::fillSpeculateCell):
        (JSC::DFG::SpeculativeJIT::fillSpeculateBoolean):
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGStructureCheckHoistingPhase.cpp:
        (JSC::DFG::StructureCheckHoistingPhase::run):
        * dfg/DFGValueSource.h:
        (JSC::DFG::ValueSource::valueRecovery):
        * dfg/DFGVariableEvent.cpp:
        (JSC::DFG::VariableEvent::dump):
        * dfg/DFGVariableEventStream.cpp:
        (JSC::DFG::VariableEventStream::reconstruct):
        * heap/BlockAllocator.h:
        (JSC::BlockAllocator::regionSetFor):
        * heap/GCThread.cpp:
        (JSC::GCThread::gcThreadMain):
        * heap/MarkedBlock.cpp:
        (JSC::MarkedBlock::sweepHelper):
        * heap/MarkedBlock.h:
        (JSC::MarkedBlock::isLive):
        * interpreter/CallFrame.h:
        (JSC::ExecState::inlineCallFrame):
        * interpreter/Interpreter.cpp:
        (JSC::getCallerInfo):
        (JSC::getStackFrameCodeType):
        (JSC::Interpreter::execute):
        * jit/ExecutableAllocatorFixedVMPool.cpp:
        (JSC::FixedVMPoolExecutableAllocator::notifyPageIsFree):
        * jit/JIT.cpp:
        (JSC::JIT::privateCompileMainPass):
        (JSC::JIT::privateCompileSlowCases):
        (JSC::JIT::privateCompile):
        * jit/JITArithmetic.cpp:
        (JSC::JIT::emitSlow_op_mod):
        * jit/JITArithmetic32_64.cpp:
        (JSC::JIT::emitBinaryDoubleOp):
        (JSC::JIT::emitSlow_op_mod):
        * jit/JITPropertyAccess.cpp:
        (JSC::JIT::isDirectPutById):
        * jit/JITStubs.cpp:
        (JSC::getPolymorphicAccessStructureListSlot):
        (JSC::DEFINE_STUB_FUNCTION):
        * llint/LLIntSlowPaths.cpp:
        (JSC::LLInt::jitCompileAndSetHeuristics):
        * parser/Lexer.cpp:
        (JSC::::lex):
        * parser/Nodes.h:
        (JSC::ExpressionNode::emitBytecodeInConditionContext):
        * parser/Parser.h:
        (JSC::Parser::getTokenName):
        (JSC::Parser::updateErrorMessageSpecialCase):
        * parser/SyntaxChecker.h:
        (JSC::SyntaxChecker::operatorStackPop):
        * runtime/Arguments.cpp:
        (JSC::Arguments::tearOffForInlineCallFrame):
        * runtime/DatePrototype.cpp:
        (JSC::formatLocaleDate):
        * runtime/Executable.cpp:
        (JSC::samplingDescription):
        * runtime/Executable.h:
        (JSC::ScriptExecutable::unlinkCalls):
        * runtime/Identifier.cpp:
        (JSC):
        * runtime/InternalFunction.cpp:
        (JSC::InternalFunction::getCallData):
        * runtime/JSArray.cpp:
        (JSC::JSArray::push):
        (JSC::JSArray::sort):
        * runtime/JSCell.cpp:
        (JSC::JSCell::defaultValue):
        (JSC::JSCell::getOwnPropertyNames):
        (JSC::JSCell::getOwnNonIndexPropertyNames):
        (JSC::JSCell::className):
        (JSC::JSCell::getPropertyNames):
        (JSC::JSCell::customHasInstance):
        (JSC::JSCell::putDirectVirtual):
        (JSC::JSCell::defineOwnProperty):
        (JSC::JSCell::getOwnPropertyDescriptor):
        * runtime/JSCell.h:
        (JSCell):
        * runtime/JSNameScope.cpp:
        (JSC::JSNameScope::put):
        * runtime/JSObject.cpp:
        (JSC::JSObject::getOwnPropertySlotByIndex):
        (JSC::JSObject::putByIndex):
        (JSC::JSObject::ensureArrayStorageSlow):
        (JSC::JSObject::deletePropertyByIndex):
        (JSC::JSObject::getOwnPropertyNames):
        (JSC::JSObject::putByIndexBeyondVectorLength):
        (JSC::JSObject::putDirectIndexBeyondVectorLength):
        (JSC::JSObject::getOwnPropertyDescriptor):
        * runtime/JSObject.h:
        (JSC::JSObject::canGetIndexQuickly):
        (JSC::JSObject::getIndexQuickly):
        (JSC::JSObject::tryGetIndexQuickly):
        (JSC::JSObject::canSetIndexQuickly):
        (JSC::JSObject::canSetIndexQuicklyForPutDirect):
        (JSC::JSObject::setIndexQuickly):
        (JSC::JSObject::initializeIndex):
        (JSC::JSObject::hasSparseMap):
        (JSC::JSObject::inSparseIndexingMode):
        * runtime/JSScope.cpp:
        (JSC::JSScope::isDynamicScope):
        * runtime/JSSymbolTableObject.cpp:
        (JSC::JSSymbolTableObject::putDirectVirtual):
        * runtime/JSSymbolTableObject.h:
        (JSSymbolTableObject):
        * runtime/LiteralParser.cpp:
        (JSC::::parse):
        * runtime/RegExp.cpp:
        (JSC::RegExp::compile):
        (JSC::RegExp::compileMatchOnly):
        * runtime/StructureTransitionTable.h:
        (JSC::newIndexingType):
        * tools/CodeProfile.cpp:
        (JSC::CodeProfile::sample):
        * yarr/YarrCanonicalizeUCS2.h:
        (JSC::Yarr::getCanonicalPair):
        (JSC::Yarr::areCanonicallyEquivalent):
        * yarr/YarrInterpreter.cpp:
        (JSC::Yarr::Interpreter::matchCharacterClass):
        (JSC::Yarr::Interpreter::matchBackReference):
        (JSC::Yarr::Interpreter::backtrackParenthesesTerminalEnd):
        (JSC::Yarr::Interpreter::matchParentheses):
        (JSC::Yarr::Interpreter::backtrackParentheses):
        (JSC::Yarr::Interpreter::matchDisjunction):
        * yarr/YarrJIT.cpp:
        (JSC::Yarr::YarrGenerator::generateTerm):
        (JSC::Yarr::YarrGenerator::backtrackTerm):
        * yarr/YarrParser.h:
        (JSC::Yarr::Parser::CharacterClassParserDelegate::assertionWordBoundary):
        (JSC::Yarr::Parser::CharacterClassParserDelegate::atomBackReference):
        * yarr/YarrPattern.cpp:
        (JSC::Yarr::YarrPatternConstructor::atomCharacterClassBuiltIn):

2013-01-23  Tony Chang  <tony@chromium.org>

        Unreviewed, set svn:eol-style to CRLF on Windows .sln files.

        * JavaScriptCore.vcproj/JavaScriptCore.sln: Modified property svn:eol-style.
        * JavaScriptCore.vcproj/JavaScriptCoreSubmit.sln: Modified property svn:eol-style.

2013-01-23  Oliver Hunt  <oliver@apple.com>

        Replace numerous manual CRASH's in JSC with RELEASE_ASSERT
        https://bugs.webkit.org/show_bug.cgi?id=107726

        Reviewed by Filip Pizlo.

        Fairly manual change from if (foo) CRASH(); to RELEASE_ASSERT(!foo);

        * assembler/MacroAssembler.h:
        (JSC::MacroAssembler::branchAdd32):
        (JSC::MacroAssembler::branchMul32):
        * bytecode/CodeBlockHash.cpp:
        (JSC::CodeBlockHash::CodeBlockHash):
        * heap/BlockAllocator.h:
        (JSC::Region::create):
        (JSC::Region::createCustomSize):
        * heap/GCAssertions.h:
        * heap/HandleSet.cpp:
        (JSC::HandleSet::visitStrongHandles):
        (JSC::HandleSet::writeBarrier):
        * heap/HandleSet.h:
        (JSC::HandleSet::allocate):
        * heap/Heap.cpp:
        (JSC::Heap::collect):
        * heap/SlotVisitor.cpp:
        (JSC::SlotVisitor::validate):
        * interpreter/Interpreter.cpp:
        (JSC::Interpreter::execute):
        * jit/ExecutableAllocator.cpp:
        (JSC::DemandExecutableAllocator::allocateNewSpace):
        (JSC::ExecutableAllocator::allocate):
        * jit/ExecutableAllocator.h:
        (JSC::roundUpAllocationSize):
        * jit/ExecutableAllocatorFixedVMPool.cpp:
        (JSC::FixedVMPoolExecutableAllocator::FixedVMPoolExecutableAllocator):
        (JSC::ExecutableAllocator::allocate):
        * runtime/ButterflyInlines.h:
        (JSC::Butterfly::createUninitialized):
        * runtime/Completion.cpp:
        (JSC::evaluate):
        * runtime/JSArray.h:
        (JSC::constructArray):
        * runtime/JSGlobalObject.cpp:
        (JSC::slowValidateCell):
        * runtime/JSObject.cpp:
        (JSC::JSObject::enterDictionaryIndexingModeWhenArrayStorageAlreadyExists):
        (JSC::JSObject::createArrayStorage):
        * tools/TieredMMapArray.h:
        (JSC::TieredMMapArray::append):
        * yarr/YarrInterpreter.cpp:
        (JSC::Yarr::Interpreter::allocDisjunctionContext):
        (JSC::Yarr::Interpreter::allocParenthesesDisjunctionContext):
        (JSC::Yarr::Interpreter::InputStream::readChecked):
        (JSC::Yarr::Interpreter::InputStream::uncheckInput):
        (JSC::Yarr::Interpreter::InputStream::atEnd):
        (JSC::Yarr::Interpreter::interpret):

2013-01-22  Filip Pizlo  <fpizlo@apple.com>

        Convert CSE phase to not rely too much on NodeIndex
        https://bugs.webkit.org/show_bug.cgi?id=107616

        Reviewed by Geoffrey Garen.
        
        - Instead of looping over the graph (which assumes that you can simply loop over all
          nodes without considering blocks first) to reset node.replacement, do that in the
          loop that sets up relevantToOSR, just before running CSE on the block.
        
        - Instead of having a relevantToOSR bitvector indexed by NodeIndex, made
          NodeRelevantToOSR be a NodeFlag. We had exactly one bit left in NodeFlags, so I did
          some reshuffling to fit it in.

        * dfg/DFGCSEPhase.cpp:
        (JSC::DFG::CSEPhase::CSEPhase):
        (JSC::DFG::CSEPhase::eliminateIrrelevantPhantomChildren):
        (JSC::DFG::CSEPhase::performNodeCSE):
        (JSC::DFG::CSEPhase::performBlockCSE):
        (CSEPhase):
        * dfg/DFGNodeFlags.h:
        (DFG):
        * dfg/DFGNodeType.h:
        (DFG):

2013-01-21  Kentaro Hara  <haraken@chromium.org>

        Implement UIEvent constructor
        https://bugs.webkit.org/show_bug.cgi?id=107430

        Reviewed by Adam Barth.

        Editor's draft: https://dvcs.w3.org/hg/d4e/raw-file/tip/source_respec.htm

        UIEvent constructor is implemented under a DOM4_EVENTS_CONSTRUCTOR flag,
        which is enabled on Safari and Chromium for now.

        * Configurations/FeatureDefines.xcconfig:

2013-01-22  Roger Fong  <roger_fong@apple.com>

        Unreviewed VS2010 build fix following r140259.

        * JavaScriptCore.vcxproj/JavaScriptCore.vcxproj:
        * JavaScriptCore.vcxproj/JavaScriptCore.vcxproj.filters:

2013-01-22  Roger Fong  <roger_fong@apple.com>

        JavaScriptCore property sheets, project files and modified build scripts.
        https://bugs.webkit.org/show_bug.cgi?id=106987

        Reviewed by Brent Fulgham.

        * JavaScriptCore.vcxproj: Added.
        * JavaScriptCore.vcxproj/JavaScriptCore.resources: Added.
        * JavaScriptCore.vcxproj/JavaScriptCore.resources/Info.plist: Added.
        * JavaScriptCore.vcxproj/JavaScriptCore.vcxproj: Added.
        * JavaScriptCore.vcxproj/JavaScriptCore.vcxproj.filters: Added.
        * JavaScriptCore.vcxproj/JavaScriptCore.vcxproj.user: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreCF.props: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreCommon.props: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreDebug.props: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreExports.def: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreGenerated.make: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreGenerated.vcxproj: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreGenerated.vcxproj.filters: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreGenerated.vcxproj.user: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreGeneratedCommon.props: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreGeneratedDebug.props: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreGeneratedRelease.props: Added.
        * JavaScriptCore.vcxproj/JavaScriptCorePostBuild.cmd: Added.
        * JavaScriptCore.vcxproj/JavaScriptCorePreBuild.cmd: Added.
        * JavaScriptCore.vcxproj/JavaScriptCorePreLink.cmd: Added.
        * JavaScriptCore.vcxproj/JavaScriptCoreRelease.props: Added.
        * JavaScriptCore.vcxproj/LLInt.vcproj: Added.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntAssembly: Added.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntAssembly/LLIntAssembly.make: Added.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntAssembly/LLIntAssembly.vcxproj: Added.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntAssembly/LLIntAssembly.vcxproj.user: Added.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntAssembly/build-LLIntAssembly.sh: Added.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntDesiredOffsets: Added.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntDesiredOffsets/LLIntDesiredOffsets.make: Added.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntDesiredOffsets/LLIntDesiredOffsets.vcxproj: Added.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntDesiredOffsets/LLIntDesiredOffsets.vcxproj.user: Added.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntDesiredOffsets/build-LLIntDesiredOffsets.sh: Added.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntOffsetsExtractor: Added.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntOffsetsExtractor/LLIntOffsetsExtractor.vcxproj: Added.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntOffsetsExtractor/LLIntOffsetsExtractor.vcxproj.user: Added.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntOffsetsExtractor/LLIntOffsetsExtractorCommon.props: Added.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntOffsetsExtractor/LLIntOffsetsExtractorDebug.props: Added.
        * JavaScriptCore.vcxproj/LLInt.vcproj/LLIntOffsetsExtractor/LLIntOffsetsExtractorRelease.props: Added.
        * JavaScriptCore.vcxproj/build-generated-files.sh: Added.
        * JavaScriptCore.vcxproj/copy-files.cmd: Added.
        * JavaScriptCore.vcxproj/jsc: Added.
        * JavaScriptCore.vcxproj/jsc/jsc.vcxproj: Added.
        * JavaScriptCore.vcxproj/jsc/jsc.vcxproj.filters: Added.
        * JavaScriptCore.vcxproj/jsc/jsc.vcxproj.user: Added.
        * JavaScriptCore.vcxproj/jsc/jscCommon.props: Added.
        * JavaScriptCore.vcxproj/jsc/jscDebug.props: Added.
        * JavaScriptCore.vcxproj/jsc/jscPostBuild.cmd: Added.
        * JavaScriptCore.vcxproj/jsc/jscPreBuild.cmd: Added.
        * JavaScriptCore.vcxproj/jsc/jscPreLink.cmd: Added.
        * JavaScriptCore.vcxproj/jsc/jscRelease.props: Added.
        * config.h:

2013-01-22  Joseph Pecoraro  <pecoraro@apple.com>

        [Mac] Enable Page Visibility (PAGE_VISIBILITY_API)
        https://bugs.webkit.org/show_bug.cgi?id=107230

        Reviewed by David Kilzer.

        * Configurations/FeatureDefines.xcconfig:

2013-01-22  Tobias Netzel  <tobias.netzel@googlemail.com>

        Yarr JIT isn't big endian compatible
        https://bugs.webkit.org/show_bug.cgi?id=102897

        Reviewed by Oliver Hunt.

        This patch was tested in the current mozilla codebase only and has passed the regexp tests there.

        * yarr/YarrJIT.cpp:
        (JSC::Yarr::YarrGenerator::generatePatternCharacterOnce):

2013-01-22  David Kilzer  <ddkilzer@apple.com>

        Fix DateMath.cpp to compile with -Wshorten-64-to-32
        <http://webkit.org/b/107503>

        Reviewed by Darin Adler.

        * runtime/JSDateMath.cpp:
        (JSC::parseDateFromNullTerminatedCharacters): Remove unneeded
        static_cast<int>().

2013-01-22  Tim Horton  <timothy_horton@apple.com>

        PDFPlugin: Build PDFPlugin everywhere, enable at runtime
        https://bugs.webkit.org/show_bug.cgi?id=107117

        Reviewed by Alexey Proskuryakov.

        Since PDFLayerController SPI is all forward-declared, the plugin should build
        on all Mac platforms, and can be enabled at runtime.

        * Configurations/FeatureDefines.xcconfig:

2013-01-21  Justin Schuh  <jschuh@chromium.org>

        [CHROMIUM] Suppress c4267 build warnings for Win64 targets
        https://bugs.webkit.org/show_bug.cgi?id=107499

        Reviewed by Abhishek Arya.

        * JavaScriptCore.gyp/JavaScriptCore.gyp:

2013-01-21  Dirk Schulze  <dschulze@adobe.com>

        Add build flag for Canvas's Path object (disabled by default)
        https://bugs.webkit.org/show_bug.cgi?id=107473

        Reviewed by Dean Jackson.

        Add CANVAS_PATH build flag to build systems.

        * Configurations/FeatureDefines.xcconfig:

2013-01-20  Geoffrey Garen  <ggaren@apple.com>

        Weak GC maps should be easier to use
        https://bugs.webkit.org/show_bug.cgi?id=107312

        Reviewed by Sam Weinig.

        Follow-up fix.

        * runtime/PrototypeMap.cpp:
        (JSC::PrototypeMap::emptyObjectStructureForPrototype): Restored this
        ASSERT, which was disabled because of a bug in WeakGCMap.

        * runtime/WeakGCMap.h:
        (JSC::WeakGCMap::add): We can't pass our passed-in value to add() because
        a PassWeak() clears itself when passed to another function. So, we pass
        nullptr instead, and fix things up afterwards.

2013-01-20  Geoffrey Garen  <ggaren@apple.com>

        Unreviewed.

        Temporarily disabling this ASSERT to get the bots green
        while I investigate a fix.

        * runtime/PrototypeMap.cpp:
        (JSC::PrototypeMap::emptyObjectStructureForPrototype):

2013-01-20  Filip Pizlo  <fpizlo@apple.com>

        Inserting a node into the DFG graph should not require five lines of code
        https://bugs.webkit.org/show_bug.cgi?id=107381

        Reviewed by Sam Weinig.
        
        This adds fairly comprehensive support for inserting a node into a DFG graph in one
        method call. A common example of this is:
        
        m_insertionSet.insertNode(indexInBlock, DontRefChildren, DontRefNode, SpecNone, ForceOSRExit, codeOrigin);
        
        The arguments to insert() specify what reference counting you need to have happen
        (RefChildren => recursively refs all children, RefNode => non-recursively refs the node
        that was created), the prediction to set (SpecNone is a common default), followed by
        the arguments to the Node() constructor. InsertionSet::insertNode() and similar methods
        (Graph::addNode() and BasicBlock::appendNode()) all use a common variadic template
        function macro from DFGVariadicFunction.h. Also, all of these methods will automatically
        non-recursively ref() the node being created if the flags say NodeMustGenerate.
        
        In all, this new mechanism retains the flexibility of the old approach (you get to
        manage ref counts yourself, albeit in less code) while ensuring that most code that adds
        nodes to the graph now needs less code to do it.
        
        In the future, we should revisit the reference counting methodology in the DFG: we could
        do like most compilers and get rid of it entirely, or we could make it automatic. This
        patch doesn't attempt to make any such major changes, and only seeks to simplify the
        technique we were already using (manual ref counting).

        * GNUmakefile.list.am:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * bytecode/Operands.h:
        (JSC::dumpOperands):
        * dfg/DFGAdjacencyList.h:
        (AdjacencyList):
        (JSC::DFG::AdjacencyList::kind):
        * dfg/DFGArgumentsSimplificationPhase.cpp:
        (JSC::DFG::ArgumentsSimplificationPhase::run):
        * dfg/DFGBasicBlock.h:
        (DFG):
        (BasicBlock):
        * dfg/DFGBasicBlockInlines.h: Added.
        (DFG):
        * dfg/DFGCFGSimplificationPhase.cpp:
        (JSC::DFG::CFGSimplificationPhase::run):
        (JSC::DFG::CFGSimplificationPhase::keepOperandAlive):
        * dfg/DFGCommon.h:
        * dfg/DFGConstantFoldingPhase.cpp:
        (JSC::DFG::ConstantFoldingPhase::ConstantFoldingPhase):
        (JSC::DFG::ConstantFoldingPhase::foldConstants):
        (JSC::DFG::ConstantFoldingPhase::addStructureTransitionCheck):
        (JSC::DFG::ConstantFoldingPhase::paintUnreachableCode):
        (ConstantFoldingPhase):
        * dfg/DFGFixupPhase.cpp:
        (JSC::DFG::FixupPhase::FixupPhase):
        (JSC::DFG::FixupPhase::fixupBlock):
        (JSC::DFG::FixupPhase::fixupNode):
        (FixupPhase):
        (JSC::DFG::FixupPhase::checkArray):
        (JSC::DFG::FixupPhase::blessArrayOperation):
        (JSC::DFG::FixupPhase::injectInt32ToDoubleNode):
        * dfg/DFGGraph.h:
        (JSC::DFG::Graph::ref):
        (Graph):
        * dfg/DFGInsertionSet.h:
        (DFG):
        (JSC::DFG::Insertion::Insertion):
        (JSC::DFG::Insertion::element):
        (Insertion):
        (JSC::DFG::InsertionSet::InsertionSet):
        (JSC::DFG::InsertionSet::insert):
        (InsertionSet):
        (JSC::DFG::InsertionSet::execute):
        * dfg/DFGNode.h:
        (JSC::DFG::Node::Node):
        (Node):
        * dfg/DFGStructureCheckHoistingPhase.cpp:
        (JSC::DFG::StructureCheckHoistingPhase::run):
        * dfg/DFGVariadicFunction.h: Added.

2013-01-19  Geoffrey Garen  <ggaren@apple.com>

        Track inheritance structures in a side table, instead of using a private
        name in each prototype
        https://bugs.webkit.org/show_bug.cgi?id=107378

        Reviewed by Sam Weinig and Phil Pizlo.

        This is a step toward object size inference.

        Using a side table frees us to use a more complex key (a pair of
        prototype and expected inline capacity).

        It also avoids ruining inline caches for prototypes. (Adding a new private
        name for a new inline capacity would change the prototype's structure,
        possibly firing watchpoints, making inline caches go polymorphic, and
        generally causing us to have a bad time.)

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * Target.pri: Buildage.

        * runtime/ArrayPrototype.cpp:
        (JSC::ArrayPrototype::finishCreation): Updated to use new side table API.

        * runtime/JSFunction.cpp:
        (JSC::JSFunction::cacheInheritorID): Updated to use new side table API.

        (JSC::JSFunction::visitChildren): Fixed a long-standing bug where JSFunction
        forgot to visit one of its data members (m_cachedInheritorID). This
        wasn't a user-visible problem before because JSFunction would always
        visit its .prototype property, which visited its m_cachedInheritorID.
        But now, function.prototype only weakly owns function.m_cachedInheritorID.

        * runtime/JSGlobalData.h:
        (JSGlobalData): Added the map, taking care to make sure that its
        destructor would run after the heap destructor.

        * runtime/JSGlobalObject.cpp:
        (JSC::JSGlobalObject::reset): Updated to use new side table API.

        * runtime/JSObject.cpp:
        (JSC::JSObject::notifyPresenceOfIndexedAccessors):
        (JSC::JSObject::setPrototype):
        * runtime/JSObject.h:
        (JSObject): Updated to use new side table API, and removed lots of code
        that used to manage the per-object private name.

        * runtime/JSProxy.cpp:
        (JSC::JSProxy::setTarget):
        * runtime/ObjectConstructor.cpp:
        (JSC::objectConstructorCreate):
        * runtime/ObjectPrototype.cpp:
        (JSC::ObjectPrototype::finishCreation): Updated to use new side table API.

        * runtime/PrototypeMap.cpp: Added.
        (JSC):
        (JSC::PrototypeMap::addPrototype):
        (JSC::PrototypeMap::emptyObjectStructureForPrototype):
        * runtime/PrototypeMap.h: Added.
        (PrototypeMap):
        (JSC::PrototypeMap::isPrototype):
        (JSC::PrototypeMap::clearEmptyObjectStructureForPrototype): New side table.
        This is a simple weak map, mapping an object to the structure you should
        use when inheriting from that object. (In future, inline capacity will
        be a part of the mapping.)

        I used two maps to preserve existing behavior that allowed us to speculate
        about an object becoming a prototype, even if it wasn't one at the moment.
        However, I suspect that behavior can be removed without harm.

        * runtime/WeakGCMap.h:
        (JSC::WeakGCMap::contains):
        (WeakGCMap): I would rate myself a 6 / 10 in C++.

2013-01-18  Dan Bernstein  <mitz@apple.com>

        Removed duplicate references to two headers in the project files.

        Rubber-stamped by Mark Rowe.

        * JavaScriptCore.xcodeproj/project.pbxproj:

2013-01-18  Michael Saboff  <msaboff@apple.com>

        Unreviewed build fix for building JSC with DFG_ENABLE_DEBUG_PROPAGATION_VERBOSE enabled in DFGCommon.h.
        Fixes the case where the argument node in fixupNode is freed due to the Vector storage being reallocated.

        * dfg/DFGFixupPhase.cpp:
        (JSC::DFG::FixupPhase::fixupNode):

2013-01-18  Michael Saboff  <msaboff@apple.com>

        Unreviewed build fix for release builds when DFG_ENABLE_DEBUG_PROPAGATION_VERBOSE is set to 1 in DFGCommon.h.

        * dfg/DFGCFAPhase.cpp: Added #include "Operations.h"

2013-01-18  Michael Saboff  <msaboff@apple.com>

        Change set r140201 broke editing/selection/move-by-word-visually-multi-line.html
        https://bugs.webkit.org/show_bug.cgi?id=107340

        Reviewed by Filip Pizlo.

        Due to the change landed in r140201, more nodes might end up
        generating Int32ToDouble nodes.  Therefore, changed the JSVALUE64
        constant path of compileInt32ToDouble() to use the more
        restrictive isInt32Constant() check on the input.  This check was
        the same as the existing ASSERT() so the ASSERT was eliminated.

        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::compileInt32ToDouble):

2013-01-18  Viatcheslav Ostapenko  <sl.ostapenko@samsung.com>

        Weak GC maps should be easier to use
        https://bugs.webkit.org/show_bug.cgi?id=107312

        Reviewed by Ryosuke Niwa.

        Build fix for linux platforms after r140194.

        * runtime/WeakGCMap.h:
        (WeakGCMap):

2013-01-18  Michael Saboff  <msaboff@apple.com>

        Harden ArithDiv of integers fix-up by inserting Int32ToDouble node directly
        https://bugs.webkit.org/show_bug.cgi?id=107321

        Reviewed by  Filip Pizlo.

        Split out the Int32ToDouble node insertion from fixDoubleEdge() and used it directly when we're fixing up
        an ArithDiv node with integer inputs and output for platforms that don't have integer division.
        Since we are checking that our inputs should be ints, we can just insert the Int32ToDouble node
        without any further checks.

        * dfg/DFGFixupPhase.cpp:
        (JSC::DFG::FixupPhase::fixupNode):
        (JSC::DFG::FixupPhase::fixDoubleEdge):
        (FixupPhase):
        (JSC::DFG::FixupPhase::injectInt32ToDoubleNode):

2013-01-18  Michael Saboff  <msaboff@apple.com>

        Fix up of ArithDiv nodes for non-x86 CPUs is broken
        https://bugs.webkit.org/show_bug.cgi?id=107309

        Reviewed by  Filip Pizlo.

        Changed the logic so that we insert an Int32ToDouble node when the existing edge is not SpecDouble.

        * dfg/DFGFixupPhase.cpp:
        (JSC::DFG::FixupPhase::fixDoubleEdge):

2013-01-18  Dan Bernstein  <mitz@apple.com>

        Tried to fix the build after r140194.

        * API/JSWrapperMap.mm:
        (-[JSWrapperMap wrapperForObject:]):

2013-01-18  Mark Hahnenberg  <mhahnenberg@apple.com>

        Objective-C API: Update documentation for JSValue and JSContext
        https://bugs.webkit.org/show_bug.cgi?id=107313

        Reviewed by Geoffrey Garen.

        After changing the semantics of object lifetime we need to update the API documentation to reflect the new semantics.

        * API/APIJSValue.h:
        * API/JSContext.h:

2013-01-18  Balazs Kilvady  <kilvadyb@homejinni.com>

        r134080 causes heap problem on linux systems where PAGESIZE != 4096
        https://bugs.webkit.org/show_bug.cgi?id=102828

        Reviewed by Mark Hahnenberg.

        Make MarkStackSegment::blockSize as the capacity of segments of a MarkStackArray.

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCoreExports.def:
        * heap/MarkStack.cpp:
        (JSC):
        (JSC::MarkStackArray::MarkStackArray):
        (JSC::MarkStackArray::expand):
        (JSC::MarkStackArray::donateSomeCellsTo):
        (JSC::MarkStackArray::stealSomeCellsFrom):
        * heap/MarkStack.h:
        (JSC::MarkStackSegment::data):
        (CapacityFromSize):
        (MarkStackArray):
        * heap/MarkStackInlines.h:
        (JSC::MarkStackArray::setTopForFullSegment):
        (JSC::MarkStackArray::append):
        (JSC::MarkStackArray::isEmpty):
        (JSC::MarkStackArray::size):
        * runtime/Options.h:
        (JSC):

2013-01-18  Geoffrey Garen  <ggaren@apple.com>

        Weak GC maps should be easier to use
        https://bugs.webkit.org/show_bug.cgi?id=107312

        Reviewed by Sam Weinig.

        This patch changes WeakGCMap to not use a WeakImpl finalizer to remove
        items from the map, and to instead have the map automatically remove
        stale items itself upon insertion. This has a few advantages:

        (1) WeakGCMap is now compatible with all the specializations you would
        use for HashMap.

        (2) There's no need for clients to write special finalization munging
        functions.

        (3) Clients can specify custom value finalizers if they like.

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCoreExports.def: Def!

        * API/JSWeakObjectMapRefPrivate.cpp: Setter no longer requires a global
        data, since we've reduced interdependency.

        * heap/Handle.h: No more need to forward declare, since we've reduced
        interdependency.

        * heap/Weak.h:
        (Weak): Use explicit so we can assign directly to a weak map iterator
        without ambiguity between Weak<T> and PassWeak<T>.

        * runtime/Structure.cpp:
        (JSC::StructureTransitionTable::add): See above.

        * runtime/Structure.h:
        (JSC):
        * runtime/StructureTransitionTable.h:
        (StructureTransitionTable): Bad code goes away, programmer happy.

        * runtime/WeakGCMap.h:
        (JSC):
        (WeakGCMap):
        (JSC::WeakGCMap::WeakGCMap):
        (JSC::WeakGCMap::set):
        (JSC::WeakGCMap::add):
        (JSC::WeakGCMap::find):
        (JSC::WeakGCMap::contains):
        (JSC::WeakGCMap::gcMap):
        (JSC::WeakGCMap::gcMapIfNeeded): Inherit from HashMap and override any
        function that might observe a Weak<T> that has died, just enough to
        make such items appear as if they are not in the table.

2013-01-18  Michael Saboff  <msaboff@apple.com>

        Refactor isPowerOf2() and add getLSBSet()
        https://bugs.webkit.org/show_bug.cgi?id=107306

        Reviewed by Filip Pizlo.

        Moved implementation of isPowerOf2() to new hasOneBitSet() in wtf/MathExtras.h.

        * runtime/PropertyMapHashTable.h:
        (JSC::isPowerOf2):

2013-01-17  Mark Hahnenberg  <mhahnenberg@apple.com>

        Objective-C API: Clean up JSValue.mm
        https://bugs.webkit.org/show_bug.cgi?id=107163

        Reviewed by Darin Adler.

        m_context is no longer weak, so there is now a lot of dead code in in JSValue.mm, and a wasted message send 
        on every API call.  In the head of just about every method in JSValue.mm we're doing:

        JSContext *context = [self context];
        if (!context)
            return nil;

        This is getting a retained copy of the context, which is no longer necessary now m_context is no longer weak.  
        We can just delete all these lines from all functions doing this, and where they were referring to the local 
        variable 'context', instead we can just access m_context directly.

        Since we're already going to be modifying most of JSValue.mm, we'll also do the following:

        1) context @property is no longer weak – the context property is declared as:

            @property(readonly, weak) JSContext *context;

        This is really only informative (since we're not presently synthesizing the ivar), but it is now misleading. 
        We should change it to:

            @property(readonly, retain) JSContext *context;

        2) the JSContext ivar and accessor can be automatically generated.  Since we're no longer doing anything 
        special with m_context, we can just let the compiler handle the ivar for us.  We'll delete:

            JSContext *m_context;

        and:

            - (JSContext *)context
            {
                return m_context;
        
            }

        and find&replace "m_context" to "_context" in JSValue.mm.

        * API/APIJSValue.h:
        * API/JSValue.mm:
        (-[JSValue toObject]):
        (-[JSValue toBool]):
        (-[JSValue toDouble]):
        (-[JSValue toNumber]):
        (-[JSValue toString]):
        (-[JSValue toDate]):
        (-[JSValue toArray]):
        (-[JSValue toDictionary]):
        (-[JSValue valueForProperty:]):
        (-[JSValue setValue:forProperty:]):
        (-[JSValue deleteProperty:]):
        (-[JSValue hasProperty:]):
        (-[JSValue defineProperty:descriptor:]):
        (-[JSValue valueAtIndex:]):
        (-[JSValue setValue:atIndex:]):
        (-[JSValue isUndefined]):
        (-[JSValue isNull]):
        (-[JSValue isBoolean]):
        (-[JSValue isNumber]):
        (-[JSValue isString]):
        (-[JSValue isObject]):
        (-[JSValue isEqualToObject:]):
        (-[JSValue isEqualWithTypeCoercionToObject:]):
        (-[JSValue isInstanceOf:]):
        (-[JSValue callWithArguments:]):
        (-[JSValue constructWithArguments:]):
        (-[JSValue invokeMethod:withArguments:]):
        (-[JSValue objectForKeyedSubscript:]):
        (-[JSValue setObject:forKeyedSubscript:]):
        (-[JSValue initWithValue:inContext:]):
        (-[JSValue dealloc]):
        (-[JSValue description]):

2013-01-17  Mark Hahnenberg  <mhahnenberg@apple.com>

        Objective-C API: Clean up JSValue
        https://bugs.webkit.org/show_bug.cgi?id=107156

        Reviewed by Oliver Hunt.

        JSContext m_protectCounts, protect, unprotect are all now unnecessary overhead, and should all be removed.  
        These exist to handle the context going away before the value does; the context needs to be able to unprotect 
        values early.  Since the value is now keeping the context alive there is no longer any danger of this happening; 
        instead we should just protect/unprotect the value in JSValue's init/dealloc methods.

        * API/JSContext.mm:
        (-[JSContext dealloc]):
        * API/JSContextInternal.h:
        * API/JSValue.mm:
        (-[JSValue initWithValue:inContext:]):
        (-[JSValue dealloc]):

2013-01-17  Filip Pizlo  <fpizlo@apple.com>

        DFG Node::ref() and Node::deref() should not return bool, and should have postfixRef variants
        https://bugs.webkit.org/show_bug.cgi?id=107147

        Reviewed by Mark Hahnenberg.
        
        This small refactoring will enable a world where ref() returns Node*, which is useful for
        https://bugs.webkit.org/show_bug.cgi?id=106868.  Also, while this refactoring does lead to
        slightly less terse code, it's also slightly more self-explanatory.  I could never quite
        remember what the meaning of the bool return from ref() and deref() was.

        * dfg/DFGGraph.cpp:
        (JSC::DFG::Graph::collectGarbage):
        * dfg/DFGGraph.h:
        (JSC::DFG::Graph::ref):
        (JSC::DFG::Graph::deref):
        * dfg/DFGNode.h:
        (JSC::DFG::Node::ref):
        (Node):
        (JSC::DFG::Node::postfixRef):
        (JSC::DFG::Node::deref):
        (JSC::DFG::Node::postfixDeref):

2013-01-17  Alexey Proskuryakov  <ap@apple.com>

        Added svn:ignore=*.pyc, so that ud_opcode.pyc and ud_optable.pyc don't show up
        in svn stat.

        * disassembler/udis86: Added property svn:ignore.

2013-01-16  Filip Pizlo  <fpizlo@apple.com>

        DFG 32_64 backend doesn't check for hasArrayStorage() in NewArrayWithSize
        https://bugs.webkit.org/show_bug.cgi?id=107081

        Reviewed by Michael Saboff.

        This bug led to the 32_64 backend emitting contiguous allocation code to allocate
        ArrayStorage arrays. This then led to all manner of heap corruption, since
        subsequent array accesses would be accessing the contiguous array "as if" it was
        an arraystorage array.

        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):

2013-01-16  Jonathan Liu  <net147@gmail.com>

        Add missing sys/mman.h include on Mac
        https://bugs.webkit.org/show_bug.cgi?id=98089

        Reviewed by Darin Adler.

        The madvise function and MADV_FREE constant require sys/mman.h.

        * jit/ExecutableAllocatorFixedVMPool.cpp:

2013-01-15  Michael Saboff  <msaboff@apple.com>

        DFG X86: division in the used-as-int case doesn't correctly check for -2^31/-1
        https://bugs.webkit.org/show_bug.cgi?id=106978

        Reviewed by Filip Pizlo.

        Changed the numerator equal to -2^31 check to just return if we expect an integer
        result, since the check is after we have determined that the denominator is -1.
        The int result of -2^31 / -1 is -2^31, so just return the numerator as the result.

        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::compileIntegerArithDivForX86):

2013-01-15  Levi Weintraub  <leviw@chromium.org>

        Unreviewed, rolling out r139792.
        http://trac.webkit.org/changeset/139792
        https://bugs.webkit.org/show_bug.cgi?id=106970

        Broke the windows build.

        * bytecode/GlobalResolveInfo.h: Removed property svn:mergeinfo.

2013-01-15  Pratik Solanki  <psolanki@apple.com>

        Use MADV_FREE_REUSABLE to return JIT memory to OS
        https://bugs.webkit.org/show_bug.cgi?id=106830
        <rdar://problem/11437701>

        Reviewed by Geoffrey Garen.

        Use MADV_FREE_REUSABLE to return JIT memory on OSes that have the underlying madvise bug
        fixed.

        * jit/ExecutableAllocatorFixedVMPool.cpp:
        (JSC::FixedVMPoolExecutableAllocator::notifyPageIsFree):

2013-01-15  Levi Weintraub  <leviw@chromium.org>

        Unreviewed, rolling out r139790.
        http://trac.webkit.org/changeset/139790
        https://bugs.webkit.org/show_bug.cgi?id=106948

        The patch is failing its own test.

        * bytecode/GlobalResolveInfo.h: Removed property svn:mergeinfo.

2013-01-15  Zan Dobersek  <zandobersek@gmail.com>

        [Autotools] Unify JavaScriptCore sources list, regardless of target OS
        https://bugs.webkit.org/show_bug.cgi?id=106007

        Reviewed by Gustavo Noronha Silva.

        Include the Source/JavaScriptCore/jit/ExecutableAllocatorFixedVMPool.cpp target
        in the general sources list as it is guarded by the ENABLE_EXECUTABLE_ALLOCATOR_FIXED
        feature define. This define is only used on 64-bit architecture and indirectly depends
        on enabling either JIT or YARR JIT feature. Both of these defines are disabled on
        Windows OS when using 64-bit architecture so there's no need to add this target to
        sources only when the target OS is Windows.

        * GNUmakefile.list.am:

2013-01-11  Filip Pizlo  <fpizlo@apple.com>

        DFG should not forget that it had proved something to be a constant during a merge just because it's merging against the empty value
        https://bugs.webkit.org/show_bug.cgi?id=106727

        Reviewed by Oliver Hunt.
        
        The problem was this statement:
        
        if (m_value != other.m_value)
            m_value = JSValue();
        
        This is well-intentioned, in the sense that if we want our abstract value (i.e. this) to become the superset of the other
        abstract value, and the two abstract values have proven different constants, then our abstract value should rescind its
        claim that it has been proven to be constant. But this misses the special case that if the other abstract value is
        completely clear (meaning that it wishes to contribute zero information and so the superset operation shouldn't change
        this), it will have a clear m_value. So, the code prior to this patch would rescind the constant proof even though it
        didn't have to.
        
        This comes up rarely and I don't believe it will be a performance win, but it is good to have the CFA been consistently
        precise as often as possible.

        * dfg/DFGAbstractValue.h:
        (JSC::DFG::AbstractValue::merge):

2013-01-11  Filip Pizlo  <fpizlo@apple.com>

        Python implementation reports "MemoryError" instead of doing things
        https://bugs.webkit.org/show_bug.cgi?id=106690

        Reviewed by Oliver Hunt.
        
        The bug was that the CFA was assuming that a variable is dead at the end of a basic block and hence doesn't need to
        be merged to the next block if the last mention of the variable was dead. This is almost correct, except that it
        doesn't work if the last mention is a GetLocal - the GetLocal itself may be dead, but that doesn't mean that the
        variable is dead - it may still be live. The appropriate thing to do is to look at the GetLocal's Phi. If the
        variable is used in the next block then the next block will have a reference to the last mention in our block unless
        that last mention is a GetLocal, in which case it will link to the Phi. Doing it this way captures everything that
        the CFA wants: if the last use is a live GetLocal then the CFA needs to consider the GetLocal itself for possible
        refinements to the proof of the value in the variable, but if the GetLocal is dead, then this must mean that the
        variable is not mentioned in the block but may still be "passed through" it, which is what the Phi will tell us.
        Note that it is not possible for the GetLocal to refer to anything other than a Phi, and it is also not possible
        for the last mention of a variable to be a dead GetLocal while there are other mentions that aren't dead - if
        there had been SetLocals or GetLocals prior to the dead one then the dead one wouldn't have been emitted by the
        parser.
        
        This also fixes a similar bug in the handling of captured variables. If a variable is captured, then it doesn't
        matter if the last mention is dead, or not. Either way, we already know that a captured variable will be live in
        the next block, so we must merge it no matter what.
        
        Finally, this change makes the output of Operands dumping a bit more verbose: it now prints the variable name next
        to each variable's dump. I've often found the lack of this information confusing particularly for operand dumps
        that involve a lot of variables.

        * bytecode/Operands.h:
        (JSC::dumpOperands):
        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::mergeStateAtTail):

2013-01-14  Roger Fong  <roger_fong@apple.com>

        Unreviewed. Fix vcproj file. Missing file tag after http://trac.webkit.org/changeset/139541.

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:

2013-01-13  Filip Pizlo  <fpizlo@apple.com>

        DFG phases that store per-node information should store it in Node itself rather than using a secondary vector
        https://bugs.webkit.org/show_bug.cgi?id=106753

        Reviewed by Geoffrey Garen.

        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::AbstractState):
        (JSC::DFG::AbstractState::beginBasicBlock):
        (JSC::DFG::AbstractState::dump):
        * dfg/DFGAbstractState.h:
        (JSC::DFG::AbstractState::forNode):
        (AbstractState):
        * dfg/DFGCFGSimplificationPhase.cpp:
        * dfg/DFGCSEPhase.cpp:
        (JSC::DFG::CSEPhase::CSEPhase):
        (JSC::DFG::CSEPhase::performSubstitution):
        (JSC::DFG::CSEPhase::setReplacement):
        (CSEPhase):
        * dfg/DFGNode.h:
        (Node):

2013-01-12  Tim Horton  <timothy_horton@apple.com>

        Unreviewed build fix.

        * API/JSBlockAdaptor.mm:
        * API/JSContext.mm:
        * API/JSValue.mm:

2013-01-12  Csaba Osztrogonác  <ossy@webkit.org>

        Unreviewed 64 bit buildfix after r139496.

        * dfg/DFGOperations.cpp:

2013-01-11  Filip Pizlo  <fpizlo@apple.com>

        Unreviewed, speculative build fix.

        * API/JSWrapperMap.mm:

2013-01-10  Filip Pizlo  <fpizlo@apple.com>

        JITThunks should not compile only because of luck
        https://bugs.webkit.org/show_bug.cgi?id=105696

        Rubber stamped by Sam Weinig and Geoffrey Garen.
        
        This patch was supposed to just move JITThunks into its own file. But then I
        realized that there is a horrible circular dependency chain between JSCell,
        JSGlobalData, CallFrame, and Weak, which only works because of magical include
        order in JITStubs.h, and the fact that JSGlobalData.h includes JITStubs.h
        before it includes JSCell or JSValue.
        
        I first tried to just get JITThunks.h to just magically do the same pointless
        includes that JITStubs.h had, but then I decided to actually fix the underflying
        problem, which was that JSCell needed CallFrame, CallFrame needed JSGlobalData,
        JSGlobalData needed JITThunks, JITThunks needed Weak, and Weak needed JSCell.
        Now, all of JSCell's outgoing dependencies are placed in JSCellInlines.h. This
        also gave me an opportunity to move JSValue inline methods from JSCell.h into
        JSValueInlines.h. But to make this really work, I needed to remove includes of
        *Inlines.h from other headers (CodeBlock.h for example included JSValueInlines.h,
        which defeats the whole entire purpose of having an Inlines.h file), and I needed
        to add includes of *Inlines.h into a bunch of .cpp files. I did this mostly by
        having .cpp files include Operations.h. In future, if you're adding a .cpp file
        to JSC, you'll almost certainly have to include Operations.h unless you enjoy
        link errors.

        * API/JSBase.cpp:
        * API/JSCallbackConstructor.cpp:
        * API/JSCallbackFunction.cpp:
        * API/JSCallbackObject.cpp:
        * API/JSClassRef.cpp:
        * API/JSContextRef.cpp:
        * API/JSObjectRef.cpp:
        * API/JSScriptRef.cpp:
        * API/JSWeakObjectMapRefPrivate.cpp:
        * JSCTypedArrayStubs.h:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.xcodeproj/project.pbxproj:
        * bytecode/ArrayAllocationProfile.cpp:
        * bytecode/CodeBlock.cpp:
        * bytecode/GetByIdStatus.cpp:
        * bytecode/LazyOperandValueProfile.cpp:
        * bytecode/ResolveGlobalStatus.cpp:
        * bytecode/SpeculatedType.cpp:
        * bytecode/UnlinkedCodeBlock.cpp:
        * bytecompiler/BytecodeGenerator.cpp:
        * debugger/Debugger.cpp:
        * debugger/DebuggerActivation.cpp:
        * debugger/DebuggerCallFrame.cpp:
        * dfg/DFGArgumentsSimplificationPhase.cpp:
        * dfg/DFGArrayMode.cpp:
        * dfg/DFGByteCodeParser.cpp:
        * dfg/DFGConstantFoldingPhase.cpp:
        * dfg/DFGDriver.cpp:
        * dfg/DFGFixupPhase.cpp:
        * dfg/DFGGraph.cpp:
        * dfg/DFGJITCompiler.cpp:
        * dfg/DFGOSREntry.cpp:
        * dfg/DFGOSRExitCompiler.cpp:
        * dfg/DFGOSRExitCompiler32_64.cpp:
        * dfg/DFGOSRExitCompiler64.cpp:
        * dfg/DFGPredictionPropagationPhase.cpp:
        * dfg/DFGSpeculativeJIT.cpp:
        (JSC::DFG::SpeculativeJIT::silentSavePlanForGPR):
        (DFG):
        (JSC::DFG::SpeculativeJIT::silentSavePlanForFPR):
        (JSC::DFG::SpeculativeJIT::silentSpill):
        (JSC::DFG::SpeculativeJIT::silentFill):
        * dfg/DFGSpeculativeJIT.h:
        (SpeculativeJIT):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        * dfg/DFGSpeculativeJIT64.cpp:
        * dfg/DFGStructureCheckHoistingPhase.cpp:
        * dfg/DFGVariableEventStream.cpp:
        * heap/CopiedBlock.h:
        * heap/CopiedSpace.cpp:
        * heap/HandleSet.cpp:
        * heap/Heap.cpp:
        * heap/HeapStatistics.cpp:
        * heap/SlotVisitor.cpp:
        * heap/WeakBlock.cpp:
        * interpreter/CallFrame.cpp:
        * interpreter/CallFrame.h:
        * jit/ClosureCallStubRoutine.cpp:
        * jit/GCAwareJITStubRoutine.cpp:
        * jit/JIT.cpp:
        * jit/JITArithmetic.cpp:
        * jit/JITArithmetic32_64.cpp:
        * jit/JITCall.cpp:
        * jit/JITCall32_64.cpp:
        * jit/JITCode.h:
        * jit/JITExceptions.cpp:
        * jit/JITStubs.h:
        * jit/JITThunks.h:
        * jsc.cpp:
        * llint/LLIntExceptions.cpp:
        * profiler/LegacyProfiler.cpp:
        * profiler/ProfileGenerator.cpp:
        * profiler/ProfilerBytecode.cpp:
        * profiler/ProfilerBytecodeSequence.cpp:
        * profiler/ProfilerBytecodes.cpp:
        * profiler/ProfilerCompilation.cpp:
        * profiler/ProfilerCompiledBytecode.cpp:
        * profiler/ProfilerDatabase.cpp:
        * profiler/ProfilerOSRExit.cpp:
        * profiler/ProfilerOSRExitSite.cpp:
        * profiler/ProfilerOrigin.cpp:
        * profiler/ProfilerOriginStack.cpp:
        * profiler/ProfilerProfiledBytecodes.cpp:
        * runtime/ArgList.cpp:
        * runtime/Arguments.cpp:
        * runtime/ArrayConstructor.cpp:
        * runtime/BooleanConstructor.cpp:
        * runtime/BooleanObject.cpp:
        * runtime/BooleanPrototype.cpp:
        * runtime/CallData.cpp:
        * runtime/CodeCache.cpp:
        * runtime/Completion.cpp:
        * runtime/ConstructData.cpp:
        * runtime/DateConstructor.cpp:
        * runtime/DateInstance.cpp:
        * runtime/DatePrototype.cpp:
        * runtime/Error.cpp:
        * runtime/ErrorConstructor.cpp:
        * runtime/ErrorInstance.cpp:
        * runtime/ErrorPrototype.cpp:
        * runtime/ExceptionHelpers.cpp:
        * runtime/Executable.cpp:
        * runtime/FunctionConstructor.cpp:
        * runtime/FunctionPrototype.cpp:
        * runtime/GetterSetter.cpp:
        * runtime/Identifier.cpp:
        * runtime/InternalFunction.cpp:
        * runtime/JSActivation.cpp:
        * runtime/JSBoundFunction.cpp:
        * runtime/JSCell.cpp:
        * runtime/JSCell.h:
        (JSC):
        * runtime/JSCellInlines.h: Added.
        (JSC):
        (JSC::JSCell::JSCell):
        (JSC::JSCell::finishCreation):
        (JSC::JSCell::structure):
        (JSC::JSCell::visitChildren):
        (JSC::allocateCell):
        (JSC::isZapped):
        (JSC::JSCell::isObject):
        (JSC::JSCell::isString):
        (JSC::JSCell::isGetterSetter):
        (JSC::JSCell::isProxy):
        (JSC::JSCell::isAPIValueWrapper):
        (JSC::JSCell::setStructure):
        (JSC::JSCell::methodTable):
        (JSC::JSCell::inherits):
        (JSC::JSCell::fastGetOwnPropertySlot):
        (JSC::JSCell::fastGetOwnProperty):
        (JSC::JSCell::toBoolean):
        * runtime/JSDateMath.cpp:
        * runtime/JSFunction.cpp:
        * runtime/JSFunction.h:
        (JSC):
        * runtime/JSGlobalData.h:
        (JSC):
        (JSGlobalData):
        * runtime/JSGlobalObject.cpp:
        * runtime/JSGlobalObjectFunctions.cpp:
        * runtime/JSLock.cpp:
        * runtime/JSNameScope.cpp:
        * runtime/JSNotAnObject.cpp:
        * runtime/JSONObject.cpp:
        * runtime/JSObject.h:
        (JSC):
        * runtime/JSProxy.cpp:
        * runtime/JSScope.cpp:
        * runtime/JSSegmentedVariableObject.cpp:
        * runtime/JSString.h:
        (JSC):
        * runtime/JSStringJoiner.cpp:
        * runtime/JSSymbolTableObject.cpp:
        * runtime/JSValue.cpp:
        * runtime/JSValueInlines.h:
        (JSC::JSValue::toInt32):
        (JSC::JSValue::toUInt32):
        (JSC):
        (JSC::JSValue::isUInt32):
        (JSC::JSValue::asUInt32):
        (JSC::JSValue::asNumber):
        (JSC::jsNaN):
        (JSC::JSValue::JSValue):
        (JSC::JSValue::encode):
        (JSC::JSValue::decode):
        (JSC::JSValue::operator bool):
        (JSC::JSValue::operator==):
        (JSC::JSValue::operator!=):
        (JSC::JSValue::isEmpty):
        (JSC::JSValue::isUndefined):
        (JSC::JSValue::isNull):
        (JSC::JSValue::isUndefinedOrNull):
        (JSC::JSValue::isCell):
        (JSC::JSValue::isInt32):
        (JSC::JSValue::isDouble):
        (JSC::JSValue::isTrue):
        (JSC::JSValue::isFalse):
        (JSC::JSValue::tag):
        (JSC::JSValue::payload):
        (JSC::JSValue::asInt32):
        (JSC::JSValue::asDouble):
        (JSC::JSValue::asCell):
        (JSC::JSValue::isNumber):
        (JSC::JSValue::isBoolean):
        (JSC::JSValue::asBoolean):
        (JSC::reinterpretDoubleToInt64):
        (JSC::reinterpretInt64ToDouble):
        (JSC::JSValue::isString):
        (JSC::JSValue::isPrimitive):
        (JSC::JSValue::isGetterSetter):
        (JSC::JSValue::isObject):
        (JSC::JSValue::getString):
        (JSC::::getString):
        (JSC::JSValue::getObject):
        (JSC::JSValue::getUInt32):
        (JSC::JSValue::toPrimitive):
        (JSC::JSValue::getPrimitiveNumber):
        (JSC::JSValue::toNumber):
        (JSC::JSValue::toObject):
        (JSC::JSValue::isFunction):
        (JSC::JSValue::inherits):
        (JSC::JSValue::toThisObject):
        (JSC::JSValue::get):
        (JSC::JSValue::put):
        (JSC::JSValue::putByIndex):
        (JSC::JSValue::structureOrUndefined):
        (JSC::JSValue::equal):
        (JSC::JSValue::equalSlowCaseInline):
        (JSC::JSValue::strictEqualSlowCaseInline):
        (JSC::JSValue::strictEqual):
        * runtime/JSVariableObject.cpp:
        * runtime/JSWithScope.cpp:
        * runtime/JSWrapperObject.cpp:
        * runtime/LiteralParser.cpp:
        * runtime/Lookup.cpp:
        * runtime/NameConstructor.cpp:
        * runtime/NameInstance.cpp:
        * runtime/NamePrototype.cpp:
        * runtime/NativeErrorConstructor.cpp:
        * runtime/NativeErrorPrototype.cpp:
        * runtime/NumberConstructor.cpp:
        * runtime/NumberObject.cpp:
        * runtime/ObjectConstructor.cpp:
        * runtime/ObjectPrototype.cpp:
        * runtime/Operations.h:
        (JSC):
        * runtime/PropertySlot.cpp:
        * runtime/RegExp.cpp:
        * runtime/RegExpCache.cpp:
        * runtime/RegExpCachedResult.cpp:
        * runtime/RegExpConstructor.cpp:
        * runtime/RegExpMatchesArray.cpp:
        * runtime/RegExpObject.cpp:
        * runtime/RegExpPrototype.cpp:
        * runtime/SmallStrings.cpp:
        * runtime/SparseArrayValueMap.cpp:
        * runtime/StrictEvalActivation.cpp:
        * runtime/StringConstructor.cpp:
        * runtime/StringObject.cpp:
        * runtime/StringRecursionChecker.cpp:
        * runtime/Structure.h:
        (JSC):
        * runtime/StructureChain.cpp:
        * runtime/TimeoutChecker.cpp:
        * testRegExp.cpp:

2013-01-11  Filip Pizlo  <fpizlo@apple.com>

        If you use Phantom to force something to be live across an OSR exit, you should put it after the OSR exit
        https://bugs.webkit.org/show_bug.cgi?id=106724

        Reviewed by Oliver Hunt.
        
        In cases where we were getting it wrong, I think it was benign because we would either already have an
        OSR exit prior to there, or the operand would be a constant.  But still, it's good to get this right.

        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::parseBlock):

2013-01-11  Filip Pizlo  <fpizlo@apple.com>

        Phantom(GetLocal) should be treated as relevant to OSR
        https://bugs.webkit.org/show_bug.cgi?id=106715

        Reviewed by Mark Hahnenberg.

        * dfg/DFGCSEPhase.cpp:
        (JSC::DFG::CSEPhase::performBlockCSE):

2013-01-11  Pratik Solanki  <psolanki@apple.com>

        Fix function name typo ProgramExecutable::initalizeGlobalProperties()
        https://bugs.webkit.org/show_bug.cgi?id=106701

        Reviewed by Geoffrey Garen.

        * interpreter/Interpreter.cpp:
        (JSC::Interpreter::execute):
        * runtime/Executable.cpp:
        (JSC::ProgramExecutable::initializeGlobalProperties):
        * runtime/Executable.h:

2013-01-11  Mark Hahnenberg  <mhahnenberg@apple.com>

        testapi is failing with a block-related error in the Objc API
        https://bugs.webkit.org/show_bug.cgi?id=106055

        Reviewed by Filip Pizlo.

        Same bug as in testapi.mm. We need to actually call the static block, rather than casting the block to a bool.

        * API/ObjCCallbackFunction.mm:
        (blockSignatureContainsClass):

2013-01-11  Filip Pizlo  <fpizlo@apple.com>

        Add a run-time option to print bytecode at DFG compile time
        https://bugs.webkit.org/show_bug.cgi?id=106704

        Reviewed by Mark Hahnenberg.

        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::parseCodeBlock):
        * runtime/Options.h:
        (JSC):

2013-01-11  Filip Pizlo  <fpizlo@apple.com>

        It should be possible to enable verbose printing of each OSR exit at run-time (rather than compile-time) and it should print register state
        https://bugs.webkit.org/show_bug.cgi?id=106700

        Reviewed by Mark Hahnenberg.

        * dfg/DFGAssemblyHelpers.h:
        (DFG):
        (JSC::DFG::AssemblyHelpers::debugCall):
        * dfg/DFGCommon.h:
        * dfg/DFGOSRExit.h:
        (DFG):
        * dfg/DFGOSRExitCompiler32_64.cpp:
        (JSC::DFG::OSRExitCompiler::compileExit):
        * dfg/DFGOSRExitCompiler64.cpp:
        (JSC::DFG::OSRExitCompiler::compileExit):
        * dfg/DFGOperations.cpp:
        * dfg/DFGOperations.h:
        * runtime/Options.h:
        (JSC):

2013-01-11  Geoffrey Garen  <ggaren@apple.com>

        Removed getDirectLocation and offsetForLocation and all their uses
        https://bugs.webkit.org/show_bug.cgi?id=106692

        Reviewed by Filip Pizlo.

        getDirectLocation() and its associated offsetForLocation() relied on
        detailed knowledge of the rules of PropertyOffset, JSObject, and
        Structure, which is a hard thing to reverse-engineer reliably. Luckily,
        it wasn't needed, and all clients either wanted a true value or a
        PropertyOffset. So, I refactored accordingly.

        * dfg/DFGOperations.cpp: Renamed putDirectOffset to putDirect, to clarify
        that we are not putting an offset.

        * runtime/JSActivation.cpp:
        (JSC::JSActivation::getOwnPropertySlot): Get a value instead of a value
        pointer, since we never wanted a pointer to begin with.

        * runtime/JSFunction.cpp:
        (JSC::JSFunction::getOwnPropertySlot): Use a PropertyOffset instead of a pointer,
        so we don't have to reverse-engineer the offset from the pointer.

        * runtime/JSObject.cpp:
        (JSC::JSObject::put):
        (JSC::JSObject::resetInheritorID):
        (JSC::JSObject::inheritorID):
        (JSC::JSObject::removeDirect):
        (JSC::JSObject::fillGetterPropertySlot):
        (JSC::JSObject::getOwnPropertyDescriptor): Renamed getDirectOffset and
        putDirectOffset, as explaind above. We want to use the name "getDirectOffset"
        for when the thing you're getting is the offset.

        * runtime/JSObject.h:
        (JSC::JSObject::getDirect):
        (JSC::JSObject::getDirectOffset): Changed getDirectLocation to getDirectOffset,
        since clients really wants PropertyOffsets and not locations.

        (JSObject::offsetForLocation): Removed this function because it was hard
        to get right.

        (JSC::JSObject::putDirect):
        (JSC::JSObject::putDirectUndefined):
        (JSC::JSObject::inlineGetOwnPropertySlot):
        (JSC::JSObject::putDirectInternal):
        (JSC::JSObject::putDirectWithoutTransition):
        * runtime/JSScope.cpp:
        (JSC::executeResolveOperations):
        (JSC::JSScope::resolvePut):
        * runtime/JSValue.cpp:
        (JSC::JSValue::putToPrimitive): Updated for renames.

        * runtime/Lookup.cpp:
        (JSC::setUpStaticFunctionSlot): Use a PropertyOffset instead of a pointer,
        so we don't have to reverse-engineer the offset from the pointer.

        * runtime/Structure.cpp:
        (JSC::Structure::flattenDictionaryStructure): Updated for renames.

2013-01-11  Geoffrey Garen  <ggaren@apple.com>

        Removed an unused version of getDirectLocation
        https://bugs.webkit.org/show_bug.cgi?id=106691

        Reviewed by Gavin Barraclough.

        getDirectLocation is a weird operation. Removing the unused version is
        the easy part.

        * runtime/JSObject.h:
        (JSObject):

2013-01-11  Mark Hahnenberg  <mhahnenberg@apple.com>

        Objective-C objects that are passed to JavaScript leak (until the JSContext is destroyed)
        https://bugs.webkit.org/show_bug.cgi?id=106056

        Reviewed by Darin Adler.

        * API/APIJSValue.h:
        * API/JSValue.mm: Make the reference to the JSContext strong.
        (-[JSValue context]):
        (-[JSValue initWithValue:inContext:]):
        (-[JSValue dealloc]):
        * API/JSWrapperMap.mm: Make the reference back from wrappers to Obj-C objects weak instead of strong.
        Also add an explicit WeakGCMap in the JSWrapperMap rather than using Obj-C associated object API which 
        was causing memory leaks.
        (wrapperClass):
        (-[JSObjCClassInfo wrapperForObject:]):
        (-[JSWrapperMap initWithContext:]):
        (-[JSWrapperMap dealloc]):
        (-[JSWrapperMap wrapperForObject:]):

2013-01-11  Geoffrey Garen  <ggaren@apple.com>

        Fixed some bogus PropertyOffset ASSERTs
        https://bugs.webkit.org/show_bug.cgi?id=106686

        Reviewed by Gavin Barraclough.

        The ASSERTs were passing a JSType instead of an inlineCapacity, due to
        an incomplete refactoring.

        The compiler didn't catch this because both types are int underneath.

        * runtime/JSObject.h:
        (JSC::JSObject::getDirect):
        (JSC::JSObject::getDirectLocation):
        (JSC::JSObject::offsetForLocation):
        * runtime/Structure.cpp:
        (JSC::Structure::addPropertyTransitionToExistingStructure): Validate against
        our inline capacity, as we intended.

2013-01-11  Geoffrey Garen  <ggaren@apple.com>

        Rename propertyOffsetFor => offsetForPropertyNumber
        https://bugs.webkit.org/show_bug.cgi?id=106685

        Reviewed by Gavin Barraclough.

        Since the argument is just a typedef and not an object, I wanted to clarify the meaning.

        * runtime/PropertyMapHashTable.h:
        (JSC::PropertyTable::nextOffset): Updated for rename.

        * runtime/PropertyOffset.h:
        (JSC::offsetForPropertyNumber): Renamed. Also changed some PropertyOffset variables
        to plain ints, because they're not actually on the PropertyOffsets number line.

        * runtime/Structure.cpp:
        (JSC::Structure::flattenDictionaryStructure):
        * runtime/Structure.h:
        (JSC::Structure::lastValidOffset): Updated for rename.

2013-01-10  Zan Dobersek  <zandobersek@gmail.com>

        Remove the ENABLE_ANIMATION_API feature define occurences
        https://bugs.webkit.org/show_bug.cgi?id=106544

        Reviewed by Simon Fraser.

        The Animation API code was removed in r137243. The ENABLE_ANIMATION_API
        feature define handling still lingers in various build systems and configurations
        but is of no use, so it should be removed.

        * Configurations/FeatureDefines.xcconfig:

2013-01-09  Roger Fong  <roger_fong@apple.com>

        Unreviewed. Just move the JavaScriptCore exports file around in the vcproj to make things clearer.

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:

2013-01-09  Filip Pizlo  <fpizlo@apple.com>

        Dont use a node reference after appending to the graph.
        https://bugs.webkit.org/show_bug.cgi?id=103305
        <rdar://problem/12753096>

        Reviewed by Mark Hahnenberg.

        * dfg/DFGArgumentsSimplificationPhase.cpp:
        (JSC::DFG::ArgumentsSimplificationPhase::run):

2013-01-09  Roger Fong  <roger_fong@apple.com>

        Rename export files to make them more easily findable.
        https://bugs.webkit.org/show_bug.cgi?id=98695.

        Reviewed by Timothy Horton.

        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.def: Removed.
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.vcproj:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCoreCommon.vsprops:
        * JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCoreExports.def: Copied from Source/JavaScriptCore/JavaScriptCore.vcproj/JavaScriptCore/JavaScriptCore.def.

2013-01-09  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix make distcheck.

        * GNUmakefile.list.am: Add mips.rb to offlineasm_nosources.

2013-01-08  Oliver Hunt  <oliver@apple.com>

        Support op_typeof in the DFG
        https://bugs.webkit.org/show_bug.cgi?id=98898

        Reviewed by Filip Pizlo.

        Adds a TypeOf node to the DFG to support op_typeof.

        To avoid adding too much GC horror, this also makes the
        common strings portion of the SmallString cache strongly
        referenced.

        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::execute):
          We try to determine the result early here, and substitute in a constant.
          Otherwise we leave the node intact, and set the result type to SpecString.
        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::parseBlock):
          Parse op_typeof
        * dfg/DFGCSEPhase.cpp:
        (JSC::DFG::CSEPhase::performNodeCSE):
          TypeOf nodes can be subjected to pure CSE
        * dfg/DFGCapabilities.h:
        (JSC::DFG::canCompileOpcode):
          We can handle typeof.
        * dfg/DFGNodeType.h:
        (DFG):
          Define the node.
        * dfg/DFGOperations.cpp:
        * dfg/DFGOperations.h:
          Add operationTypeOf to support the non-trivial cases.
        * dfg/DFGPredictionPropagationPhase.cpp:
        (JSC::DFG::PredictionPropagationPhase::propagate):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):
          Actual codegen
        * runtime/Operations.cpp:
        (JSC::jsTypeStringForValue):
        (JSC):
        * runtime/Operations.h:
        (JSC):
          Some refactoring to allow us to get the type string for an
          object without needing a callframe.


2013-01-08  Filip Pizlo  <fpizlo@apple.com>

        DFG shouldn't treat the 'this' argument as being captured if a code block uses arguments
        https://bugs.webkit.org/show_bug.cgi?id=106398
        <rdar://problem/12439776>

        Reviewed by Mark Hahnenberg.
        
        This is a possible optimization for inlined calls, and fixes crashes for inlined constructors, in the case
        that the inlined code used arguments. The problem was that assuming that 'this' was captured implies the
        assumption that it was initialized by the caller, which is wrong for constructors and this.
        
        Also added a pretty essential DFG IR validation rule: we shouldn't have any live locals at the top of the
        root block. This helps to catch this bug: our assumption that 'this' was captured in an inlined constructor
        that used arguments led to liveness for the temporary that would have held 'this' in the caller being
        propagated all the way up to the entrypoint of the function.

        * bytecode/CodeBlock.h:
        (JSC::CodeBlock::isCaptured):
        * dfg/DFGValidate.cpp:
        (JSC::DFG::Validate::validate):
        (JSC::DFG::Validate::reportValidationContext):
        (Validate):
        (JSC::DFG::Validate::dumpGraphIfAppropriate):

2013-01-08  Filip Pizlo  <fpizlo@apple.com>

        REGRESSION (r138921): Crash in JSC::Arguments::create
        https://bugs.webkit.org/show_bug.cgi?id=106329
        <rdar://problem/12974196>

        Reviewed by Mark Hahnenberg.
        
        Arguments::finishCreation() that takes an InlineCallFrame* needs to understand that the callee can
        be unset, indicating that the callee needs to be loaded from the true call frame. This adds a
        method to InlineCallFrame to do just that.

        * bytecode/CodeOrigin.cpp:
        (JSC::InlineCallFrame::calleeForCallFrame):
        * bytecode/CodeOrigin.h:
        (InlineCallFrame):
        * runtime/Arguments.h:
        (JSC::Arguments::finishCreation):

2013-01-08  Filip Pizlo  <fpizlo@apple.com>

        DFG initrinsic handling should ensure that we backwards propagate the fact that all operands may escape
        https://bugs.webkit.org/show_bug.cgi?id=106365

        Reviewed by Mark Hahnenberg.
        
        Use the fact that Phantom means that things escaped, and just insert Phantoms for all
        of the operands.

        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::handleCall):

2013-01-08  Filip Pizlo  <fpizlo@apple.com>

        If array allocation profiling causes a new_array to allocate double arrays, then the holes should end up being correctly initialized
        https://bugs.webkit.org/show_bug.cgi?id=106363

        Reviewed by Mark Hahnenberg.

        * runtime/JSArray.h:
        (JSC::JSArray::tryCreateUninitialized):

2013-01-07  Filip Pizlo  <fpizlo@apple.com>

        DFG should backwards-propagate NodeUsedAsValue for Phantom
        https://bugs.webkit.org/show_bug.cgi?id=106299

        Reviewed by Mark Hahnenberg.
        
        This is currently benign because Phantom is only inserted by the bytecode parser for
        things that already happen to be used in contexts that backwards propagate
        NodeUsedAsValue. But that doesn't change the fact that the semantics of Phantom are
        that the value can be arbitrarily used by the baseline JIT.

        * dfg/DFGPredictionPropagationPhase.cpp:
        (JSC::DFG::PredictionPropagationPhase::propagate):

2013-01-07  Filip Pizlo  <fpizlo@apple.com>

        Rationalize closure call heuristics and profiling
        https://bugs.webkit.org/show_bug.cgi?id=106270

        Reviewed by Oliver Hunt.
        
        Did a number of things:
        
        - CallLinkInfo now remembers if it was ever a closure call, and CallLinkStatus uses
          this. Reduces the likelihood that we will inline a closure call as if it was a
          normal call.
        
        - Made InlineCallFrame print inferred function names, and refactored
          CodeBlock::inferredName() to better use FunctionExecutable's API.
        
        - Made bytecode dumping print frequent exit sites that led to recompilation.
        
        - Made bytecode dumping for op_call and op_construct print what the CallLinkStatus
          saw.
        
        * bytecode/CallLinkInfo.h:
        (JSC::CallLinkInfo::CallLinkInfo):
        (CallLinkInfo):
        * bytecode/CallLinkStatus.cpp:
        (JSC::CallLinkStatus::computeFor):
        * bytecode/CodeBlock.cpp:
        (JSC::CodeBlock::inferredName):
        (JSC::CodeBlock::dumpBytecodeCommentAndNewLine):
        (JSC::CodeBlock::printCallOp):
        * bytecode/CodeOrigin.cpp:
        (JSC::CodeOrigin::dump):
        (JSC::InlineCallFrame::inferredName):
        (JSC):
        (JSC::InlineCallFrame::dumpBriefFunctionInformation):
        (JSC::InlineCallFrame::dump):
        * bytecode/CodeOrigin.h:
        (InlineCallFrame):
        * bytecode/DFGExitProfile.cpp:
        (JSC::DFG::ExitProfile::exitSitesFor):
        (DFG):
        * bytecode/DFGExitProfile.h:
        (ExitProfile):
        * jit/JITStubs.cpp:
        (JSC::DEFINE_STUB_FUNCTION):

2013-01-07  Ryosuke Niwa  <rniwa@webkit.org>

        Sorted the xcodeproj file.

        * JavaScriptCore.xcodeproj/project.pbxproj:

2013-01-07  Filip Pizlo  <fpizlo@apple.com>

        Unreviewed, it should be possible to build JSC on ARM.

        * API/JSBase.h:
        * jit/JITStubs.cpp:
        (JSC::performPlatformSpecificJITAssertions):
        (JSC):
        * jit/JITStubs.h:
        (JSC):
        * jit/JITThunks.cpp:
        (JSC::JITThunks::JITThunks):
        * jit/JITThunks.h:
        (JITThunks):
        * offlineasm/armv7.rb:
        * runtime/JSGlobalData.cpp:
        (JSC::JSGlobalData::JSGlobalData):

2013-01-07  Balazs Kilvady  <kilvadyb@homejinni.com>

        MIPS LLInt implementation.
        https://bugs.webkit.org/show_bug.cgi?id=99706

        Reviewed by Filip Pizlo.

        LLInt implementation for MIPS.

        * assembler/MacroAssemblerMIPS.h:
        (JSC::MacroAssemblerMIPS::jump):
        * dfg/DFGOperations.cpp:
        (JSC):
        * jit/JITStubs.cpp:
        (JSC):
        * jit/JITStubs.h:
        (JITStackFrame):
        * llint/LLIntOfflineAsmConfig.h:
        * llint/LowLevelInterpreter.asm:
        * llint/LowLevelInterpreter32_64.asm:
        * offlineasm/backends.rb:
        * offlineasm/instructions.rb:
        * offlineasm/mips.rb: Added.

2013-01-07  Mark Hahnenberg  <mhahnenberg@apple.com>

        testapi is failing with a block-related error in the Objc API
        https://bugs.webkit.org/show_bug.cgi?id=106055

        Reviewed by Geoffrey Garen.

        Casting a block to a bool will always return true, which isn't the behavior that is intended here.
        Instead we need to call the block, but C semantics don't allow this, so we need to change 
        testapi.m to be Objective-C++ and therefore testapi.mm.

        * API/tests/testapi.m: Removed.
        * API/tests/testapi.mm: Copied from Source/JavaScriptCore/API/tests/testapi.m.
        (blockSignatureContainsClass):
        * JavaScriptCore.xcodeproj/project.pbxproj:

2013-01-06  Filip Pizlo  <fpizlo@apple.com>

        Simplify slow case profiling
        https://bugs.webkit.org/show_bug.cgi?id=106208

        Reviewed by Mark Rowe.
        
        Removing the minimum execution ratio portion of slow case profiling, which allows
        the removal of a field from CodeBlock. This appears to be performance neutral,
        implying that the complexity incurred by the previous heuristic was purely
        harmful: it made the code more complicated, and it made CodeBlock larger, without
        resulting in any measurable benefits.

        * bytecode/CodeBlock.cpp:
        (JSC::CodeBlock::CodeBlock):
        * bytecode/CodeBlock.h:
        (JSC::CodeBlock::likelyToTakeSlowCase):
        (JSC::CodeBlock::couldTakeSlowCase):
        (JSC::CodeBlock::likelyToTakeSpecialFastCase):
        (JSC::CodeBlock::couldTakeSpecialFastCase):
        (JSC::CodeBlock::likelyToTakeDeepestSlowCase):
        (JSC::CodeBlock::likelyToTakeAnySlowCase):
        * jit/JIT.cpp:
        (JSC::JIT::privateCompile):
        * runtime/Options.h:

2013-01-05  Filip Pizlo  <fpizlo@apple.com>

        DFG should inline closure calls
        https://bugs.webkit.org/show_bug.cgi?id=106067

        Reviewed by Gavin Barraclough.
        
        This adds initial support for inlining closure calls to the DFG. A call is considered
        to be a closure call when the JSFunction* varies, but always has the same executable.
        We already have closure call inline caching in both JITs, which works by checking that
        the callee has an expected structure (as a cheap way of detecting that it is in fact
        a JSFunction) and an expected executable. Closure call inlining uses profiling data
        aggregated by CallLinkStatus to decide when to specialize the call to the particular
        structure/executable, and inline the call rather than emitting a call sequence. When
        we choose to do a closure inline rather than an ordinary inline, a number of things
        change about how inlining is performed:
        
        - The inline is guarded by a CheckStructure/CheckExecutable rather than a
          CheckFunction.
        
        - Instead of propagating a constant value for the scope, we emit GetMyScope every time
          that the scope is needed, which loads the scope from a local variable. We do similar
          things for the callee.
        
        - The prologue of the inlined code includes SetMyScope and SetCallee nodes to eagerly
          plant the scope and callee into the "true call frame", i.e. the place on the stack
          where the call frame would have been if the call had been actually performed. This
          allows GetMyScope/GetCallee to work as they would if the code wasn't inlined. It
          also allows for trivial handling of scope and callee for call frame reconstruction
          upon stack introspection and during OSR.
        
        - A new node called GetScope is introduced, which just gets the scope of a function.
          This node has the expected CSE support. This allows for the
          SetMyScope(GetScope(@function)) sequence to set up the scope in the true call frame.
        
        - GetMyScope/GetCallee CSE can match against SetMyScope/SetCallee, which means that
          the GetMyScope/GetCallee nodes emitted during parsing are often removed during CSE,
          if we can prove that it is safe to do so.
        
        - Inlining heuristics are adjusted to grok the cost of inlining a closure. We are
          less likely to inline a closure call than we are to inline a normal call, since we
          end up emitting more code for closures due to CheckStructure, CheckExecutable,
          GetScope, SetMyScope, and SetCallee.
        
        Additionally, I've fixed the VariableEventStream to ensure that we don't attempt to
        plant Undefined into the true call frames. This was previously a harmless oversight,
        but it becomes quite bad if OSR is relying on the scope/callee already having been
        set and not subsequently clobbered by the OSR itself.
        
        This is a ~60% speed-up on programs that frequently make calls to closures. It's
        neutral on V8v7 and other major benchmark suites.
        
        The lack of a definite speed-up is likely due the fact that closure inlining currently
        does not do any cardinality [1] optimizations. We don't observe when a closure was
        constructed within its caller, and so used the scope from its caller; and furthermore
        we have no facility to detect when the scope is single. All scoped variable accesses
        are assumed to be multiple instead. A subsequent step will be to ensure that closure
        call inlining will be single and loving it.
        
        [1] Single and loving it: Must-alias analysis for higher-order languages. Suresh
            Jagannathan, Peter Thiemann, Stephen Weeks, and Andrew Wright. In POPL '98.

        * bytecode/CallLinkStatus.cpp:
        (JSC::CallLinkStatus::dump):
        * bytecode/CallLinkStatus.h:
        (JSC::CallLinkStatus::isClosureCall):
        (CallLinkStatus):
        * bytecode/CodeBlock.cpp:
        (JSC::CodeBlock::globalObjectFor):
        (JSC):
        * bytecode/CodeBlock.h:
        (CodeBlock):
        * bytecode/CodeOrigin.cpp:
        (JSC::InlineCallFrame::dump):
        * dfg/DFGAbstractState.cpp:
        (JSC::DFG::AbstractState::execute):
        * dfg/DFGByteCodeParser.cpp:
        (ByteCodeParser):
        (JSC::DFG::ByteCodeParser::handleCall):
        (JSC::DFG::ByteCodeParser::emitFunctionChecks):
        (JSC::DFG::ByteCodeParser::handleInlining):
        * dfg/DFGCSEPhase.cpp:
        (JSC::DFG::CSEPhase::pureCSE):
        (CSEPhase):
        (JSC::DFG::CSEPhase::getCalleeLoadElimination):
        (JSC::DFG::CSEPhase::checkExecutableElimination):
        (JSC::DFG::CSEPhase::getMyScopeLoadElimination):
        (JSC::DFG::CSEPhase::performNodeCSE):
        * dfg/DFGCapabilities.cpp:
        (JSC::DFG::mightInlineFunctionForClosureCall):
        * dfg/DFGCapabilities.h:
        (DFG):
        (JSC::DFG::mightInlineFunctionForClosureCall):
        (JSC::DFG::canInlineFunctionForClosureCall):
        (JSC::DFG::canInlineFunctionFor):
        * dfg/DFGNode.h:
        (Node):
        (JSC::DFG::Node::hasExecutable):
        (JSC::DFG::Node::executable):
        * dfg/DFGNodeType.h:
        (DFG):
        * dfg/DFGPredictionPropagationPhase.cpp:
        (JSC::DFG::PredictionPropagationPhase::propagate):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGVariableEventStream.cpp:
        (JSC::DFG::VariableEventStream::reconstruct):
        * runtime/Options.h:
        (JSC):

2013-01-05  Filip Pizlo  <fpizlo@apple.com>

        Data flow paths that carry non-numbers, non-undefined, non-null values should not cause subtractions and arithmetic additions (i.e. ++) to speculate double
        https://bugs.webkit.org/show_bug.cgi?id=106190

        Reviewed by Sam Weinig.
        
        The problem is that the DFG logic for deciding when to speculate integer was
        confusing the special case of ValueAdd (where non-numeric values should cause us
        to not speculate integer, because we want to fall off into the generic case) with
        the more normal case of ArithAdd and ArithSub (where we want to speculate integer
        unless we have evidence that the operands are doubles, since the DFG doesn't have
        generic handling of non-numeric arithmetic). Prior to this change doing a - b where
        either a or b were possibly non-numeric would always force the subtraction to be
        done using doubles.

        * dfg/DFGGraph.h:
        (JSC::DFG::Graph::addSpeculationMode):
        (Graph):
        (JSC::DFG::Graph::valueAddSpeculationMode):
        (JSC::DFG::Graph::arithAddSpeculationMode):
        (JSC::DFG::Graph::addImmediateShouldSpeculateInteger):

2013-01-04  Filip Pizlo  <fpizlo@apple.com>

        DFG should trust array profiling over value profiling
        https://bugs.webkit.org/show_bug.cgi?id=106155

        Reviewed by Gavin Barraclough.
        
        The real problem is that prediction propagation is not flow-sensitive. We had code
        like:
        
        var a = (some load from memory); // returns either an array or false
        if (a)
            a[i] = v;
        
        Because 'a' could be 'false', we were emitting a fully generic unoptimized PutByVal.
        This patch changes ArrayMode to ignore the type of the base of an array access, if
        array profiling tells us that the array access can be optimized.
        
        In the future, we could probably make this work even better with some flow
        sensitivity in the prediction propagator, but I also tend to think that this is a
        more robust overall solution. If we ever did want to support array accesses on
        array-or-false then we should change the array profiler to be able to tell us that
        this is what is going on.
        
        3.7% speed-up on V8/earley.

        * dfg/DFGArrayMode.cpp:
        (JSC::DFG::ArrayMode::refine):

2013-01-04  Filip Pizlo  <fpizlo@apple.com>

        Rationalize exit site profiling for calls
        https://bugs.webkit.org/show_bug.cgi?id=106150

        Reviewed by Sam Weinig.
        
        This adds two new exit kinds for calls: BadFunction and BadExecutable. The latter is not used
        yet, but is already integrated with profiling. CheckFunction uses a BadFunction speculation
        instead of BadCache, now. This allows CallLinkStatus to turn itself into a closure call status
        if we had a BadFunction exit site but the CallLinkInfo told us to use a non-closure call. This
        might happen if we had call unlinking that led to information loss along the way.
        
        No performance impact. This is meant as another step towards inlining closure calls.

        * bytecode/CallLinkStatus.cpp:
        * bytecode/CallLinkStatus.h:
        (JSC::CallLinkStatus::setIsProved):
        (JSC::CallLinkStatus::setHasBadFunctionExitSite):
        (CallLinkStatus):
        (JSC::CallLinkStatus::setHasBadCacheExitSite):
        (JSC::CallLinkStatus::setHasBadExecutableExitSite):
        * bytecode/ExitKind.cpp:
        (JSC::exitKindToString):
        * bytecode/ExitKind.h:
        * dfg/DFGByteCodeParser.cpp:
        (JSC::DFG::ByteCodeParser::handleCall):
        * dfg/DFGSpeculativeJIT32_64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):
        * dfg/DFGSpeculativeJIT64.cpp:
        (JSC::DFG::SpeculativeJIT::compile):

2013-01-03  Filip Pizlo  <fpizlo@apple.com>

        DFG should not elide CheckStructure if it's needed to perform a cell check
        https://bugs.webkit.org/show_bug.cgi?id=106074

        Reviewed by Ryosuke Niwa.
        
        The problem here was that the constant folding phase was misinterpreting the meaning of the sets
        in DFG::AbstractValue.  AbstractValue describes a constraint on the values that a variable (i.e.
        a DFG Node, or a virtual register, i.e. local or argument) may have. It does so by containing
        four sets: the set of JSValues (either empty, the singleton set containing one JSValue, or the
        set of all JSValues); the set of "current known" structures, i.e. the set of structures that you
        already know that this value may have right now (also either empty, the singleton set, or the set
